;======================================================;
;                                                      ;
;       ntdll.inc for EC v2 Fasm classic projects      ;
;                   (version 1.0.2)                    ;
;                                                      ;
;          Copyright  Ramon Sala - 2020-2022          ;
;                                                      ;
;======================================================;

if ~defined NTDLL_INC
define NTDLL_INC    1

if ~defined KERNEL32_INC
    include 'kernel32.inc'
end if

MAXIMUM_FILENAME_LENGTH                         equ     256
PORT_MAXIMUM_MESSAGE_LENGTH                     equ     256
INITIAL_PRIVILEGE_COUNT                         equ     3

FSCTL_GET_VOLUME_INFORMATION                    equ     90064H

DOS_PATHTYPE_UNC                                equ     00000001H
DOS_PATHTYPE_ROOTDRIVE                          equ     00000002H
DOS_PATHTYPE_STREAM                             equ     00000003H
DOS_PATHTYPE_NT                                 equ     00000004H
DOS_PATHTYPE_NAME                               equ     00000005H
DOS_PATHTYPE_DEVICE                             equ     00000006H
DOS_PATHTYPE_LOCALUNCROOT                       equ     00000007H

FILE_REMOVABLE_MEDIA                            equ     00000001H
FILE_READ_ONLY_DEVICE                           equ     00000002H
FILE_FLOPPY_DISKETTE                            equ     00000004H
FILE_WRITE_ONCE_MEDIA                           equ     00000008H
FILE_REMOTE_DEVICE                              equ     00000010H
FILE_DEVICE_IS_MOUNTED                          equ     00000020H
FILE_VIRTUAL_VOLUME                             equ     00000040H
FILE_AUTOGENERATED_DEVICE_NAME                  equ     00000080H
FILE_DEVICE_SECURE_OPEN                         equ     00000100H

FILE_SUPERSEDE                                  equ     00000000H
FILE_OPEN                                       equ     00000001H
FILE_CREATE                                     equ     00000002H
FILE_OPEN_IF                                    equ     00000003H
FILE_OVERWRITE                                  equ     00000004H
FILE_OVERWRITE_IF                               equ     00000005H
FILE_MAXIMUM_DISPOSITION                        equ     00000005H

FILE_DIRECTORY_FILE                             equ     00000001H
FILE_WRITE_THROUGH                              equ     00000002H
FILE_SequENTIAL_ONLY                            equ     00000004H
FILE_NO_INTERMEDIATE_BUFFERING                  equ     00000008H

FILE_SYNCHRONOUS_IO_ALERT                       equ     00000010H
FILE_SYNCHRONOUS_IO_NONALERT                    equ     00000020H
FILE_NON_DIRECTORY_FILE                         equ     00000040H
FILE_CREATE_TREE_CONNECTION                     equ     00000080H

FILE_COMPLETE_IF_OPLOCKED                       equ     00000100H
FILE_NO_EA_KNOWLEDGE                            equ     00000200H
FILE_OPEN_FOR_RECOVERY                          equ     00000400H
FILE_RANDOM_ACCESS                              equ     00000800H

FILE_DELETE_ON_CLOSE                            equ     00001000H
FILE_OPEN_BY_FILE_ID                            equ     00002000H
FILE_OPEN_FOR_BACKUP_INTENT                     equ     00004000H
FILE_NO_COMPRESSION                             equ     00008000H

FILE_RESERVE_OPFILTER                           equ     00100000H
FILE_OPEN_REPARSE_POINT                         equ     00200000H
FILE_OPEN_NO_RECALL                             equ     00400000H
FILE_OPEN_FOR_FREE_SPACE_QUERY                  equ     00800000H

FILE_COPY_STRUCTURED_STORAGE                    equ     00000041H
FILE_STRUCTURED_STORAGE                         equ     00000441H

FILE_VALID_OPTION_FLAGS                         equ     00FFFFFFH
FILE_VALID_PIPE_OPTION_FLAGS                    equ     00000032H
FILE_VALID_MAILSLOT_OPTION_FLAGS                equ     00000032H
FILE_VALID_SET_FLAGS                            equ     00000036H

THREAD_STATE_INITIALIZED                        equ     0
THREAD_STATE_READY                              equ     1
THREAD_STATE_RUNNING                            equ     2
THREAD_STATE_STANDBY                            equ     3
THREAD_STATE_TERMINATED                         equ     4
THREAD_STATE_WAIT                               equ     5
THREAD_STATE_TRANSITION                         equ     6
THREAD_STATE_UNKNOWN                            equ     7

OB_TYPE_TYPE                                    equ     1
OB_TYPE_DIRECTORY                               equ     2
OB_TYPE_SYMBOLIC_LINK                           equ     3
OB_TYPE_TOKEN                                   equ     4
OB_TYPE_PROCESS                                 equ     5
OB_TYPE_THREAD                                  equ     6
OB_TYPE_EVENT                                   equ     7
OB_TYPE_EVENT_PAIR                              equ     8
OB_TYPE_MUTANT                                  equ     9
OB_TYPE_SEMAPHORE                               equ     10
OB_TYPE_TIMER                                   equ     11
OB_TYPE_PROFILE                                 equ     12
OB_TYPE_WINDOW_STATION                          equ     13
OB_TYPE_DESKTOP                                 equ     14
OB_TYPE_SECTION                                 equ     15
OB_TYPE_KEY                                     equ     16
OB_TYPE_PORT                                    equ     17
OB_TYPE_ADAPTER                                 equ     18
OB_TYPE_CONTROLLER                              equ     19
OB_TYPE_DEVICE                                  equ     20
OB_TYPE_DRIVER                                  equ     21
OB_TYPE_IO_COMPLETION                           equ     22
OB_TYPE_FILE                                    equ     23

OBJ_INHERIT                                     equ     00000002H
OBJ_PERMANENT                                   equ     00000010H
OBJ_EXCLUSIVE                                   equ     00000020H
OBJ_CASE_INSENSITIVE                            equ     00000040H
OBJ_OPENIF                                      equ     00000080H
OBJ_OPENLINK                                    equ     00000100H
OBJ_VALID_ATTRIBUTES                            equ     000001F2H


DIRECTORY_QUERY                                 equ     0001H
DIRECTORY_TRAVERSE                              equ     0002H
DIRECTORY_CREATE_OBJECT                         equ     0004H
DIRECTORY_CREATE_SUBDIRECTORY                   equ     0008H
DIRECTORY_ALL_ACCESS                            equ     (STANDARD_RIGHTS_RequIRED or 0FH)

SYMBOLIC_LINK_QUERY                             equ     0001H
SYMBOLIC_LINK_ALL_ACCESS                        equ     (STANDARD_RIGHTS_RequIRED or 01H)

SE_MIN_WELL_KNOWN_PRIVILEGE                     equ     2
SE_CREATE_TOKEN_PRIVILEGE                       equ     2
SE_ASSIGNPRIMARYTOKEN_PRIVILEGE                 equ     3
SE_LOCK_MEMORY_PRIVILEGE                        equ     4
SE_INCREASE_QUOTA_PRIVILEGE                     equ     5
SE_UNSOLICITED_INPUT_PRIVILEGE                  equ     6
SE_MACHINE_ACCOUNT_PRIVILEGE                    equ     6
SE_TCB_PRIVILEGE                                equ     7
SE_SECURITY_PRIVILEGE                           equ     8
SE_TAKE_OWNERSHIP_PRIVILEGE                     equ     9
SE_LOAD_DRIVER_PRIVILEGE                        equ     10
SE_SYSTEM_PROFILE_PRIVILEGE                     equ     11
SE_SYSTEMTIME_PRIVILEGE                         equ     12
SE_PROF_SINGLE_PROCESS_PRIVILEGE                equ     13
SE_INC_BASE_PRIORITY_PRIVILEGE                  equ     14
SE_CREATE_PAGEFILE_PRIVILEGE                    equ     15
SE_CREATE_PERMANENT_PRIVILEGE                   equ     16
SE_BACKUP_PRIVILEGE                             equ     17
SE_RESTORE_PRIVILEGE                            equ     18
SE_SHUTDOWN_PRIVILEGE                           equ     19
SE_DEBUG_PRIVILEGE                              equ     20
SE_AUDIT_PRIVILEGE                              equ     21
SE_SYSTEM_ENVIRONMENT_PRIVILEGE                 equ     22
SE_CHANGE_NOTIFY_PRIVILEGE                      equ     23
SE_REMOTE_SHUTDOWN_PRIVILEGE                    equ     24
SE_MAX_WELL_KNOWN_PRIVILEGE                     equ     SE_REMOTE_SHUTDOWN_PRIVILEGE

PROCESS_PARAMETERS_NORMALIZED                   equ     1

LDR_STATIC_LINK                                 equ     0000002H
LDR_IMAGE_DLL                                   equ     0000004H
LDR_LOAD_IN_PROGRESS                            equ     0001000H
LDR_UNLOAD_IN_PROGRESS                          equ     0002000H
LDR_ENTRY_PROCESSED                             equ     0004000H
LDR_ENTRY_INSERTED                              equ     0008000H
LDR_CURRENT_LOAD                                equ     0010000H
LDR_FAILED_BUILTIN_LOAD                         equ     0020000H
LDR_DONT_CALL_FOR_THREADS                       equ     0040000H
LDR_PROCESS_ATTACH_CALLED                       equ     0080000H
LDR_DEBUG_SYMBOLS_LOADED                        equ     0100000H
LDR_IMAGE_NOT_AT_BASE                           equ     0200000H
LDR_WX86_IGNORE_MACHINETYPE                     equ     0400000H
LDR_COR_IMAGE                                   equ     00400000H
LDR_COR_OWNS_UNMAP                              equ     00800000H
LDR_SYSTEM_MAPPED                               equ     01000000H
LDR_IMAGE_VERIFYING                             equ     02000000H
LDR_DRIVER_DEPENDENT_DLL                        equ     04000000H
LDR_ENTRY_NATIVE                                equ     08000000H
LDR_REDIRECTED                                  equ     10000000H
LDR_NON_PAGED_DEBUG_INFO                        equ     20000000H
LDR_MM_LOADED                                   equ     40000000H
LDR_COMPAT_DATABASE_PROCESSED                   equ     80000000H

;POOL_TYPE Enumeration
NonPagedPool                                    equ     0
PagedPool                                       equ     1
NonPagedPoolMustSucceed                         equ     2
DontUseThisType                                 equ     3
NonPagedPoolCacheAligned                        equ     4
PagedPoolCacheAligned                           equ     5
NonPagedPoolCacheAlignedMustS                   equ     6
MaxPoolType                                     equ     7

;KWAIT_REASON Enumeration
Executive                                       equ     0
FreePage                                        equ     1
PageIn                                          equ     2
PoolAllocation                                  equ     3
DelayExecution                                  equ     4
Suspended                                       equ     5
UserRequest                                     equ     6
WrExecutive                                     equ     7
WrFreePage                                      equ     8
WrPageIn                                        equ     9
WrPoolAllocation                                equ     10
WrDelayExecution                                equ     11
WrSuspended                                     equ     12
WrUserRequest                                   equ     13
WrEventPair                                     equ     14
WrQueue                                         equ     15
WrLpcReceive                                    equ     16
WrLpcReply                                      equ     17
WrVirtualMemory                                 equ     18
WrPageOut                                       equ     19
WrRendezvous                                    equ     20
Spare2                                          equ     21
Spare3                                          equ     22
Spare4                                          equ     23
Spare5                                          equ     24
Spare6                                          equ     25
WrKernel                                        equ     26
MaximumWaitReason                               equ     27

;SYSTEMINFOCLASS Enumeration
SystemBasicInformation                          equ     0
SystemProcessorInformation                      equ     1
SystemPerformanceInformation                    equ     2
SystemTimeOfDayInformation                      equ     3
SystemPathInformation                           equ     4 ;Not implemented
SystemProcessInformation                        equ     5
SystemCallCounts                                equ     6
SystemCallCountInformation                      equ     6
SystemConfigurationInformation                  equ     7
SystemDeviceInformation                         equ     7
SystemProcessorTimes                            equ     8
SystemProcessorPerformanceInformation           equ     8
SystemGlobalFlag                                equ     9
SystemFlagsInformation                          equ     9
SystemCallTimeInformation                       equ     10
SystemModuleInformation                         equ     11
SystemLockInformation                           equ     12
SystemStackTraceInformation                     equ     13
SystemPagedPoolInformation                      equ     14
SystemNonPagedPoolInformation                   equ     15
SystemHandleInformation                         equ     16
SystemObjectInformation                         equ     17
SystemPagefileInformation                       equ     18
SystemInstructionEmulationCounts                equ     19
SystemVdmInstemulInformation                    equ     19
SystemVdmBopInformation                         equ     20 ;Not implemented
SystemCacheInformation                          equ     21
SystemFileCacheInformation                      equ     21
SystemPoolTagInformation                        equ     22
SystemProcessorStatistics                       equ     23
SystemInterruptInformation                      equ     23
SystemDpcInformation                            equ     24
SystemDpcBehaviorInformation                    equ     24
SystemFullMemoryInformation                     equ     25
SystemLoadImage                                 equ     26
SystemLoadGdiDriverInformation                  equ     26
SystemUnloadImage                               equ     27
SystemUnloadGdiDriverInformation                equ     27
SystemTimeAdjustment                            equ     28
SystemTimeAdjustmentInformation                 equ     28
SystemSummaryMemoryInformation                  equ     29
SystemMirrorMemoryInformation                   equ     30
SystemPerformanceTraceInformation               equ     31
SystemCrashDumpInformation                      equ     32 ;Not implemented
SystemObsolete0                                 equ     32 ;Not implemented
SystemExceptionInformation                      equ     33
SystemCrashDumpStateInformation                 equ     34
SystemKernelDebuggerInformation                 equ     35
SystemContextSwitchInformation                  equ     36
SystemRegistryQuotaInformation                  equ     37
SystemLoadAndCallImage                          equ     38
SystemExtendServiceTableInformation             equ     38
SystemPrioritySeparation                        equ     39
SystemVerifierAddDriverInformation              equ     40
SystemVerifierRemoveDriverInformation           equ     41
SystemProcessorIdleInformation                  equ     42
SystemLegacyDriverInformation                   equ     43
SystemCurrentTimeZoneInformation                equ     44
SystemLookasideInformation                      equ     45
SystemSetTimeSlipEvent                          equ     46
SystemTimeSlipNotification                      equ     46
SystemCreateSession                             equ     47
SystemSessionCreate                             equ     47
SystemDeleteSession                             equ     48
SystemSessionDetach                             equ     48
SystemSessionInformation                        equ     49
SystemRangeStartInformation                     equ     50
SystemVerifierInformation                       equ     51
SystemAddVerifier                               equ     52
SystemVerifierThunkExtend                       equ     52
SystemSessionProcessesInformation               equ     53
SystemLoadGdiDriverInSystemSpace                equ     54
SystemNumaProcessorMap                          equ     55
SystemPrefetcherInformation                     equ     56
SystemExtendedProcessInformation                equ     57
SystemRecommendedSharedDataAlignment            equ     58
SystemComPlusPackage                            equ     59
SystemNumaAvailableMemory                       equ     60
SystemProcessorPowerInformation                 equ     61
SystemEmulationBasicInformation                 equ     62
SystemEmulationProcessorInformation             equ     63
SystemExtendedHandleInformation                 equ     64
SystemLostDelayedWriteInformation               equ     65
SystemBigPoolInformation                        equ     66
SystemSessionPoolTagInformation                 equ     67
SystemSessionMappedViewInformation              equ     68
SystemHotpatchInformation                       equ     69
SystemObjectSecurityMode                        equ     70
SystemWatchdogTimerHandler                      equ     71
SystemWatchdogTimerInformation                  equ     72
SystemLogicalProcessorInformation               equ     73
SystemWow64SharedInformationObsolete            equ     74
SystemRegisterFirmwareTableInformationHandler   equ     75
SystemFirmwareTableInformation                  equ     76
SystemModuleInformationEx                       equ     77
SystemVerifierTriageInformation                 equ     78
SystemSuperfetchInformation                     equ     79
SystemMemoryListInformation                     equ     80
SystemFileCacheInformationEx                    equ     81
SystemThreadPriorityClientIdInformation         equ     82
SystemProcessorIdleCycleTimeInformation         equ     83
SystemVerifierCancellationInformation           equ     84
SystemProcessorPowerInformationEx               equ     85
SystemRefTraceInformation                       equ     96
SystemSpecialPoolInformation                    equ     87
SystemProcessIdInformation                      equ     88
SystemErrorPortInformation                      equ     89
SystemBootEnvironmentInformation                equ     90
SystemHypervisorInformation                     equ     91
SystemVerifierInformationEx                     equ     92
SystemTimeZoneInformation                       equ     93
SystemImageFileExecutionOptionsInformation      equ     94
SystemCoverageInformation                       equ     95
SystemPrefetchPatchInformation                  equ     96
SystemVerifierFaultsInformation                 equ     97
SystemSystemPartitionInformation                equ     98
SystemSystemDiskInformation                     equ     99
SystemProcessorPerformanceDistribution          equ     100
SystemNumaProximityNodeInformation              equ     101
SystemDynamicTimeZoneInformation                equ     102
SystemCodeIntegrityInformation                  equ     103
SystemProcessorMicrocodeUpdateInformation       equ     104
SystemProcessorBrandString                      equ     105
SystemVirtualAddressInformation                 equ     106
SystemLogicalProcessorAndGroupInformation       equ     107
SystemProcessorCycleTimeInformation             equ     108
SystemStoreInformation                          equ     109
SystemRegistryAppendString                      equ     110
SystemAitSamplingValue                          equ     111
SystemVhdBootInformation                        equ     112
SystemCpuQuotaInformation                       equ     113
SystemNativeBasicInformation                    equ     114
SystemSpare1                                    equ     115
SystemLowPriorityIoInformation                  equ     116
SystemTpmBootEntropyInformation                 equ     117
SystemVerifierCountersInformation               equ     118
SystemPagedPoolInformationEx                    equ     119
SystemSystemPtesInformationEx                   equ     120
SystemNodeDistanceInformation                   equ     121
SystemAcpiAuditInformation                      equ     122
SystemBasicPerformanceInformation               equ     123
SystemQueryPerformanceCounterInformation        equ     124
SystemSessionBigPoolInformation                 equ     125
SystemBootGraphicsInformation                   equ     126
SystemScrubPhysicalMemoryInformation            equ     127
SystemBadPageInformation                        equ     128
SystemProcessorProfileControlArea               equ     129
SystemCombinePhysicalMemoryInformation          equ     130
SystemEntropyInterruptTimingCallback            equ     131
SystemConsoleInformation                        equ     132
SystemPlatformBinaryInformation                 equ     133
SystemThrottleNotificationInformation           equ     134
SystemHypervisorProcessorCountInformation       equ     135
SystemDeviceDataInformation                     equ     136
SystemDeviceDataEnumerationInformation          equ     137
SystemMemoryTopologyInformation                 equ     138
SystemMemoryChannelInformation                  equ     139
SystemBootLogoInformation                       equ     140
SystemProcessorPerformanceInformationEx         equ     141
SystemSpare0                                    equ     142
SystemSecureBootPolicyInformation               equ     143
SystemPageFileInformationEx                     equ     144
SystemSecureBootInformation                     equ     145
SystemEntropyInterruptTimingRawInformation      equ     146
SystemPortableWorkspaceEfiLauncherInformation   equ     147
SystemFullProcessInformation                    equ     148
SystemKernelDebuggerInformationEx               equ     149
SystemBootMetadataInformation                   equ     150
SystemSoftRebootInformation                     equ     151
SystemElamCertificateInformation                equ     152
SystemOfflineDumpConfigInformation              equ     153
SystemProcessorFeaturesInformation              equ     154
SystemRegistryReconciliationInformation         equ     155
SystemEdidInformation                           equ     156
SystemManufacturingInformation                  equ     157
SystemEnergyEstimationConfigInformation         equ     158
SystemHypervisorDetailInformation               equ     159
SystemProcessorCycleStatsInformation            equ     160
SystemVmGenerationCountInformation              equ     161
SystemTrustedPlatformModuleInformation          equ     162
SystemKernelDebuggerFlags                       equ     163
SystemCodeIntegrityPolicyInformation            equ     164
SystemIsolatedUserModeInformation               equ     165
SystemHardwareSecurityTestInterfaceResultsInformation equ  166
SystemSingleModuleInformation                   equ     167
SystemAllowedCpuSetsInformation                 equ     168
SystemDmaProtectionInformation                  equ     169
SystemInterruptCpuSetsInformation               equ     170
SystemSecureBootPolicyFullInformation           equ     171
SystemCodeIntegrityPolicyFullInformation        equ     172
SystemAffinitizedInterruptProcessorInformation  equ     173
SystemRootSiloInformation                       equ     174
MaxSystemInfoClass                              equ     175

;THREAD_STATE Enumeration
StateInitialized                                equ     0
StateReady                                      equ     1
StateRunning                                    equ     2
StateStandby                                    equ     3
StateTerminated                                 equ     4
StateWait                                       equ     5
StateTransition                                 equ     6
StateUnknown                                    equ     7

;FILE_INFORMATION_CLASS Enumeration
FileDirectoryInformation                        equ     1
FileFullDirectoryInformation                    equ     2
FileBothDirectoryInformation                    equ     3
FileBasicInformation                            equ     4
FileStandardInformation                         equ     5
FileInternalInformation                         equ     6
FileEaInformation                               equ     7
FileAccessInformation                           equ     8
FileNameInformation                             equ     9
FileRenameInformation                           equ     10
FileLinkInformation                             equ     11
FileNamesInformation                            equ     12
FileDispositionInformation                      equ     13
FilePositionInformation                         equ     14
FileFullEaInformation                           equ     15
FileModeInformation                             equ     16
FileAlignmentInformation                        equ     17
FileAllInformation                              equ     18
FileAllocationInformation                       equ     19
FileEndOfFileInformation                        equ     20
FileAlternateNameInformation                    equ     21
FileStreamInformation                           equ     22
FilePipeInformation                             equ     23
FilePipeLocalInformation                        equ     24
FilePipeRemoteInformation                       equ     25
FileMailslotQueryInformation                    equ     26
FileMailslotSetInformation                      equ     27
FileCompressionInformation                      equ     28
FileObjectIdInformation                         equ     29
FileCompletionInformation                       equ     30
FileMoveClusterInformation                      equ     31
FileInformationReserved32                       equ     32
FileInformationReserved33                       equ     33
FileNetworkOpenInformation                      equ     34
FileMaximumInformation                          equ     35

;KEY_INFORMATION_CLASS Enumeration
KeyBasicInformation                             equ     0
KeyNodeInformation                              equ     1
KeyFullInformation                              equ     2
KeyNameInformation                              equ     3
KeyCachedInformation                            equ     4
KeyVirtualizationInformation                    equ     5

;KEY_VALUE_INFORMATION_CLASS Enumeration
KeyValueBasicInformation                        equ     0
KeyValueFullInformation                         equ     1
KeyValuePartialInformation                      equ     2

;PROCESSINFOCLASS Enumeration
ProcessBasicInformation                         equ     0
ProcessQuotaLimits                              equ     1
ProcessIoCounters                               equ     2
ProcessVmCounters                               equ     3
ProcessTimes                                    equ     4
ProcessBasePriority                             equ     5
ProcessRaisePriority                            equ     6
ProcessDebugPort                                equ     7
ProcessExceptionPort                            equ     8
ProcessAccessToken                              equ     9
ProcessLdtInformation                           equ     10
ProcessLdtSize                                  equ     11
ProcessDefaultHardErrorMode                     equ     12
ProcessIoPortHandlers                           equ     13
ProcessPooledUsageAndLimits                     equ     14
ProcessWorkingSetWatch                          equ     15
ProcessUserModeIOPL                             equ     16
ProcessEnableAlignmentFaultFixup                equ     17
ProcessPriorityClass                            equ     18
ProcessWx86Information                          equ     19
ProcessHandleCount                              equ     20
ProcessAffinityMask                             equ     21
ProcessPriorityBoost                            equ     22
ProcessDeviceMap                                equ     23
ProcessSessionInformation                       equ     24
ProcessForegroundInformation                    equ     25
ProcessWow64Information                         equ     26
MaxProcessInfoClass                             equ     27

;LPC_TYPE Enumeration
LPC_NEW_MESSAGE                                 equ     0
LPC_RequEST                                     equ     1
LPC_REPLY                                       equ     2
LPC_DATAGRAM                                    equ     3
LPC_LOST_REPLY                                  equ     4
LPC_PORT_CLOSED                                 equ     5
LPC_CLIENT_DIED                                 equ     6
LPC_EXCEPTION                                   equ     7
LPC_DEBUG_EVENT                                 equ     8
LPC_ERROR_EVENT                                 equ     9
LPC_CONNECTION_RequEST                          equ     10
LPC_CONNECTION_REFUSED                          equ     11
LPC_MAXIMUM                                     equ     12

;SECTION_INHERIT Enumeration
ViewShare                                       equ     1
ViewUnmap                                       equ     2

;SECTION_INFORMATION_CLASS Enumeration
SectionBasicInformation                         equ     0
SectionImageInformation                         equ     1

;OBJECT_INFORMATION_CLASS Enumeration
ObjectBasicInformation                          equ     0
ObjectNameInformation                           equ     1
ObjectTypeInformation                           equ     2
ObjectAllTypesInformation                       equ     3
ObjectHandleInformation                         equ     4

;MEMORY_INFORMATION_CLASS Enumeration
MemoryBasicInformation                          equ     0
MemoryWorkingSetList                            equ     1
MemorySectionName                               equ     2
MemoryBasicVlmInformation                       equ     3

;THREADINFOCLASS Enumeration
ThreadBasicInformation                          equ     0
ThreadTimes                                     equ     1
ThreadPriority                                  equ     2
ThreadBasePriority                              equ     3
ThreadAffinityMask                              equ     4
ThreadImpersonationToken                        equ     5
ThreadDescriptorTableEntry                      equ     6
ThreadEnableAlignmentFaultFixup                 equ     7
ThreadEventPair                                 equ     8
ThreadQuerySetWin32StartAddress                 equ     9
ThreadZeroTlsCell                               equ     10
ThreadPerformanceCount                          equ     11
ThreadAmILastThread                             equ     12
ThreadIdealProcessor                            equ     13
ThreadPriorityBoost                             equ     14
ThreadSetTlsArrayAddress                        equ     15
ThreadIsIoPending                               equ     16
ThreadHideFromDebugger                          equ     17
MaxThreadInfoClass                              equ     18

;FSINFOCLASS Enumeration
FileFsVolumeInformation                         equ     1
FileFsLabelInformation                          equ     2
FileFsSizeInformation                           equ     3
FileFsDeviceInformation                         equ     4
FileFsAttributeInformation                      equ     5
FileFsControlInformation                        equ     6
FileFsFullSizeInformation                       equ     7
FileFsObjectIdInformation                       equ     8
FileFsMaximumInformation                        equ     9

;PLUGPLAY_BUS_CLASS Enumeration
SystemBus                                       equ     0
PlugPlayVirtualBus                              equ     1
MaxPlugPlayBusClass                             equ     2

;PLUGPLAY_VIRTUAL_BUS_TYPE Enumeration
Root                                            equ     0
MaxPlugPlayVirtualBusType                       equ     1

;INTERFACE_TYPE Enumeration
InterfaceTypeUndefined                          equ     (-1)
Internal                                        equ     0
Isa                                             equ     1
Eisa                                            equ     2
MicroChannel                                    equ     3
TurboChannel                                    equ     4
PCIBus                                          equ     5
VMEBus                                          equ     6
NuBus                                           equ     7
PCMCIABus                                       equ     8
CBus                                            equ     9
MPIBus                                          equ     10
MPSABus                                         equ     11
ProcessorInternal                               equ     12
InternalPowerBus                                equ     13
PNPISABus                                       equ     14
PNPBus                                          equ     15
MaximumInterfaceType                            equ     16

;SYSTEM_DOCK_STATE Enumeration
SystemDockStateUnknown                          equ     0
SystemUndocked                                  equ     1
SystemDocked                                    equ     2

MAX_SYSTEM_MODULE_NAME_LENGTH                   equ     256

LPC_MAX_MESSAGE_SIZE                            equ     148
LPC_MAX_DATA_SIZE                               equ     104

SIZE_OF_80387_REGISTERS                         equ     80
MAXIMUM_SUPPORTED_EXTENSION                     equ     512

_CONTEXT_i386                                   equ     010000H
_CONTEXT_AMD64                                  equ     100000H
_CONTEXT_CONTROL                                equ     1
_CONTEXT_INTEGER                                equ     2

IMAGE_REL_BASED_MASK                            equ     0FFFH
IMAGE_REL_BASED_SHIFT                           equ     12

IMAGE_SIZEOF_BASE_RELOCATION                    equ     8

UWOP_PUSH_NONVOL                                equ     0
UWOP_ALLOC_LARGE                                equ     1
UWOP_ALLOC_SMALL                                equ     2
UWOP_SET_FPREG                                  equ     3
UWOP_SAVE_NONVOL                                equ     4
UWOP_SAVE_NONVOL_FAR                            equ     5
UWOP_SAVE_XMM128                                equ     6
UWOP_SAVE_XMM128_FAR                            equ     7
UWOP_PUSH_MACHFRAME                             equ     8

PDI_MODULES                                     equ     01H
PDI_BACKTRACE                                   equ     02H
PDI_HEAPS                                       equ     04H
PDI_HEAP_TAGS                                   equ     08H
PDI_HEAP_BLOCKS                                 equ     10H
PDI_LOCKS                                       equ     20H

UNW_FLAG_NHANDLER                               equ     0H
UNW_FLAG_EHANDLER                               equ     1H
UNW_FLAG_UHANDLER                               equ     2H
UNW_FLAG_CHAININFO                              equ     4H

MAX_BUS_NAME                                    equ     24

KRNL_NORMAL_PRIORITY_CLASS                      equ     02H
KRNL_IDLE_PRIORITY_CLASS                        equ     01H
KRNL_HIGH_PRIORITY_CLASS                        equ     03H
KRNL_REALTIME_PRIORITY_CLASS                    equ     04H

;======================================== Structures ======================================;
if ~defined LARGE_INTEGER_DEF
    LARGE_INTEGER_DEF equ 1
    struct LARGE_INTEGER
        LowPart  dd ?
        HighPart dd ?
    ends
end if

if ~defined ULARGE_INTEGER_DEF
    ULARGE_INTEGER_DEF equ 1
    struct ULARGE_INTEGER
        LowPart  dd ?
        HighPart dd ?
    ends
end if

if ~defined UNICODE_STRING32_DEFINED
    define UNICODE_STRING32_DEFINED 1
    struct UNICODE_STRING32
        Length          dw ?
        MaximumLength   dw ?
        Buffer          dd ?
    ends
end if

if ~defined UNICODE_STRING64_DEFINED
    define UNICODE_STRING64_DEFINED 1
    struct UNICODE_STRING64
        Length          dw ?
        MaximumLength   dw ?
        Reserved        dd ?
        Buffer          dq ?
    ends
end if

struct OBJECT_ATTRIBUTES
    Length                   dd    ?
    RootDirectory            xptr ?
    ObjectName               xptr  ?
    Attributes               dd    ?
    SecurityDescriptor       xptr  ?
    SecurityQualityOfService xptr  ?
ends

struct CLIENT_ID
    UniqueProcess   xptr ?
    UniqueThread    xptr ?
ends

struct NT_TIB
    ExceptionList   xptr ?
    StackBase       xptr ?
    StackLimit      xptr ?
    SubSystemTib    xptr ?
    union
        FiberData   xptr ?
        Version     dd   ?
    ends
    ArbitraryUserPointer xptr ?
    Self            xptr ?
ends

struct PEB_FREE_BLOCK
    Next    xptr ?
    Size    dd   ?
ends

struct CURDIR
   DosPath  UNICODE_STRING
   Handle   xptr ?
ends

struct RTL_DRIVE_LETTER_CURDIR
    Flags       dd ?
    Length      dw ?
    TimeStamp   dd ?
    DosPath     STRING
ends

struct PROCESS_PARAMETERS
    MaximumLength       dd   ?
    Length              dd   ?
    Flags               dd   ?
    DebugFlags          dd   ?
    ConsoleHandle       xptr ?
    ConsoleFlags        dd   ?
    StandardInput       xptr ?
    StandardOutput      xptr ?
    StandardError       xptr ?
    CurrentDirectory    CURDIR
    DllPath             UNICODE_STRING
    ImagePathName       UNICODE_STRING
    CommandLine         UNICODE_STRING
    Environment         xptr ?
    StartingX           dd   ?
    StartingY           dd   ?
    CountX              dd   ?
    CountY              dd   ?
    CountCharsX         dd   ?
    CountCharsY         dd   ?
    FillAttribute       dd   ?
    WindowFlags         dd   ?
    ShowWindowFlags     dd   ?
    WindowTitle         UNICODE_STRING
    Desktop             UNICODE_STRING
    ShellInfo           UNICODE_STRING
    RuntimeInfo         UNICODE_STRING
    CurrentDirectores   RTL_DRIVE_LETTER_CURDIR 32
ends

struct RTL_BITMAP
    SizeOfBitMap    dd   ?
    Buffer          xptr ?
ends

struct LDR_DATA_TABLE_ENTRY64
    InLoadOrderModuleList           LIST_ENTRY64
    InMemoryOrderModuleList         LIST_ENTRY64
    InInitializationOrderModuleList LIST_ENTRY64
    DllBase                         dq ?
    EntryPoint                      dq ?
    SizeOfImage                     dd ?
    FullDllName                     UNICODE_STRING64
    BaseDllName                     UNICODE_STRING64
    Flags                           dd ?
    LoadCount                       dw ?
    TlsIndex                        dw ?
    union
        HashLinks                   LIST_ENTRY64
        struct
            SectionPointer          dq ?
            CheckSum                dd ?
        ends
    ends
    union
        TimeDateStamp               dd ?
        LoadedImports               dq ?
    ends
    EntryPointActivationContext     dq ?
    PatchInformation                dq ?
ends

struct LDR_DATA_TABLE_ENTRY32
    InLoadOrderModuleList           LIST_ENTRY32
    InMemoryOrderModuleList         LIST_ENTRY32
    InInitializationOrderModuleList LIST_ENTRY32
    DllBase                         dd ?
    EntryPoint                      dd ?
    SizeOfImage                     dd ?
    FullDllName                     UNICODE_STRING32
    BaseDllName                     UNICODE_STRING32
    Flags                           dd ?
    LoadCount                       dw ?
    TlsIndex                        dw ?
    union
        HashLinks                   LIST_ENTRY32
        struct
            SectionPointer          dd ?
            CheckSum                dd ?
        ends
        union
            TimeDateStamp               dd ?
            LoadedImports               dd ?
        ends
    ends
    EntryPointActivationContext     dd ?
    PatchInformation                dd ?
ends

struct LDR_DATA_TABLE_ENTRY
     InLoadOrderLinks           LIST_ENTRY
     InMemoryOrderLinks         LIST_ENTRY
     InInitializationOrderLinks LIST_ENTRY
     DllBase                    xptr ?
     EntryPoint                 xptr ?
     SizeOfImage                dd   ?
     FullDllName                UNICODE_STRING
     BaseDllName                UNICODE_STRING
     Flags                      dd   ?
     LoadCount                  dw   ?
     TlsIndex                   dw   ?
     union
          HashLinks             LIST_ENTRY
          struct
               SectionPointer   xptr ?
               CheckSum         dd   ?
          ends
     ends
     union
          TimeDateStamp         dd   ?
          LoadedImports         xptr ?
     ends
     _ACTIVATION_CONTEXT        xptr ?
     PatchInformation           xptr ?
     ForwarderLinks             LIST_ENTRY
     ServiceTagLinks            LIST_ENTRY
     StaticLinks                LIST_ENTRY
ends

struct PEB_LDR_DATA64
    Length                          dd ?
    Initialized                     db ?
    SsHandle                        dq ?
    InLoadOrderModuleList           LIST_ENTRY64
    InMemoryOrderModuleList         LIST_ENTRY64
    InInitializationOrderModuleList LIST_ENTRY64
ends

struct PEB_LDR_DATA32
    Length                          dd ?
    Initialized                     db ?
    SsHandle                        dd ?
    InLoadOrderModuleList           LIST_ENTRY32
    InMemoryOrderModuleList         LIST_ENTRY32
    InInitializationOrderModuleList LIST_ENTRY32
ends

struct PEB_LDR_DATA
    Length                          dd   ?
    Initialized                     db   ?
    SsHandle                        xptr ?
    InLoadOrderModuleList           LIST_ENTRY
    InMemoryOrderModuleList         LIST_ENTRY
    InInitializationOrderModuleList LIST_ENTRY
ends

struct SYSTEM_STRINGS
    SystemRoot          UNICODE_STRING
    System32Root        UNICODE_STRING
    BaseNamedObjects    UNICODE_STRING
ends

struct TEXT_INFO
    Reserved        xptr ?
    SystemStrings   xptr ?
ends

struct PEB64
    InheritedAddressSpace    db ?
    ReadImageFileExecOptions db ?
    BeingDebugged            db ?
    b003                     db ?
    Reserved0                dd ?
    Mutant                   dq ?
    ImageBaseAddress         dq ?
    Ldr                      dq ?
    ProcessParameters        dq ?
ends

struct PEB32
    InheritedAddressSpace    db ?
    ReadImageFileExecOptions db ?
    BeingDebugged            db ?
    b003                     db ?
    Mutant                   dd ?
    ImageBaseAddress         dd ?
    Ldr                      dd ?
    ProcessParameters        dd ?
ends

struct PEB
    InheritedAddressSpace            db ?
    ReadImageFileExecOptions         db ?
    BeingDebugged                    db ?
    b003                             db ?
    Mutant                           xptr ?
    ImageBaseAddress                 xptr ?
    Ldr                              xptr ?
    ProcessParameters                xptr ?
    SubSystemData                    xptr ?
    ProcessHeap                      xptr ?
    FastPebLock                      xptr ?
    FastPebLockRoutine               xptr ?
    FastPebUnlockRoutine             xptr ?
    EnvironmentUpdateCount           dd   ?
    KernelCallbackTable              xptr ?
    EventLogSection                  xptr ?
    EventLog                         xptr ?
    FreeList                         xptr ?
    TlsExpansionCounter              dd   ?
    TlsBitmap                        xptr ?
    TlsBitmapData                    dd   ?
    ReadOnlySharedMemoryBase         xptr ?
    ReadOnlySharedMemoryHeap         xptr ?
    ReadOnlyStaticServerData         xptr ?
    InitAnsiCodePageData             xptr ?
    InitOemCodePageData              xptr ?
    InitUnicodeCaseTableData         xptr ?
    KeNumberProcessors               dd   ?
    NtGlobalFlag                     dd   ?
    d6C                              dd   ?
    MmCriticalSectionTimeout         LARGE_INTEGER
    MmHeapSegmentReserve             dd   ?
    MmHeapSegmentCommit              dd   ?
    MmHeapDeCommitTotalFreeThreshold dd   ?
    MmHeapDeCommitFreeBlockThreshold dd   ?
    NumberOfHeaps                    dd   ?
    AvailableHeaps                   dd   ?
    ProcessHeapsListBuffer           xptr ?
    GdiSharedHandleTable             xptr ?
    ProcessStarterHelper             xptr ?
    GdiDCAttributeList               xptr ?
    LoaderLock                       xptr ?
    NtMajorVersion                   dd   ?
    NtMinorVersion                   dd   ?
    NtBuildNumber                    dw   ?
    NtCSDVersion                     dw   ?
    PlatformId                       dd   ?
    Subsystem                        dd   ?
    MajorSubsystemVersion            dd   ?
    MinorSubsystemVersion            dd   ?
    AffinityMask                     xptr ?
    GdiHandleBuffer                  dd   ?
    PostProcessInitRoutine           dd   ?
    TlsExpansionBitmap               dd   ?
    TlsExpansionBitmapBits           dw   ?
    SessionId                        dd   ?
    AppCompatFlags                   ULARGE_INTEGER
    CSDVersion                       xptr ?
ends

struct TEB
    Tib                          NT_TIB
    EnvironmentPointer           xptr ?
    Cid                          CLIENT_ID
    ActiveRpcInfo                xptr ?
    ThreadLocalStoragePointer    xptr ?
    Peb                          xptr ?
    LastErrorValue               dd   ?
    CountOfOwnedCriticalSections dd   ?
    CsrClientThread              xptr ?
    Win32ThreadInfo              xptr ?
    Win32ClientInfo              dd   01FH dup(?)
    WOW32Reserved                xptr ?
    CurrentLocale                dd   ?
    FpSoftwareStatusRegister     dd   ?
    SystemReserved1              xptr ?
    Spare1                       xptr ?
    ExceptionCode                dd   ?
    SpareBytes1                  dd   28 dup(?)
    SystemReserved2              xptr ?
    gdiRgn                       dd   ?
    gdiPen                       dd   ?
    gdiBrush                     dd   ?
    RealClientId                 CLIENT_ID
    GdiCachedProcessHandle       xptr ?
    GdiClientPID                 dd   ?
    GdiClientTID                 dd   ?
    GdiThreadLocaleInfo          xptr ?
    UserReserved                 xptr 5 dup(?)
    glDispatchTable              xptr 118 dup(?)
    glReserved1                  dd   01AH dup(?)
    glReserved2                  xptr ?
    glSectionInfo                xptr ?
    glSection                    xptr ?
    glTable                      xptr ?
    glCurrentRC                  xptr ?
    glContext                    xptr ?
    LastStatusValue              dd   ?
    StaticUnicodeString          UNICODE_STRING
    StaticUnicodeBuffer          dw 105 dup(?)
    DeallocationStack            xptr ?
    TlsSlots                     xptr 40 dup(?)
    TlsLinks                     LIST_ENTRY
    Vdm                          xptr ?
    ReservedForNtRpc             xptr ?
    DbgSsReserved                xptr 2 dup(?)
    HardErrorDisabled            dd   ?
    Instrumentation              xptr 10 dup(?)
    WinSockData                  xptr ?
    GdiBatchCount                dd   ?
    _Spare2                      dd   ?
    _Spare3                      dd   ?
    _Spare4                      dd   ?
    ReservedForOle               xptr ?
    WaitingOnLoaderLock          dd   ?
    StackCommit                  xptr ?
    StackCommitMax               xptr ?
    StackReserve                 xptr ?
ends

struct DISPATCHER_HEADER
    uType           db ?
    uAbsolute       db ?
    uSize           db ?
    uInserted       db ?
    lSignalState    dd ?
    WaitListHead    LIST_ENTRY
ends

struct KPROCESS
    Header          DISPATCHER_HEADER
    le10            LIST_ENTRY
    d18             dd ?
    d1C             dd ?
    d20             dd ?
    d24             dd ?
    d28             dd ?
    d2C             dd ?
    d30             dd ?
    d34             dd ?
    dKernelTime     dd ?
    dUserTime       dd ?
    le40            LIST_ENTRY
    OutSwapList     LIST_ENTRY
    ThreadListHead  LIST_ENTRY
    d58             dd ?
    AffinityMask    xptr ?
    w60             dw ?
    bBasePriority   db ?
    b63             db ?
    w64             dw ?
    b66             db ?
    fPriorityBoost  db ?
ends

struct PORT_MESSAGE
    DataSize            dw ?
    MessageSize         dw ?
    MessageType         dw ?
    VirtualRangesOffset dw ?
    ClientId            CLIENT_ID
    MessageId           dd ?
    SectionSize         dd ?
    Data                db 2 dup(?)
ends

struct SERVICE_DESCRIPTOR_TABLE
    ServiceTable    xptr ?
    puCounterTable  xptr ?
    uTableSize      dd   ?
    pbArgumentTable xptr ?
ends

struct KSEMAPHORE
    Header  DISPATCHER_HEADER
    lLimit  dd ?
ends

struct KTHREAD
    Header                      DISPATCHER_HEADER
    le010                       LIST_ENTRY
    d018                        dd   ?
    d01C                        dd   ?
    pTeb                        xptr ?
    d024                        dd   ?
    d028                        dd   ?
    b02C                        db   ?
    bThreadState                db   ?
    w02E                        dw   ?
    w030                        dw   ?
    b032                        db   ?
    bPriority                   db   ?
    le034                       LIST_ENTRY
    le03C                       LIST_ENTRY
    pProcess                    xptr ?
    d048                        dd   ?
    dContextSwitches            dd   ?
    d050                        dd   ?
    w054                        dw   ?
    b056                        db   ?
    bWaitReason                 db   ?
    d058                        dd   ?
    ple05C                      xptr ?
    ple060                      xptr ?
    d064                        dd   ?
    bBasePriority               db   ?
    b069                        db   ?
    w06A                        dw   ?
    d06C                        dd   ?
    d070                        dd   ?
    d074                        dd   ?
    d078                        dd   ?
    d07C                        dd   ?
    d080                        dd   ?
    d084                        dd   ?
    d088                        dd   ?
    d08C                        dd   ?
    d090                        dd   ?
    d094                        dd   ?
    d098                        dd   ?
    d09C                        dd   ?
    d0A0                        dd   ?
    d0A4                        dd   ?
    d0A8                        dd   ?
    d0AC                        dd   ?
    d0B0                        dd   ?
    d0B4                        dd   ?
    d0B8                        dd   ?
    d0BC                        dd   ?
    d0C0                        dd   ?
    d0C4                        dd   ?
    d0C8                        dd   ?
    d0CC                        dd   ?
    d0D0                        dd   ?
    d0D4                        dd   ?
    d0D8                        dd   ?
    pServiceDescriptorTable     xptr ?
    d0E0                        dd   ?
    d0E4                        dd   ?
    d0E8                        dd   ?
    d0EC                        dd   ?
    le0F0                       LIST_ENTRY
    d0F8                        dd   ?
    d0FC                        dd   ?
    d100                        dd   ?
    d104                        dd   ?
    d108                        dd   ?
    d10C                        dd   ?
    d110                        dd   ?
    d114                        dd   ?
    d118                        dd   ?
    b11C                        db   ?
    b11D                        db   ?
    w11E                        dw   ?
    d120                        dd   ?
    d124                        dd   ?
    d128                        dd   ?
    d12C                        dd   ?
    d130                        dd   ?
    w134                        dw   ?
    b136                        db   ?
    ProcessorMode               db   ?
    dKernelTime                 dd   ?
    dUserTime                   dd   ?
    d140                        dd   ?
    d144                        dd   ?
    d148                        dd   ?
    d14C                        dd   ?
    d150                        dd   ?
    d154                        dd   ?
    d158                        dd   ?
    d15C                        dd   ?
    d160                        dd   ?
    d164                        dd   ?
    d168                        dd   ?
    d16C                        dd   ?
    d170                        dd   ?
    SuspendNop                  xptr ?
    d178                        dd   ?
    d17C                        dd   ?
    d180                        dd   ?
    d184                        dd   ?
    d188                        dd   ?
    d18C                        dd   ?
    SuspendSemaphore            KSEMAPHORE
    ThreadList                  LIST_ENTRY
    d1AC                        dd   ?
ends

struct ETHREAD
    Tcb                         KTHREAD
    liCreateTime                LARGE_INTEGER
    liExitTime                  LARGE_INTEGER
    ExitStatus                  dd   ?
    PostBlockList               LIST_ENTRY
    TerminationPortList         LIST_ENTRY
    uActiveTimerListLock        dd   ?
    ActiveTimerListHead         LIST_ENTRY
    Cid                         CLIENT_ID
    LpcReplySemaphore           KSEMAPHORE
    uLpcReplyMessage            dd   ?
    liLpcReplyMessageId         LARGE_INTEGER
    uImpersonationInfo          dd   ?
    IrpList                     LIST_ENTRY
    TopLevelIrp                 LIST_ENTRY
    uReadClusterSize            dd   ?
    fForwardClusterOnly         db   ?
    fDisablePageFaultClustering db   ?
    fDeadThread                 db   ?
    fHasTerminated              db   ?
    uEventPair                  dd   ?
    uGrantedAccess              dd   ?
    uThreadsProcess             dd   ?
    pStartAddress               xptr ?
    Win32StartAddress           xptr ?
    fLpcExitThreadCalled        db   ?
    fHardErrorsAreDisabled      db   ?
    wUknown1                    dw   ?
    dwUknown2                   dd   ?
ends

struct KEVENT
    Header  DISPATCHER_HEADER
ends

struct ERESOURCE_OLD
    SystemResourcesList         LIST_ENTRY
    OwnerThreads                xptr ?
    pbOwnerCounts               xptr ?
    wTableSize                  dw   ?
    wActiveCount                dw   ?
    wFlag                       dw   ?
    wTableRover                 dw   ?
    bInitialOwnerCounts         db   4 dup(?)
    InitialOwnerThreads         dd   4 dup(?)
    dwUknown1                   dd   ?
    uContentionCount            dd   ?
    wNumberOfExclusiveWaiters   dw   ?
    wNumberOfSharedWaiters      dw   ?
    SharedWaiters               KSEMAPHORE
    ExclusiveWaiters            KEVENT
    SpinLock                    xptr ?
    uCreatorBackTraceIndex      dd   ?
    wDepth                      dw   ?
    wUknown2                    dw   ?
    pOwnerBackTrace             xptr 4 dup(?)
ends

struct OWNER_ENTRY
    OwnerThread                 dd   ?
    union
        OwnerCount              dd   ?
        TableSize               dd   ?
    ends
ends

struct ERESOURCE_LITE
    SystemResourcesList         LIST_ENTRY
    OwnerTable                  xptr ?
    sActiveCount                dw   ?
    wFlag                       dw   ?
    SharedWaiters               xptr ?
    ExclusiveWaiters            xptr ?
    OwnerThreads                OWNER_ENTRY 2
    uContentionCount            dd ?
    wNumberOfSharedWaiters      dw ?
    wNumberOfExclusiveWaiters   dw ?
    union
        pAddress                xptr ?
        uCreatorBackTraceIndex  dd ?
    ends
    SpinLock                    xptr ?
ends

struct IO_STATUS_BLOCK
  union
    Status    dd ?
    Pointer   xptr ?
  ends
  Information xptr ?
ends

if ~defined QUOTA_LIMITS_DEFINED
    define QUOTA_LIMITS_DEFINED 1
    struct QUOTA_LIMITS
        PagedPoolLimit          xptr ?
        NonPagedPoolLimit       xptr ?
        MinimumWorkingSetSize   xptr ?
        MaximumWorkingSetSize   xptr ?
        PagefileLimit           xptr ?
        TimeLimit               LARGE_INTEGER
    ends
end if

struct IOCOUNTERS
    uReadOperationCount     dd ?
    uWriteOperationCount    dd ?
    uOtherOperationCount    dd ?
    liReadTransferCount     LARGE_INTEGER
    liWriteTransferCount    LARGE_INTEGER
    liOtherTransferCount    LARGE_INTEGER
ends

struct VM_COUNTERS
    uPeakVirtualSize            dd ?
    uVirtualSize                dd ?
    uPageFaultCount             dd ?
    uPeakWorkingSetSize         dd ?
    uWorkingSetSize             dd ?
    uQuotaPeakPagedPoolUsage    dd ?
    uQuotaPagedPoolUsage        dd ?
    uQuotaPeakNonPagedPoolUsage dd ?
    uQuotaNonPagedPoolUsage     dd ?
    uPagefileUsage              dd ?
    uPeakPagefileUsage          dd ?
ends

struct KERNEL_USER_TIMES
    liCreateTime    LARGE_INTEGER
    liExitTime      LARGE_INTEGER
    liKernelTime    LARGE_INTEGER
    liUserTime      LARGE_INTEGER
ends

struct BASE_PRIORITY_INFORMATION
    BasePriority dd ?
ends

struct AFFINITY_MASK
    AffinityMask xptr ?
ends

struct TIME_FIELDS
    wYear           dw ?
    wMonth          dw ?
    wDay            dw ?
    wHour           dw ?
    wMinute         dw ?
    wSecond         dw ?
    wMilliseconds   dw ?
    wWeekday        dw ?
ends

struct NTFS_VOLUME_DATA_BUFFER
    liSerialNumber          LARGE_INTEGER
    liNumberOfSectors       LARGE_INTEGER
    liTotalClusters         LARGE_INTEGER
    liFreeClusters          LARGE_INTEGER
    liReserved              LARGE_INTEGER
    uBytesPerSector         dd ?
    uBytesPerCluster        dd ?
    uBytesPerMFTRecord      dd ?
    uClustersPerMFTRecord   dd ?
    liMFTLength             LARGE_INTEGER
    liMFTStart              LARGE_INTEGER
    liMFTMirrorStart        LARGE_INTEGER
    liMFTZoneStart          LARGE_INTEGER
    liMFTZoneEnd            LARGE_INTEGER
ends

struct OBJDIR_INFORMATION
    ObjectName      UNICODE_STRING
    ObjectTypeName  UNICODE_STRING
    Data            db 2 dup(?)
ends

struct FILE_FS_VOLUME_INFORMATION
    VolumeCreationTime  LARGE_INTEGER
    VolumeSerialNumber  dd ?
    VolumeLabelLength   dd ?
    SupportsObjects     db ?
    VolumeLabel         dw 2 dup(?)
ends

struct FILE_FS_LABEL_INFORMATION
    VolumeLabelLength   dd ?
    VolumeLabel         dw 2 dup(?)
ends

struct FILE_FS_SIZE_INFORMATION
    TotalAllocationUnits        LARGE_INTEGER
    AvailableAllocationUnits    LARGE_INTEGER
    SectorsPerAllocationUnit    dd ?
    BytesPerSector              dd ?
ends

struct FILE_FS_DEVICE_INFORMATION
    DeviceType      dd ?
    Characteristics dd ?
ends

struct FILE_FS_ATTRIBUTE_INFORMATION
    FileSystemAttributes        dd ?
    MaximumComponentNameLength  dd ?
    FileSystemNameLength        dd ?
    FileSystemName              dw 2 dup(?)
ends

struct FILE_FS_CONTROL_INFORMATION
    FreeSpaceStartFiltering LARGE_INTEGER
    FreeSpaceThreshold      LARGE_INTEGER
    FreeSpaceStopFiltering  LARGE_INTEGER
    DefaultQuotaThreshold   LARGE_INTEGER
    DefaultQuotaLimit       LARGE_INTEGER
    FileSystemControlFlags  dd ?
ends

struct FILE_FS_FULL_SIZE_INFORMATION
    TotalQuotaAllocationUnits       LARGE_INTEGER
    AvailablequotaAllocationUnits   LARGE_INTEGER
    AvailableAllocationUnits        LARGE_INTEGER
    SectorsPerAllocationUnit        dd ?
    BytesPerSector                  dd ?
ends

struct FILE_FS_OBJECT_ID_INFORMATION
    VolumeObjectId              GUID
    VolumeObjectIdExtendedInfo  dd 12 dup(?)
ends

struct SYSTEM_BASIC_INFORMATION
    dwUnknown1                  dd   ?
    uKeMaximumIncrement         dd   ?
    uPageSize                   dd   ?
    uMmNumberOfPhysicalPages    dd   ?
    uMmLowestPhysicalPage       dd   ?
    uMmHighestPhysicalPage      dd   ?
    uAllocationGranularity      dd   ?
    pLowestUserAddress          xptr ?
    pMmHighestUserAddress       xptr ?
    uKeActiveProcessors         xptr ?
    bKeNumberProcessors         db   ?
    bUnknown2                   db   ?
    wUnknown3                   dw   ?
ends

struct SYSTEM_PROCESSOR_INFORMATION
    wKeProcessorArchitecture    dw   ?
    wKeProcessorLevel           dw   ?
    wKeProcessorRevision        dw   ?
    wUnknown1                   dw   ?
    uKeFeatureBits              dd   ?
ends

struct MM_INFO_COUNTERS
    uPageFaults             dd ?
    uWriteCopyFaults        dd ?
    uTransistionFaults      dd ?
    uCacheTransitionCount   dd ?
    uDemandZeroFaults       dd ?
    uPagesRead              dd ?
    uPageReadIos            dd ?
    uCacheReadCount         dd ?
    uCacheIoCount           dd ?
    uPagefilePagesWritten   dd ?
    uPagefilePageWriteIos   dd ?
    uMappedFilePagesWritten dd ?
    uMappedFilePageWriteIos dd ?
ends

struct SYSTEM_PERFORMANCE_INFORMATION
    liIdleTime                              LARGE_INTEGER
    liIoReadTransferCount                   LARGE_INTEGER
    liIoWriteTransferCount                  LARGE_INTEGER
    liIoOtherTransferCount                  LARGE_INTEGER
    uIoReadOperationCount                   dd ?
    uIoWriteOperationCount                  dd ?
    uIoOtherOperationCount                  dd ?
    uMmAvailablePages                       dd ?
    uMmTotalCommittedPages                  dd ?
    uMmTotalCommitLimit                     dd ?
    uMmPeakCommitLimit                      dd ?
    MmInfoCounters                          MM_INFO_COUNTERS
    uPoolPaged                              dd ?
    uPoolNonPaged                           dd ?
    uPagedPoolAllocs                        dd ?
    uPagedPoolFrees                         dd ?
    uNonPagedPoolAllocs                     dd ?
    uNonPagedPoolFrees                      dd ?
    uMmTotalFreeSystemPages                 dd ?
    uMmSystemCodePage                       dd ?
    uMmTotalSystemDriverPages               dd ?
    uMmTotalSystemCodePages                 dd ?
    uSmallNonPagedLookasideListAllocateHits dd ?
    uSmallPagedLookasideListAllocateHits    dd ?
    dwUnknown1                              dd ?
    uMmSystemCachePage                      dd ?
    uMmPagedPoolPage                        dd ?
    uMmSystemDriverPage                     dd ?
    uCcFastReadNoWait                       dd ?
    uCcFastReadWait                         dd ?
    uCcFastReadResourceMiss                 dd ?
    uCcFastReadNotPossible                  dd ?
    uCcFastMdlReadNoWait                    dd ?
    uCcFastMdlReadWait                      dd ?
    uCcFastMdlReadResourceMiss              dd ?
    uCcFastMdlReadNotPossible               dd ?
    uCcMapDataNoWait                        dd ?
    uCcMapDataWait                          dd ?
    uCcMapDataNoWaitMiss                    dd ?
    uCcMapDataWaitMiss                      dd ?
    uCcPinMappedDataCount                   dd ?
    uCcPinReadNoWait                        dd ?
    uCcPinReadWait                          dd ?
    uCcPinReadNoWaitMiss                    dd ?
    uCcPinReadWaitMiss                      dd ?
    uCcCopyReadNoWait                       dd ?
    uCcCopyReadWait                         dd ?
    uCcCopyReadNoWaitMiss                   dd ?
    uCcCopyReadWaitMiss                     dd ?
    uCcMdlReadNoWait                        dd ?
    uCcMdlReadWait                          dd ?
    uCcMdlReadNoWaitMiss                    dd ?
    uCcMdlReadWaitMiss                      dd ?
    uCcReadAheadIos                         dd ?
    uCcLazyWriteIos                         dd ?
    uCcLazyWritePages                       dd ?
    uCcDataFlushes                          dd ?
    uCcDataPages                            dd ?
    uTotalContextSwitches                   dd ?
    uFirstLevelTbFills                      dd ?
    uSecondLevelTbFills                     dd ?
    uSystemCalls                            dd ?
ends

struct SYSTEM_TIME_INFORMATION
    liKeBootTime            LARGE_INTEGER
    liKeSystemTime          LARGE_INTEGER
    liExpTimeZoneBias       LARGE_INTEGER
    uExpCurrentTimeZoneId   dd ?
    dwUnknown1              dd ?
ends

struct SYSTEM_THREAD
    liKernelTime    xptr ?
    liUserTime      xptr ?
    liCreateTime    xptr ?
    WaitTime        dd   ?
    pStartAddress   xptr ?
    Cid             CLIENT_ID
    Priority        dd   ?
    BasePriority    dd   ?
    ContextSwitches dd   ?
    ThreadState     dd   ?
    WaitReason      dd   ?
    dwUnknown2      dd   ?
ends

struct SYSTEM_PROCESS_INFORMATION
    uNext                           dd ?
    uThreadCount                    dd ?
    liUnknown1                      LARGE_INTEGER
    liUnknown2                      LARGE_INTEGER
    liUnknown3                      LARGE_INTEGER
    liCreateTime                    LARGE_INTEGER
    liUserTime                      LARGE_INTEGER
    liKernelTime                    LARGE_INTEGER
    usName                          UNICODE_STRING
    BasePriority                    dd ?
    uUniqueProcessId                dd ?
    uInheritedFromUniqueProcessId   dd ?
    uHandleCount                    dd ?
    uSessionId                      dd ?
    dwUnknown5                      dd ?
    VmCounters                      VM_COUNTERS
    uCommitCharge                   dd ?
    aST                             SYSTEM_THREAD 2
ends

struct IO_COUNTERSEX
    ReadOperationCount  LARGE_INTEGER
    WriteOperationCount LARGE_INTEGER
    OtherOperationCount LARGE_INTEGER
    ReadTransferCount   LARGE_INTEGER
    WriteTransferCount  LARGE_INTEGER
    OtherTransferCount  LARGE_INTEGER
ends

struct SYSTEM_PROCESS_INFORMATION_2000
    uNext                           dd ?
    uThreadCount                    dd ?
    liUnknown1                      LARGE_INTEGER
    liUnknown2                      LARGE_INTEGER
    liUnknown3                      LARGE_INTEGER
    liCreateTime                    LARGE_INTEGER
    liUserTime                      LARGE_INTEGER
    liKernelTime                    LARGE_INTEGER
    usName                          UNICODE_STRING
    BasePriority                    dd ?
    uUniqueProcessId                dd ?
    uInheritedFromUniqueProcessId   dd ?
    uHandleCount                    dd ?
    uSessionId                      dd ?
    dwUnknown5                      dd ?
    VmCounters                      VM_COUNTERS
    uCommitCharge                   dd ?
    IoCounters                      IO_COUNTERSEX
    aST                             SYSTEM_THREAD 2
ends

struct SYSTEM_CONFIGURATION_INFORMATION
    uDiskCount      dd ?
    uFloppyCount    dd ?
    uCDRomCount     dd ?
    uTapeCount      dd ?
    uSerialCount    dd ?
    uParallelCount  dd ?
ends

struct SYSTEM_PROCESSOR_COUNTERS
    liProcessorTime     LARGE_INTEGER
    liKernelTime        LARGE_INTEGER
    liUserTime          LARGE_INTEGER
    liDpcTime           LARGE_INTEGER
    liInterruptTime     LARGE_INTEGER
    uInterruptCount     dd ?
    dwUnknown1          dd ?
ends

struct SYSTEM_GLOBAL_FLAG
    NtGlobalFlag    dd ?
ends

struct SYSTEM_CALL_TIME_INFORMATION
    Length          dd ?
    TotalCalls      dd ?
    TimeOfCalls     LARGE_INTEGER 2
ends

struct SYSTEM_MODULE
    Reserved            dd 2 dup(?)
    Base                dd ?
    Size                dd ?
    Flags               dd ?
    Index               dw ?
    _Unknown            dw ?
    LoadCount           dw ?
    ModuleNameOffset    dw ?
    ImageName           db MAX_SYSTEM_MODULE_NAME_LENGTH dup(?)
ends

if ~defined SYSTEM_MODULE_INFORMATION_DEFINED
    define SYSTEM_MODULE_INFORMATION_DEFINED 1
    struct SYSTEM_MODULE_INFORMATION
        uCount           dd   ?
        aSM              SYSTEM_MODULE 2
        Reserved         dd   2 dup(?)
        Base             xptr ?
        Size             dd   ?
        Flags            dd   ?
        Index            dw   ?
        _Unknown         dw   ?
        LoadCount        dw   ?
        ModuleNameOffset dw   ?
        ImageName        db   256 dup(?)
    ends
end if

struct SYSTEM_MODULE64
    Reserved         dd 2 dup(?)
    Base             dq ?
    Size             dd ?
    Flags            dd ?
    Index            dw ?
    _Unknown         dw ?
    LoadCount        dw ?
    ModuleNameOffset dw ?
    ImageName        db MAX_SYSTEM_MODULE_NAME_LENGTH dup(?)
ends

struct SYSTEM_MODULE_INFORMATION64
    uCount  dd ?
    aSM     SYSTEM_MODULE64 2
ends

struct SYSTEM_LOCK
    union
        pEResourceOld           xptr ?
        pEResourceLite          xptr ?
        pEResource              xptr ?
    ends
    wUnknown1                   dw   ?
    wUnknown2                   dw   ?
    ExclusiveOwnerThreadId      dd   ?
    uActiveCount                dd   ?
    uContentionCount            dd   ?
    dwUnknown3                  dd   ?
    dwUnknown4                  dd   ?
    uNumberOfSharedWaiters      dd   ?
    uNumberOfExclusiveWaiters   dd   ?
ends

struct SYSTEM_LOCK_INFORMATION
    uCount  dd ?
    aSL     SYSTEM_LOCK 2
ends

struct SYSTEM_HANDLE
    uIdProcess      dd   ?
    ObjectType      db   ?
    Flags           db   ?
    Handle          dw   ?
    pObject         xptr ?
    GrantedAccess   dd   ?
ends

struct SYSTEM_HANDLE_INFORMATION
    uCount  dd ?
    aSH     SYSTEM_HANDLE 2
ends

struct SYSTEM_OBJECTTYPE_INFORMATION
    NextEntryOffset     dd ?
    ObjectCount         dd ?
    HandleCount         dd ?
    TypeIndex           dd ?
    InvalidAttributes   dd ?
    GenericMapping      GENERIC_MAPPING
    ValidAccessMask     dd ?
    PoolType            dd ?
    SecurityRequired    db ?
    WaitableObject      db ?
    TypeName            UNICODE_STRING
ends

struct SYSTEM_OBJECT_INFORMATION
    NextEntryOffset         dd   ?
    Object                  xptr ?
    CreatorProcessId        dd   ?
    CreatorBackTraceIndex   dw ?
    Flags                   dw ?
    PointerCount            dd   ?
    HandleCount             dd   ?
    PagedPoolCharge         dd   ?
    NonPagedPoolCharge      dd   ?
    ExclusiveProcessId      dd   ?
    SecurityDescriptor      xptr ?
    ObjectName              UNICODE_STRING
ends

struct SYSTEM_PAGE_FILE_INFORMATION
    NextEntryOffset dd ?
    CurrentSize     dd ?
    TotalUsed       dd ?
    PeakUsed        dd ?
    FileName        UNICODE_STRING
ends

struct SYSTEM_VDM_INSTEMUL_INFO
    fExVdmSegmentNotPresent dd ?
    uOpcode0FV86            dd ?
    uOpcodeESPrefixV86      dd ?
    uOpcodeCSPrefixV86      dd ?
    uOpcodeSSPrefixV86      dd ?
    uOpcodeDSPrefixV86      dd ?
    uOpcodeFSPrefixV86      dd ?
    uOpcodeGSPrefixV86      dd ?
    uOpcodeOPER32PrefixV86  dd ?
    uOpcodeADDR32PrefixV86  dd ?
    uOpcodeINSBV86          dd ?
    uOpcodeINSWV86          dd ?
    uOpcodeOUTSBV86         dd ?
    uOpcodeOUTSWV86         dd ?
    uOpcodePUSHFV86         dd ?
    uOpcodePOPFV86          dd ?
    uOpcodeINTnnV86         dd ?
    uOpcodeINTOV86          dd ?
    uOpcodeIRETV86          dd ?
    uOpcodeINBimmV86        dd ?
    uOpcodeINWimmV86        dd ?
    uOpcodeOUTBimmV86       dd ?
    uOpcodeOUTWimmV86       dd ?
    uOpcodeINBV86           dd ?
    uOpcodeINWV86           dd ?
    uOpcodeOUTBV86          dd ?
    uOpcodeOUTWV86          dd ?
    uOpcodeLOCKPrefixV86    dd ?
    uOpcodeREPNEPrefixV86   dd ?
    uOpcodeREPPrefixV86     dd ?
    uOpcodeHLTV86           dd ?
    uOpcodeCLIV86           dd ?
    uOpcodeSTIV86           dd ?
    uVdmBopCount            dd ?
ends

struct SYSTEM_CACHE_INFORMATION
    uFileCache                  dd ?
    uFileCachePeak              dd ?
    PageFaultCount              dd ?
    MinimumWorkingSet           dd ?
    MaximumWorkingSet           dd ?
    TransitionSharedPages       dd ?
    TransitionSharedPagesPeak   dd ?
    Reserved                    dd 2 dup(?)
ends

struct SYSTEM_POOL_ENTRY
    Allocated               db   ?
    Spare0                  db   ?
    AllocatorBackTraceIndex dw   ?
    Size                    dd   ?
    union
        Tag                 db   4 dup(?)
        TagUlong            dd   ?
        ProcessChargedQuota xptr ?
    ends
ends

struct SYSTEM_POOL_INFORMATION
    TotalSize       dd   ?
    FirstEntry      xptr ?
    EntryOverhead   dw   ?
    PoolTagPresent  db   ?
    Spare0          db   ?
    NumberOfEntries dd   ?
    Entries         SYSTEM_POOL_ENTRY 2
ends

struct SYSTEM_POOL_TAG
    union
        Tag             db 4 dup(?)
        TagUlong        dd ?
    ends
    PagedPoolAllocs     dd ?
    PagedPoolFrees      dd ?
    PagedPoolUsage      dd ?
    NonPagedPoolAllocs  dd ?
    NonPagedPoolFrees   dd ?
    NonPagedPoolUsage   dd ?
ends

struct SYSTEM_POOL_TAG_INFORMATION
    uCount  dd ?
    aSPT    SYSTEM_POOL_TAG 2
ends

struct SYSTEM_INTERRUPT_INFORMATION
    ContextSwitches dd ?
    DpcCount        dd ?
    DpcRate         dd ?
    TimeIncrement   dd ?
    DpcBypassCount  dd ?
    ApcBypassCount  dd ?
ends

struct SYSTEM_DPC_INFORMATION
    dwUnknown1           dd ?
    MaximumDpcQueueDepth dd ?
    MinimumDpcRate       dd ?
    AdjustDpcThreshold   dd ?
    IdealDpcRate         dd ?
ends

struct SYSTEM_MEMORY_INFO
    StringOffset    xptr ?
    ValidCount      dw ?
    TransitionCount dw ?
    ModifiedCount   dw ?
    PageTableCount  dw ?
ends

struct SYSTEM_MEMORY_INFORMATION
    InfoSize    dd ?
    StringStart dd ?
    Memory      SYSTEM_MEMORY_INFO 2
ends

struct SYSTEM_LOAD_DRIVER
    DriverName      UNICODE_STRING
    BaseAddress     xptr ?
    SectionPointer  xptr ?
    EntryPoint      xptr ?
    ExportDirectory xptr ?
ends

struct SYSTEM_UNLOAD_DRIVER
    SectionPointer xptr ?
ends

struct SYSTEM_QUERY_TIME_ADJUSTMENT
    TimeAdjustment      dd ?
    MaximumIncrement    dd ?
    TimeSynchronization db ?
ends

struct SYSTEM_SET_TIME_ADJUSTMENT
    TimeAdjustment      dd ?
    TimeSynchronization db ?
ends

struct SYSTEM_CRASH_DUMP_INFORMATION
    CrashDumpSectionHandle  xptr ?
ends

struct SYSTEM_CRASH_DUMP_INFORMATION_2000
    CrashDumpSectionHandle  xptr ?
    _Unknown                xptr ?
ends

struct SYSTEM_EXCEPTION_INFORMATION
    AlignmentFixupCount     dd ?
    ExceptionDispatchCount  dd ?
    FloatingEmulationCount  dd ?
    ByteWordEmulationCount  dd ?
ends

struct SYSTEM_CRASH_DUMP_STATE_INFORMATION
    ValidCrashDump  dd ?
ends

struct SYSTEM_CRASH_DUMP_STATE_INFORMATION_2000
    ValidCrashDump  dd ?
    _Unknown        dd ?
ends

struct SYSTEM_DEBUGGER_INFORMATION
    KernelDebuggerEnabled       db ?
    KernelDebuggerNotPresent    db ?
ends

struct SYSTEM_CONTEXT_SWITCH_INFORMATION
    ContextSwitches dd ?
    FindAny         dd ?
    FindLast        dd ?
    FindIdeal       dd ?
    IdleAny         dd ?
    IdleCurrent     dd ?
    IdleLast        dd ?
    IdleIdeal       dd ?
    PreemptAny      dd ?
    PreemptCurrent  dd ?
    PreemptLast     dd ?
    SwitchToIdle    dd ?
ends

struct SYSTEM_REGISTRY_QUOTA_INFORMATION
    RegistryQuotaAllowed    dd ?
    RegistryQuotaUsed       dd ?
    PagedPoolSize           dd ?
ends

struct SYSTEM_ADD_DRIVER
    ModuleName UNICODE_STRING
ends

struct SYSTEM_PRIORITY_SEPARATION_INFORMATION
    PrioritySeparation  dd ?
ends

struct PLUGPLAY_BUS_TYPE
    BusClass                    dd ?
    union
        SystemBusType           dd ?
        PlugPlayVirtualBusType  dd ?
    ends
ends

struct PLUGPLAY_BUS_INSTANCE
    BusType     PLUGPLAY_BUS_TYPE
    BusNumber   dd ?
    BusName     dw MAX_BUS_NAME dup(?)
ends

struct SYSTEM_PLUGPLAY_BUS_INFORMATION
    BusCount    dd ?
    BusInstance PLUGPLAY_BUS_INSTANCE 2
ends

struct SYSTEM_DOCK_INFORMATION
    DockState       dd ?
    DeviceBusType   dd ?
    DeviceBusNumber dd ?
    SlotNumber      dd ?
ends

struct SYSTEM_POWER_INFORMATION
    SystemSuspendSupported          db ?
    SystemHibernateSupported        db ?
    ResumeTimerSupportsSuspend      db ?
    ResumeTimerSupportsHibernate    db ?
    LidSupported                    db ?
    TurboSettingSupported           db ?
    TurboMode                       db ?
    SystemAcOrDc                    db ?
    PowerDownDisabled               db ?
    SpindownDrives                  LARGE_INTEGER
ends

struct SYSTEM_PROCESSOR_SPEED_INFORMATION
    MaximumProcessorSpeed   dd ?
    CurrentAvailableSpeed   dd ?
    ConfiguredSpeedLimit    dd ?
    PowerLimit              db ?
    ThermalLimit            db ?
    TurboLimit              db ?
ends

struct SYSTEM_TIME_ZONE_INFORMATION
    Bias            dd ?
    StandardName    dw 32 dup(?)
    StandardDate    TIME_FIELDS
    StandardBias    dd ?
    DaylightName    dw 32 dup(?)
    DaylightDate    TIME_FIELDS
    DaylightBias    dd ?
ends

struct SYSTEM_LOOKASIDE
    Depth           dw ?
    MaximumDepth    dw ?
    TotalAllocates  dd ?
    AllocateMisses  dd ?
    TotalFrees      dd ?
    FreeMisses      dd ?
    Type            dd ?
    Tag             dd ?
    Size            dd ?
ends

struct SYSTEM_LOOKASIDE_INFORMATION
    asl SYSTEM_LOOKASIDE
ends

struct SYSTEM_SET_TIME_SLIP_EVENT
    TimeSlipEvent   xptr ?
ends

struct SYSTEM_CREATE_SESSION
    Session dd ?
ends

struct SYSTEM_DELETE_SESSION
    Session dd ?
ends

struct SYSTEM_RANGE_START_INFORMATION
    SystemRangeStart xptr ?
ends

struct FILE_DIRECTORY_INFORMATION
    NextEntryOffset dd ?
    FileIndex       dd ?
    CreationTime    LARGE_INTEGER
    LastAccessTime  LARGE_INTEGER
    LastWriteTime   LARGE_INTEGER
    ChangeTime      LARGE_INTEGER
    EndOfFile       LARGE_INTEGER
    AllocationSize  LARGE_INTEGER
    FileAttributes  dd ?
    FileNameLength  dd ?
    FileName        dw 2 dup(?)
ends

struct FILE_FULL_DIR_INFORMATION
    NextEntryOffset dd ?
    FileIndex       dd ?
    CreationTime    LARGE_INTEGER
    LastAccessTime  LARGE_INTEGER
    LastWriteTime   LARGE_INTEGER
    ChangeTime      LARGE_INTEGER
    EndOfFile       LARGE_INTEGER
    AllocationSize  LARGE_INTEGER
    FileAttributes  dd ?
    FileNameLength  dd ?
    EaSize          dd ?
    FileName        dw 2 dup(?)
ends

struct FILE_BOTH_DIR_INFORMATION
    NextEntryOffset dd ?
    FileIndex       dd ?
    CreationTime    LARGE_INTEGER
    LastAccessTime  LARGE_INTEGER
    LastWriteTime   LARGE_INTEGER
    ChangeTime      LARGE_INTEGER
    EndOfFile       LARGE_INTEGER
    AllocationSize  LARGE_INTEGER
    FileAttributes  dd ?
    FileNameLength  dd ?
    EaSize          dd ?
    ShortNameLength db ?
    ShortName       dw 12 dup(?)
    FileName        dw 2 dup(?)
ends

struct FILE_BASIC_INFORMATION
    CreationTime    LARGE_INTEGER
    LastAccessTime  LARGE_INTEGER
    LastWriteTime   LARGE_INTEGER
    ChangeTime      LARGE_INTEGER
    FileAttributes  dd ?
ends

struct FILE_STANDARD_INFORMATION
    AllocationSize  LARGE_INTEGER
    EndOfFile       LARGE_INTEGER
    NumberOfLinks   dd ?
    DeletePending   db ?
    Directory       db ?
ends
                                                            
struct FILE_INTERNAL_INFORMATION
    IndexNumber LARGE_INTEGER
ends

struct FILE_EA_INFORMATION
    EaSize dd ?
ends

struct FILE_ACCESS_INFORMATION
    AccessFlags dd ?
ends

struct FILE_NAME_INFORMATION
    FileNameLength  dd ?
    FileName        dw 2 dup(?)
ends

struct FILE_RENAME_INFORMATION
    ReplaceIfExists db ?
    RootDirectory   xptr ?
    FileNameLength  dd ?
    FileName        dw 2 dup(?)
ends

struct FILE_LINK_INFORMATION
    ReplaceIfExists db ?
    RootDirectory   xptr ?
    FileNameLength  dd ?
    FileName        dw 2 dup(?)
ends

struct FILE_NAMES_INFORMATION
    NextEntryOffset dd ?
    FileIndex       dd ?
    FileNameLength  dd ?
    FileName        dw 2 dup(?)
ends

struct FILE_ALLOCATION_INFORMATION
    AllocationSize LARGE_INTEGER
ends

struct FILE_COMPRESSION_INFORMATION
    CompressedFileSize   LARGE_INTEGER
    CompressionFormat    dw ?
    CompressionUnitShift db ?
    ChunkShift           db ?
    ClusterShift         db ?
    Reserved             db 3 dup(?)
ends

struct FILE_COMPLETION_INFORMATION
    Port    xptr ?
    Key     dd    ?
ends

struct KEY_VALUE_BASIC_INFORMATION
    TitleIndex  dd ?
    Type        dd ?
    NameLength  dd ?
    _Name       dw 2 dup(?)
ends

struct KEY_VALUE_FULL_INFORMATION
    TitleIndex  dd ?
    Type        dd ?
    DataOffset  dd ?
    DataLength  dd ?
    NameLength  dd ?
    _Name       dw 2 dup(?)
ends

struct KEY_VALUE_PARTIAL_INFORMATION
    TitleIndex  dd ?
    Type        dd ?
    DataLength  dd ?
    Data        db 2 dup(?)
ends

struct KEY_NODE_INFORMATION
    LastWriteTime   LARGE_INTEGER
    TitleIndex      dd ?
    ClassOffset     dd ?
    ClassLength     dd ?
    NameLength      dd ?
    _Name           dw 2 dup(?)
ends

struct KEY_NAME_INFORMATION
    NameLength  dd ?
    _Name       dw 2 dup(?)
ends

struct PROCESS_BASIC_INFORMATION32
    ExitStatus                      dd ?
    PebBaseAddress                  dd ?
    AffinityMask                    dd ?
    BasePriority                    dd ?
    uUniqueProcessId                dd ?
    uInheritedFromUniqueProcessId   dd ?
ends

struct PROCESS_BASIC_INFORMATION64
    ExitStatus                      dd ?
    Reserved0                       dd ?
    PebBaseAddress                  dq ?
    AffinityMask                    dq ?
    BasePriority                    dd ?
    Reserved1                       dd ?
    uUniqueProcessId                dq ?
    uInheritedFromUniqueProcessId   dq ?
ends

struct PROCESS_BASIC_INFORMATION
    ExitStatus                      dd ?
    PebBaseAddress                  xptr ?
    AffinityMask                    xptr ?
    BasePriority                    dd ?
    uUniqueProcessId                xptr ?
    uInheritedFromUniqueProcessId   dd ?
ends

struct PROCESS_RAISE_PRIORITY
    RaisePriority dd ?
ends

struct PROCESS_DEBUG_PORT_INFORMATION
    DebugPort xptr ?
ends

struct PROCESS_EXCEPTION_PORT
    ExceptionPort xptr ?
ends

struct PROCESS_ACCESS_TOKEN
    Token   xptr ?
    Thread  xptr ?
ends

struct PROCESS_WOW64_INFORMATION
    Wow64PebBaseAddress xptr ?
ends

if ~defined LDT_ENTRY_DEFINED
    define LDT_ENTRY_DEFINED 1

    struct LDT_ENTRY
        LimitLow dw ?
        BaseLow  dw ?
        union
            struct
                BaseMid db ?
                Flags1  db ?
                Flags2  db ?
                BaseHi  db ?
            ends
            struct
                LDTBits dd ?
            ends
        ends
    ends
    LDT_TABLE_SIZE equ (8 * 1024 * sizeof.LDT_ENTRY)
end if

struct PROCESS_LDT_INFORMATION
    Start       dd ?
    Length      dd ?
    LdtEntries  LDT_ENTRY 2
ends

struct PROCESS_LDT_SIZE
    Length dd ?
ends

struct PROCESS_DEFAULT_HARDERROR_MODE_INFORMATION
    HardErrorMode dd ?
ends

struct PROCESS_POOLED_USAGE_AND_LIMITS_INFORMATION
    PeakPagedPoolUsage      dd ?
    PagedPoolUsage          dd ?
    PagedPoolLimit          dd ?
    PeakNonPagedPoolUsage   dd ?
    NonPagedPoolUsage       dd ?
    NonPagedPoolLimit       dd ?
    PeakPagefileUsage       dd ?
    PagefileUsage           dd ?
    PagefileLimit           dd ?
ends

struct PROCESS_WS_WATCH_INFORMATION
    FaultingPc  xptr ?
    FaultingVa  xptr ?
ends

struct PROCESS_IOPL
    Iopl dd ?
ends

struct PROCESS_ALLIGNMENT_FAULT_FIXUP
    EnableAllignmentFaultFixup db ?
ends

struct PROCESS_PRIORITY_CLASS_INFORMATION
    _Unknown        db ?
    PriorityClass   db ?
ends

struct PROCESS_X86_INFORMATION
    x86Info dd ?
ends

struct PROCESS_HANDLE_COUNT_INFORMATION
    HandleCount dd ?
ends

struct PROCESS_PRIORITY_BOOST_INFORMATION
    PriorityBoostEnabled dd ?
ends

struct PROCESS_DEVICE_MAP_INFORMATION
    union
        struct
            DirectoryHandle xptr ?
        ends
        struct
            DriveMap        dd    ?
            DriveType       db    32 dup(?)
        ends
    ends
ends

struct PROCESS_SESSION_INFORMATION
    SessionId dd ?
ends

struct USER_STACK
    FixedStackBase          xptr ?
    FixedStackLimit         xptr ?
    ExpandableStackBase     xptr ?
    ExpandableStackLimit    xptr ?
    ExpandableStackBottom   xptr ?
ends

struct THREAD_BASIC_INFORMATION
    ExitStatus      dd   ?
    TebBaseAddress  xptr ?
    ClientId        CLIENT_ID
    AffinityMask    xptr ?
    Priority        dd ?
    BasePriority    dd ?
ends

struct THREAD_PRIORITY
    Priority dd ?
ends

struct THREAD_DESCRIPTOR_TABLE_ENTRY_INFORMATION
    Selector    dd ?
    Descriptor  LDT_ENTRY
ends

struct THREAD_EVENTPAIR
    EventPair xptr ?
ends

struct THREAD_WIN32_START_ADDRESS_INFORMATION
    Win32StartAddress xptr ?
ends

struct THREAD_ZERO_TLSCELL
    TlsIndex dd ?
ends

struct THREAD_PERFORMANCE_COUNTER_INFORMATION
    Count1 dd ?
    Count2 dd ?
ends

struct THREAD_AMI_LAST_THREAD
    AmILastThread dd ?
ends

struct THREAD_IDEAL_PROCESSOR
    IdealProcessor dd ?
ends

struct THREAD_TLS_ARRAY
    TlsArray    xptr ?
ends

struct THREAD_IS_IO_PENDING_INFORMATION
    IsIOPending dd ?
ends

struct THREAD_HIDE_FROM_DEBUGGER
    HideFromDebugger dd ?
ends

struct SECTION_BASIC_INFORMATION
    BaseAddress xptr ?
    Attributes  dd   ?
    Size        LARGE_INTEGER
ends

struct SECTION_IMAGE_INFORMATION
    EntryPoint              xptr ?
    Unknown1                dd ?
    StackReserve            dd ?
    StackCommit             dd ?
    Subsystem               dd ?
    MinorSubsystemVersion   dw ?
    MajorSubsystemVersion   dw ?
    Unknown2                dd ?
    Characteristics         dd ?
    ImageNumber             dw ?
    Executable              db ?
    Unknown3                db ?
    Unknown4                dd 3 dup(?)
ends

struct OBJECT_BASIC_INFORMATION
    Attributes                  dd ?
    GrantedAccess               dd ?
    HandleCount                 dd ?
    PointerCount                dd ?
    PagedPoolUsage              dd ?
    NonPagedPoolUsage           dd ?
    Reserved                    dd 3 dup(?)
    NameInformationLength       dd ?
    TypeInformationLength       dd ?
    SecurityDescriptorLength    dd ?
    CreateTime                  LARGE_INTEGER
ends

struct OBJECT_NAME_INFORMATION
    _Name UNICODE_STRING
ends

struct OBJECT_TYPE_INFORMATION
    _Name                   UNICODE_STRING
    ObjectCount             dd ?
    HandleCount             dd ?
    Reserved1               dd 4 dup(?)
    PeakObjectCount         dd ?
    PeakHandleCount         dd ?
    Reserved2               dd 4 dup(?)
    InvalidAttributes       dd ?
    GenericMapping          GENERIC_MAPPING
    ValidAccess             dd ?
    _Unknown                db ?
    MaintainHandleDatabase  db ?
    Reserved3               db 2 dup(?)
    PoolType                dd ?
    PagedPoolUsage          dd ?
    NonPagedPoolUsage       dd ?
ends

struct OBJECT_ALL_TYPES_INFORMATION
    NumberOfTypes   dd ?
    TypeInformation OBJECT_TYPE_INFORMATION
ends

struct OBJECT_HANDLE_ATTRIBUTE_INFORMATION
    Inherit             db ?
    ProtectFromClose    db ?
ends

if ~defined MEMORY_BASIC_INFORMATION_DEFINED
    define MEMORY_BASIC_INFORMATION_DEFINED 1
    struct MEMORY_BASIC_INFORMATION
		BaseAddress         xptr ?
		AllocationBase      xptr ?
		AllocationProtect   dd   ?
        PartitionId         dw   ?
		RegionSize          xptr ?
		State               dd   ?
		Protect             dd   ?
		Type                dd   ?
    ends
end if

struct MEMORY_WORKING_SET_LIST
    NumberOfPages   dd ?
    WorkingSetList  dd 2 dup(?)
ends

struct MEMORY_SECTION_NAME
    SectionFileName UNICODE_STRING
ends

struct DEBUG_BUFFER
    SectionHandle           xptr ?
    SectionBase             xptr  ?
    RemoteSectionBase       xptr  ?
    SectionBaseDelta        dd    ?
    EventPairHandle         xptr ?
    _Unknown                dd    2 dup(?)
    RemoteThreadHandle      xptr ?
    InfoClassMask           dd    ?
    SizeOfInfo              dd    ?
    AllocatedSize           dd    ?
    SectionSize             dd    ?
    ModuleInformation       xptr  ?
    BackTraceInformation    xptr  ?
    HeapInformation         xptr  ?
    LockInformation         xptr  ?
    Reserved                xptr  8 dup(?)
ends

struct DEBUG_MODULE_INFORMATION
    Reserved            dd 2 dup(?)
    Base                dd ?
    Size                dd ?
    Flags               dd ?
    Index               dw ?
    _Unknown            dw ?
    LoadCount           dw ?
    ModuleNameOffset    dw ?
    ImageName           db 256 dup(?)
ends

struct DEBUG_HEAP_INFORMATION
    Base        dd   ?
    Flags       dd   ?
    Granularity dw   ?
    _Unknown    dw   ?
    Allocated   dd   ?
    Committed   dd   ?
    TagCount    dd   ?
    BlockCount  dd   ?
    Reserved    dd   7 dup(?)
    Tags        xptr ?
    Blocks      xptr ?
ends

struct DEBUG_LOCK_INFORMATION
    Address                     xptr ?
    Type                        dw   ?
    CreatorBackTraceIndex       dw   ?
    OwnerThreadId               dd   ?
    ActiveCount                 dd   ?
    ContentionCount             dd   ?
    EntryCount                  dd   ?
    RecursionCount              dd   ?
    NumberOfSharedWaiters       dd   ?
    NumberOfExclusiveWaiters    dd   ?
ends

struct PORT_SECTION_WRITE
    Length          dd   ?
    SectionHandle   xptr ?
    SectionOffset   dd   ?
    ViewSize        dd   ?
    ViewBase        xptr ?
    TargetViewBase  xptr ?
ends

struct PORT_SECTION_READ
    Length      dd   ?
    ViewSize    dd   ?
    ViewBase    xptr ?
ends

if ~defined CONTEXT32_DEFINED
    define CONTEXT32_DEFINED 1
    struct CONTEXT32
        ContextFlags        dd ?
        _Dr0                dd ?
        _Dr1                dd ?
        _Dr2                dd ?
        _Dr3                dd ?
        _Dr6                dd ?
        _Dr7                dd ?
        FloatSave           FLOATING_SAVE_AREA
        SegGs               dd ?
        SegFs               dd ?
        SegEs               dd ?
        SegDs               dd ?
        _Edi                dd ?
        _Esi                dd ?
        _Ebx                dd ?
        _Edx                dd ?
        _Ecx                dd ?
        _Eax                dd ?
        _Ebp                dd ?
        _Eip                dd ?
        SegCs               dd ?
        EFlags              dd ?
        _Esp                dd ?
        SegSs               dd ?
        ExtendedRegisters   db MAXIMUM_SUPPORTED_EXTENSION dup(?)
    ends
end if

struct SCOPE_RECORD
    BeginAddress    dd ?
    EndAddress      dd ?
    HandlerAddress  dd ?
    JumpTarget      dd ?
ends

struct SCOPE_TABLE
    Count          dd ?
    ScopeRecord    SCOPE_RECORD 2
ends

struct EXCEPTION_DATA
    union
        ExceptionHandler dd ?
        FunctionEntry    dd ?
    ends
    ScopeTable          SCOPE_TABLE
ends

if ~defined XMM_SAVE_AREA32_DEFINED
    define XMM_SAVE_AREA32_DEFINED 1
    struct XMM_SAVE_AREA32
        ControlWord     dw ?
        StatusWord      dw ?
        TagWord         db ?
        Reserved1       db ?
        ErrorOpcode     dw ?
        ErrorOffset     dd ?
        ErrorSelector   dw ?
        Reserved2       dw ?
        DataOffset      dd ?
        DataSelector    dw ?
        Reserved3       dw ?
        MxCsr           dd ?
        MxCsr_Mask      dd ?
        FloatRegisters  M128A 8
        XmmRegisters    M128A 16
        Reserved4       db 96 dup(?)
    ends
end if

if ~defined CONTEXT64_DEFINED
    define CONTEXT64_DEFINED 1
    struct CONTEXT64
        P1Home                  dq ?
        P2Home                  dq ?
        P3Home                  dq ?
        P4Home                  dq ?
        P5Home                  dq ?
        P6Home                  dq ?
        ContextFlags            dd ?
        MxCsr                   dd ?
        SegCs                   dw ?
        SegDs                   dw ?
        SegEs                   dw ?
        SegFs                   dw ?
        SegGs                   dw ?
        SegSs                   dw ?
        EFlags                  dd ?
        _Dr0                    dq ?
        _Dr1                    dq ?
        _Dr2                    dq ?
        _Dr3                    dq ?
        _Dr6                    dq ?
        _Dr7                    dq ?
        _Rax                    dq ?
        _Rcx                    dq ?
        _Rdx                    dq ?
        _Rbx                    dq ?
        _Rsp                    dq ?
        _Rbp                    dq ?
        _Rsi                    dq ?
        _Rdi                    dq ?
        _R8                     dq ?
        _R9                     dq ?
        _R10                    dq ?
        _R11                    dq ?
        _R12                    dq ?
        _R13                    dq ?
        _R14                    dq ?
        _R15                    dq ?
        _Rip                    dq ?
        union
            FltSave             XMM_SAVE_AREA32
            struct 
                Header          M128A 2
                Legacy          M128A 8
                _Xmm0           M128A
                _Xmm1           M128A
                _Xmm2           M128A
                _Xmm3           M128A
                _Xmm4           M128A
                _Xmm5           M128A
                _Xmm6           M128A
                _Xmm7           M128A
                _Xmm8           M128A
                _Xmm9           M128A
                _Xmm10          M128A
                _Xmm11          M128A
                _Xmm12          M128A
                _Xmm13          M128A
                _Xmm14          M128A
                _Xmm15          M128A
            ends
        ends
        VectorRegister          M128A 26
        VectorControl           dq ?
        DebugControl            dq ?
        LastBranchToRip         dq ?
        LastBranchFromRip       dq ?
        LastExceptionToRip      dq ?
        LastExceptionFromRip    dq ?
    ends
end if

struct IMAGE_BASE_RELOCATION_EX
    VirtualAddress  dd ?
    SizeOfBlock     dd ?
    TypeOffset      dw 2 dup(?)
ends

;======================================== Functions =======================================;
import ntdll,\
__isascii,'__isascii',\
__iscsym,'__iscsym',\
__iscsymf,'__iscsymf',\
__toascii,'__toascii',\
_atoi64,'_atoi64',\
_errno,'_errno',\
_i64toa,'_i64toa',\
_i64toa_s,'_i64toa_s',\
_i64tow,'_i64tow',\
_i64tow_s,'_i64tow_s',\
_itoa,'_itoa',\
_itoa_s,'_itoa_s',\
_itow,'_itow',\
_itow_s,'_itow_s',\
_lfind,'_lfind',\
_local_unwind,'_local_unwind',\
_ltoa,'_ltoa',\
_ltoa_s,'_ltoa_s',\
_ltow,'_ltow',\
_ltow_s,'_ltow_s',\
_makepath_s,'_makepath_s',\
_memccpy,'_memccpy',\
_memicmp,'_memicmp',\
_setjmp,'_setjmp',\
_setjmpex,'_setjmpex',\
_snprintf,'_snprintf',\
_snprintf_s,'_snprintf_s',\
_snscanf_s,'_snscanf_s',\
_snwprintf,'_snwprintf',\
_snwprintf_s,'_snwprintf_s',\
_snwscanf_s,'_snwscanf_s',\
_splitpath,'_splitpath',\
_splitpath_s,'_splitpath_s',\
_strcmpi,'_strcmpi',\
_stricmp,'_stricmp',\
_strlwr,'_strlwr',\
_strlwr_s,'_strlwr_s',\
_strnicmp,'_strnicmp',\
_strnset_s,'_strnset_s',\
_strset_s,'_strset_s',\
_strupr,'_strupr',\
_strupr_s,'_strupr_s',\
_swprintf,'_swprintf',\
_ui64toa,'_ui64toa',\
_ui64toa_s,'_ui64toa_s',\
_ui64tow,'_ui64tow',\
_ui64tow_s,'_ui64tow_s',\
_ultoa,'_ultoa',\
_ultoa_s,'_ultoa_s',\
_ultow,'_ultow',\
_ultow_s,'_ultow_s',\
_vscprintf,'_vscprintf',\
_vscwprintf,'_vscwprintf',\
_vsnprintf,'_vsnprintf',\
_vsnprintf_s,'_vsnprintf_s',\
_vsnwprintf,'_vsnwprintf',\
_vsnwprintf_s,'_vsnwprintf_s',\
_vswprintf,'_vswprintf',\
_wcsicmp,'_wcsicmp',\
_wcslwr,'_wcslwr',\
_wcslwr_s,'_wcslwr_s',\
_wcsnicmp,'_wcsnicmp',\
_wcsnset_s,'_wcsnset_s',\
_wcsset_s,'_wcsset_s',\
_wcstoi64,'_wcstoi64',\
_wcstoui64,'_wcstoui64',\
_wcsupr,'_wcsupr',\
_wcsupr_s,'_wcsupr_s',\
_wmakepath_s,'_wmakepath_s',\
_wsplitpath_s,'_wsplitpath_s',\
_wtoi,'_wtoi',\
_wtoi64,'_wtoi64',\
_wtol,'_wtol',\
A_SHAFinal,'A_SHAFinal',\
A_SHAInit,'A_SHAInit',\
A_SHAUpdate,'A_SHAUpdate',\
abs,'abs',\
AlpcAdjustCompletionListConcurrencyCount,'AlpcAdjustCompletionListConcurrencyCount',\
AlpcFreeCompletionListMessage,'AlpcFreeCompletionListMessage',\
AlpcGetCompletionListLastMessageInformation,'AlpcGetCompletionListLastMessageInformation',\
AlpcGetCompletionListMessageAttributes,'AlpcGetCompletionListMessageAttributes',\
AlpcGetHeaderSize,'AlpcGetHeaderSize',\
AlpcGetMessageAttribute,'AlpcGetMessageAttribute',\
AlpcGetMessageFromCompletionList,'AlpcGetMessageFromCompletionList',\
AlpcGetOutstandingCompletionListMessageCount,'AlpcGetOutstandingCompletionListMessageCount',\
AlpcInitializeMessageAttribute,'AlpcInitializeMessageAttribute',\
AlpcMaxAllowedMessageLength,'AlpcMaxAllowedMessageLength',\
AlpcRegisterCompletionList,'AlpcRegisterCompletionList',\
AlpcRegisterCompletionListWorkerThread,'AlpcRegisterCompletionListWorkerThread',\
AlpcRundownCompletionList,'AlpcRundownCompletionList',\
AlpcUnregisterCompletionList,'AlpcUnregisterCompletionList',\
AlpcUnregisterCompletionListWorkerThread,'AlpcUnregisterCompletionListWorkerThread',\
ApiSetQueryApiSetPresence,'ApiSetQueryApiSetPresence',\
ApiSetQueryApiSetPresenceEx,'ApiSetQueryApiSetPresenceEx',\
atan,'atan',\
atan2,'atan2',\
atoi,'atoi',\
atol,'atol',\
bsearch,'bsearch',\
bsearch_s,'bsearch_s',\
ceil,'ceil',\
cos,'cos',\
CsrAllocateCaptureBuffer,'CsrAllocateCaptureBuffer',\
CsrAllocateMessagePointer,'CsrAllocateMessagePointer',\
CsrCaptureMessageBuffer,'CsrCaptureMessageBuffer',\
CsrCaptureMessageMultiUnicodeStringsInPlace,'CsrCaptureMessageMultiUnicodeStringsInPlace',\
CsrCaptureMessageString,'CsrCaptureMessageString',\
CsrCaptureTimeout,'CsrCaptureTimeout',\
CsrClientCallServer,'CsrClientCallServer',\
CsrClientConnectToServer,'CsrClientConnectToServer',\
CsrFreeCaptureBuffer,'CsrFreeCaptureBuffer',\
CsrGetProcessId,'CsrGetProcessId',\
CsrIdentifyAlertableThread,'CsrIdentifyAlertableThread',\
CsrSetPriorityClass,'CsrSetPriorityClass',\
CsrVerifyRegion,'CsrVerifyRegion',\
DbgBreakPoint,'DbgBreakPoint',\
DbgPrint,'DbgPrint',\
DbgPrintEx,'DbgPrintEx',\
DbgPrintReturnControlC,'DbgPrintReturnControlC',\
DbgPrompt,'DbgPrompt',\
DbgQueryDebugFilterState,'DbgQueryDebugFilterState',\
DbgSetDebugFilterState,'DbgSetDebugFilterState',\
DbgUiConnectToDbg,'DbgUiConnectToDbg',\
DbgUiContinue,'DbgUiContinue',\
DbgUiConvertStateChangeStructure,'DbgUiConvertStateChangeStructure',\
DbgUiConvertStateChangeStructureEx,'DbgUiConvertStateChangeStructureEx',\
DbgUiDebugActiveProcess,'DbgUiDebugActiveProcess',\
DbgUiGetThreadDebugObject,'DbgUiGetThreadDebugObject',\
DbgUiIssueRemoteBreakin,'DbgUiIssueRemoteBreakin',\
DbgUiRemoteBreakin,'DbgUiRemoteBreakin',\
DbgUiSetThreadDebugObject,'DbgUiSetThreadDebugObject',\
DbgUiStopDebugging,'DbgUiStopDebugging',\
DbgUiWaitStateChange,'DbgUiWaitStateChange',\
DbgUserBreakPoint,'DbgUserBreakPoint',\
EtwCreateTraceInstanceId,'EtwCreateTraceInstanceId',\
EtwDeliverDataBlock,'EtwDeliverDataBlock',\
EtwEnumerateProcessRegGuids,'EtwEnumerateProcessRegGuids',\
EtwEventActivityIdControl,'EtwEventActivityIdControl',\
EtwEventEnabled,'EtwEventEnabled',\
EtwEventProviderEnabled,'EtwEventProviderEnabled',\
EtwEventRegister,'EtwEventRegister',\
EtwEventSetInformation,'EtwEventSetInformation',\
EtwEventUnregister,'EtwEventUnregister',\
EtwEventWrite,'EtwEventWrite',\
EtwEventWriteEndScenario,'EtwEventWriteEndScenario',\
EtwEventWriteEx,'EtwEventWriteEx',\
EtwEventWriteFull,'EtwEventWriteFull',\
EtwEventWriteNoRegistration,'EtwEventWriteNoRegistration',\
EtwEventWriteStartScenario,'EtwEventWriteStartScenario',\
EtwEventWriteString,'EtwEventWriteString',\
EtwEventWriteTransfer,'EtwEventWriteTransfer',\
EtwGetTraceEnableFlags,'EtwGetTraceEnableFlags',\
EtwGetTraceEnableLevel,'EtwGetTraceEnableLevel',\
EtwGetTraceLoggerHandle,'EtwGetTraceLoggerHandle',\
EtwLogTraceEvent,'EtwLogTraceEvent',\
EtwNotificationRegister,'EtwNotificationRegister',\
EtwNotificationUnregister,'EtwNotificationUnregister',\
EtwpCreateEtwThread,'EtwpCreateEtwThread',\
EtwpGetCpuSpeed,'EtwpGetCpuSpeed',\
EtwProcessPrivateLoggerRequest,'EtwProcessPrivateLoggerRequest',\
EtwRegisterSecurityProvider,'EtwRegisterSecurityProvider',\
EtwRegisterTraceGuidsA,'EtwRegisterTraceGuidsA',\
EtwRegisterTraceGuidsW,'EtwRegisterTraceGuidsW',\
EtwReplyNotification,'EtwReplyNotification',\
EtwSendNotification,'EtwSendNotification',\
EtwSetMark,'EtwSetMark',\
EtwTraceEventInstance,'EtwTraceEventInstance',\
EtwTraceMessage,'EtwTraceMessage',\
EtwUnregisterTraceGuids,'EtwUnregisterTraceGuids',\
EtwWriteUMSecurityEvent,'EtwWriteUMSecurityEvent',\
EvtIntReportAuthzEventAndSourceAsync,'EvtIntReportAuthzEventAndSourceAsync',\
EvtIntReportEventAndSourceAsync,'EvtIntReportEventAndSourceAsync',\
floor,'floor',\
isalnum,'isalnum',\
isalpha,'isalpha',\
iscntrl,'iscntrl',\
isdigit,'isdigit',\
isgraph,'isgraph',\
islower,'islower',\
isprint,'isprint',\
ispunct,'ispunct',\
isspace,'isspace',\
isupper,'isupper',\
iswalnum,'iswalnum',\
iswalpha,'iswalpha',\
iswascii,'iswascii',\
iswctype,'iswctype',\
iswdigit,'iswdigit',\
iswgraph,'iswgraph',\
iswlower,'iswlower',\
iswprint,'iswprint',\
iswspace,'iswspace',\
iswxdigit,'iswxdigit',\
isxdigit,'isxdigit',\
KiRaiseUserExceptionDispatcher,'KiRaiseUserExceptionDispatcher',\
KiUserApcDispatcher,'KiUserApcDispatcher',\
KiUserCallbackDispatcher,'KiUserCallbackDispatcher',\
KiUserExceptionDispatcher,'KiUserExceptionDispatcher',\
labs,'labs',\
LdrAccessResource,'LdrAccessResource',\
LdrAddDllDirectory,'LdrAddDllDirectory',\
LdrAddLoadAsDataTable,'LdrAddLoadAsDataTable',\
LdrAddRefDll,'LdrAddRefDll',\
LdrAppxHandleIntegrityFailure,'LdrAppxHandleIntegrityFailure',\
LdrCallEnclave,'LdrCallEnclave',\
LdrControlFlowGuardEnforced,'LdrControlFlowGuardEnforced',\
LdrCreateEnclave,'LdrCreateEnclave',\
LdrDeleteEnclave,'LdrDeleteEnclave',\
LdrDisableThreadCalloutsForDll,'LdrDisableThreadCalloutsForDll',\
LdrEnumerateLoadedModules,'LdrEnumerateLoadedModules',\
LdrEnumResources,'LdrEnumResources',\
LdrFastFailInLoaderCallout,'LdrFastFailInLoaderCallout',\
LdrFindEntryForAddress,'LdrFindEntryForAddress',\
LdrFindResource_U,'LdrFindResource_U',\
LdrFindResourceDirectory_U,'LdrFindResourceDirectory_U',\
LdrFindResourceEx_U,'LdrFindResourceEx_U',\
LdrFlushAlternateResourceModules,'LdrFlushAlternateResourceModules',\
LdrGetDllDirectory,'LdrGetDllDirectory',\
LdrGetDllFullName,'LdrGetDllFullName',\
LdrGetDllHandle,'LdrGetDllHandle',\
LdrGetDllHandleByMapping,'LdrGetDllHandleByMapping',\
LdrGetDllHandleByName,'LdrGetDllHandleByName',\
LdrGetDllHandleEx,'LdrGetDllHandleEx',\
LdrGetDllPath,'LdrGetDllPath',\
LdrGetFailureData,'LdrGetFailureData',\
LdrGetFileNameFromLoadAsDataTable,'LdrGetFileNameFromLoadAsDataTable',\
LdrGetKnownDllSectionHandle,'LdrGetKnownDllSectionHandle',\
LdrGetProcedureAddress,'LdrGetProcedureAddress',\
LdrGetProcedureAddressEx,'LdrGetProcedureAddressEx',\
LdrGetProcedureAddressForCaller,'LdrGetProcedureAddressForCaller',\
LdrInitializeEnclave,'LdrInitializeEnclave',\
LdrInitializeThunk,'LdrInitializeThunk',\
LdrInitShimEngineDynamic,'LdrInitShimEngineDynamic',\
LdrIsModuleSxsRedirected,'LdrIsModuleSxsRedirected',\
LdrLoadAlternateResourceModule,'LdrLoadAlternateResourceModule',\
LdrLoadAlternateResourceModuleEx,'LdrLoadAlternateResourceModuleEx',\
LdrLoadDll,'LdrLoadDll',\
LdrLoadEnclaveModule,'LdrLoadEnclaveModule',\
LdrLockLoaderLock,'LdrLockLoaderLock',\
LdrOpenImageFileOptionsKey,'LdrOpenImageFileOptionsKey',\
LdrpResGetMappingSize,'LdrpResGetMappingSize',\
LdrpResGetResourceDirectory,'LdrpResGetResourceDirectory',\
LdrProcessRelocationBlock,'LdrProcessRelocationBlock',\
LdrProcessRelocationBlockEx,'LdrProcessRelocationBlockEx',\
LdrQueryImageFileExecutionOptions,'LdrQueryImageFileExecutionOptions',\
LdrQueryImageFileExecutionOptionsEx,'LdrQueryImageFileExecutionOptionsEx',\
LdrQueryImageFileKeyOption,'LdrQueryImageFileKeyOption',\
LdrQueryModuleServiceTags,'LdrQueryModuleServiceTags',\
LdrQueryOptionalDelayLoadedAPI,'LdrQueryOptionalDelayLoadedAPI',\
LdrQueryProcessModuleInformation,'LdrQueryProcessModuleInformation',\
LdrRegisterDllNotification,'LdrRegisterDllNotification',\
LdrRemoveDllDirectory,'LdrRemoveDllDirectory',\
LdrRemoveLoadAsDataTable,'LdrRemoveLoadAsDataTable',\
LdrResFindResource,'LdrResFindResource',\
LdrResFindResourceDirectory,'LdrResFindResourceDirectory',\
LdrResGetRCConfig,'LdrResGetRCConfig',\
LdrResolveDelayLoadedAPI,'LdrResolveDelayLoadedAPI',\
LdrResolveDelayLoadsFromDll,'LdrResolveDelayLoadsFromDll',\
LdrResRelease,'LdrResRelease',\
LdrResSearchResource,'LdrResSearchResource',\
LdrRscIsTypeExist,'LdrRscIsTypeExist',\
LdrSetAppCompatDllRedirectionCallback,'LdrSetAppCompatDllRedirectionCallback',\
LdrSetDefaultDllDirectories,'LdrSetDefaultDllDirectories',\
LdrSetDllDirectory,'LdrSetDllDirectory',\
LdrSetDllManifestProber,'LdrSetDllManifestProber',\
LdrSetImplicitPathOptions,'LdrSetImplicitPathOptions',\
LdrSetMUICacheType,'LdrSetMUICacheType',\
LdrShutdownProcess,'LdrShutdownProcess',\
LdrShutdownThread,'LdrShutdownThread',\
LdrStandardizeSystemPath,'LdrStandardizeSystemPath',\
LdrSystemDllInitBlock,'LdrSystemDllInitBlock',\
LdrUnloadAlternateResourceModule,'LdrUnloadAlternateResourceModule',\
LdrUnloadAlternateResourceModuleEx,'LdrUnloadAlternateResourceModuleEx',\
LdrUnloadDll,'LdrUnloadDll',\
LdrUnlockLoaderLock,'LdrUnlockLoaderLock',\
LdrUnregisterDllNotification,'LdrUnregisterDllNotification',\
LdrUpdatePackageSearchPath,'LdrUpdatePackageSearchPath',\
LdrVerifyImageMatchesChecksum,'LdrVerifyImageMatchesChecksum',\
LdrVerifyImageMatchesChecksumEx,'LdrVerifyImageMatchesChecksumEx',\
log,'log',\
longjmp,'longjmp',\
mbstowcs,'mbstowcs',\
MD4Final,'MD4Final',\
MD4Init,'MD4Init',\
MD4Update,'MD4Update',\
MD5Final,'MD5Final',\
MD5Init,'MD5Init',\
MD5Update,'MD5Update',\
memchr,'memchr',\
memcmp,'memcmp',\
memcpy,'memcpy',\
memcpy_s,'memcpy_s',\
memmove,'memmove',\
memmove_s,'memmove_s',\
memset,'memset',\
NlsAnsiCodePage,'NlsAnsiCodePage',\
NlsMbCodePageTag,'NlsMbCodePageTag',\
NlsMbOemCodePageTag,'NlsMbOemCodePageTag',\
NtAcceptConnectPort,'NtAcceptConnectPort',\
NtAccessCheck,'NtAccessCheck',\
NtAccessCheckAndAuditAlarm,'NtAccessCheckAndAuditAlarm',\
NtAccessCheckByType,'NtAccessCheckByType',\
NtAccessCheckByTypeAndAuditAlarm,'NtAccessCheckByTypeAndAuditAlarm',\
NtAccessCheckByTypeResultList,'NtAccessCheckByTypeResultList',\
NtAccessCheckByTypeResultListAndAuditAlarm,'NtAccessCheckByTypeResultListAndAuditAlarm',\
NtAccessCheckByTypeResultListAndAuditAlarmByHandle,'NtAccessCheckByTypeResultListAndAuditAlarmByHandle',\
NtAcquireProcessActivityReference,'NtAcquireProcessActivityReference',\
NtAddAtom,'NtAddAtom',\
NtAddAtomEx,'NtAddAtomEx',\
NtAddBootEntry,'NtAddBootEntry',\
NtAddDriverEntry,'NtAddDriverEntry',\
NtAdjustGroupsToken,'NtAdjustGroupsToken',\
NtAdjustPrivilegesToken,'NtAdjustPrivilegesToken',\
NtAdjustTokenClaimsAndDeviceGroups,'NtAdjustTokenClaimsAndDeviceGroups',\
NtAlertResumeThread,'NtAlertResumeThread',\
NtAlertThread,'NtAlertThread',\
NtAlertThreadByThreadId,'NtAlertThreadByThreadId',\
NtAllocateLocallyUniqueId,'NtAllocateLocallyUniqueId',\
NtAllocateReserveObject,'NtAllocateReserveObject',\
NtAllocateUserPhysicalPages,'NtAllocateUserPhysicalPages',\
NtAllocateUuids,'NtAllocateUuids',\
NtAllocateVirtualMemory,'NtAllocateVirtualMemory',\
NtAllocateVirtualMemoryEx,'NtAllocateVirtualMemoryEx',\
NtAlpcAcceptConnectPort,'NtAlpcAcceptConnectPort',\
NtAlpcCancelMessage,'NtAlpcCancelMessage',\
NtAlpcConnectPort,'NtAlpcConnectPort',\
NtAlpcConnectPortEx,'NtAlpcConnectPortEx',\
NtAlpcCreatePort,'NtAlpcCreatePort',\
NtAlpcCreatePortSection,'NtAlpcCreatePortSection',\
NtAlpcCreateResourceReserve,'NtAlpcCreateResourceReserve',\
NtAlpcCreateSectionView,'NtAlpcCreateSectionView',\
NtAlpcCreateSecurityContext,'NtAlpcCreateSecurityContext',\
NtAlpcDeletePortSection,'NtAlpcDeletePortSection',\
NtAlpcDeleteResourceReserve,'NtAlpcDeleteResourceReserve',\
NtAlpcDeleteSectionView,'NtAlpcDeleteSectionView',\
NtAlpcDeleteSecurityContext,'NtAlpcDeleteSecurityContext',\
NtAlpcDisconnectPort,'NtAlpcDisconnectPort',\
NtAlpcImpersonateClientContainerOfPort,'NtAlpcImpersonateClientContainerOfPort',\
NtAlpcImpersonateClientOfPort,'NtAlpcImpersonateClientOfPort',\
NtAlpcOpenSenderProcess,'NtAlpcOpenSenderProcess',\
NtAlpcOpenSenderThread,'NtAlpcOpenSenderThread',\
NtAlpcQueryInformation,'NtAlpcQueryInformation',\
NtAlpcQueryInformationMessage,'NtAlpcQueryInformationMessage',\
NtAlpcRevokeSecurityContext,'NtAlpcRevokeSecurityContext',\
NtAlpcSendWaitReceivePort,'NtAlpcSendWaitReceivePort',\
NtAlpcSetInformation,'NtAlpcSetInformation',\
NtApphelpCacheControl,'NtApphelpCacheControl',\
NtAreMappedFilesTheSame,'NtAreMappedFilesTheSame',\
NtAssignProcessToJobObject,'NtAssignProcessToJobObject',\
NtAssociateWaitCompletionPacket,'NtAssociateWaitCompletionPacket',\
NtCallbackReturn,'NtCallbackReturn',\
NtCallEnclave,'NtCallEnclave',\
NtCancelIoFile,'NtCancelIoFile',\
NtCancelIoFileEx,'NtCancelIoFileEx',\
NtCancelSynchronousIoFile,'NtCancelSynchronousIoFile',\
NtCancelTimer,'NtCancelTimer',\
NtCancelTimer2,'NtCancelTimer2',\
NtCancelWaitCompletionPacket,'NtCancelWaitCompletionPacket',\
NtClearEvent,'NtClearEvent',\
NtClose,'NtClose',\
NtCloseObjectAuditAlarm,'NtCloseObjectAuditAlarm',\
NtCommitComplete,'NtCommitComplete',\
NtCommitEnlistment,'NtCommitEnlistment',\
NtCommitRegistryTransaction,'NtCommitRegistryTransaction',\
NtCommitTransaction,'NtCommitTransaction',\
NtCompactKeys,'NtCompactKeys',\
NtCompareObjects,'NtCompareObjects',\
NtCompareSigningLevels,'NtCompareSigningLevels',\
NtCompareTokens,'NtCompareTokens',\
NtCompleteConnectPort,'NtCompleteConnectPort',\
NtCompressKey,'NtCompressKey',\
NtConnectPort,'NtConnectPort',\
NtContinue,'NtContinue',\
NtConvertBetweenAuxiliaryCounterAndPerformanceCounter,'NtConvertBetweenAuxiliaryCounterAndPerformanceCounter',\
NtCreateCrossVmEvent,'NtCreateCrossVmEvent',\
NtCreateDebugObject,'NtCreateDebugObject',\
NtCreateDirectoryObject,'NtCreateDirectoryObject',\
NtCreateDirectoryObjectEx,'NtCreateDirectoryObjectEx',\
NtCreateEnclave,'NtCreateEnclave',\
NtCreateEnlistment,'NtCreateEnlistment',\
NtCreateEvent,'NtCreateEvent',\
NtCreateEventPair,'NtCreateEventPair',\
NtCreateFile,'NtCreateFile',\
NtCreateIoCompletion,'NtCreateIoCompletion',\
NtCreateIRTimer,'NtCreateIRTimer',\
NtCreateJobObject,'NtCreateJobObject',\
NtCreateJobSet,'NtCreateJobSet',\
NtCreateKey,'NtCreateKey',\
NtCreateKeyedEvent,'NtCreateKeyedEvent',\
NtCreateKeyTransacted,'NtCreateKeyTransacted',\
NtCreateLowBoxToken,'NtCreateLowBoxToken',\
NtCreateMailslotFile,'NtCreateMailslotFile',\
NtCreateMutant,'NtCreateMutant',\
NtCreateNamedPipeFile,'NtCreateNamedPipeFile',\
NtCreatePagingFile,'NtCreatePagingFile',\
NtCreatePartition,'NtCreatePartition',\
NtCreatePort,'NtCreatePort',\
NtCreatePrivateNamespace,'NtCreatePrivateNamespace',\
NtCreateProcess,'NtCreateProcess',\
NtCreateProcessEx,'NtCreateProcessEx',\
NtCreateProfile,'NtCreateProfile',\
NtCreateProfileEx,'NtCreateProfileEx',\
NtCreateRegistryTransaction,'NtCreateRegistryTransaction',\
NtCreateResourceManager,'NtCreateResourceManager',\
NtCreateSection,'NtCreateSection',\
NtCreateSectionEx,'NtCreateSectionEx',\
NtCreateSemaphore,'NtCreateSemaphore',\
NtCreateSymbolicLinkObject,'NtCreateSymbolicLinkObject',\
NtCreateThread,'NtCreateThread',\
NtCreateThreadEx,'NtCreateThreadEx',\
NtCreateTimer,'NtCreateTimer',\
NtCreateTimer2,'NtCreateTimer2',\
NtCreateToken,'NtCreateToken',\
NtCreateTokenEx,'NtCreateTokenEx',\
NtCreateTransaction,'NtCreateTransaction',\
NtCreateTransactionManager,'NtCreateTransactionManager',\
NtCreateUserProcess,'NtCreateUserProcess',\
NtCreateWaitablePort,'NtCreateWaitablePort',\
NtCreateWaitCompletionPacket,'NtCreateWaitCompletionPacket',\
NtCreateWnfStateName,'NtCreateWnfStateName',\
NtCreateWorkerFactory,'NtCreateWorkerFactory',\
NtDebugActiveProcess,'NtDebugActiveProcess',\
NtDebugContinue,'NtDebugContinue',\
NtDelayExecution,'NtDelayExecution',\
NtDeleteAtom,'NtDeleteAtom',\
NtDeleteBootEntry,'NtDeleteBootEntry',\
NtDeleteDriverEntry,'NtDeleteDriverEntry',\
NtDeleteFile,'NtDeleteFile',\
NtDeleteKey,'NtDeleteKey',\
NtDeleteObjectAuditAlarm,'NtDeleteObjectAuditAlarm',\
NtDeletePrivateNamespace,'NtDeletePrivateNamespace',\
NtDeleteValueKey,'NtDeleteValueKey',\
NtDeleteWnfStateData,'NtDeleteWnfStateData',\
NtDeleteWnfStateName,'NtDeleteWnfStateName',\
NtDeviceIoControlFile,'NtDeviceIoControlFile',\
NtDisableLastKnownGood,'NtDisableLastKnownGood',\
NtDisplayString,'NtDisplayString',\
NtdllDefWindowProc_A,'NtdllDefWindowProc_A',\
NtdllDefWindowProc_W,'NtdllDefWindowProc_W',\
NtdllDialogWndProc_A,'NtdllDialogWndProc_A',\
NtdllDialogWndProc_W,'NtdllDialogWndProc_W',\
NtDrawText,'NtDrawText',\
NtDuplicateObject,'NtDuplicateObject',\
NtDuplicateToken,'NtDuplicateToken',\
NtEnableLastKnownGood,'NtEnableLastKnownGood',\
NtEnumerateBootEntries,'NtEnumerateBootEntries',\
NtEnumerateDriverEntries,'NtEnumerateDriverEntries',\
NtEnumerateKey,'NtEnumerateKey',\
NtEnumerateSystemEnvironmentValuesEx,'NtEnumerateSystemEnvironmentValuesEx',\
NtEnumerateTransactionObject,'NtEnumerateTransactionObject',\
NtEnumerateValueKey,'NtEnumerateValueKey',\
NtExtendSection,'NtExtendSection',\
NtFilterBootOption,'NtFilterBootOption',\
NtFilterToken,'NtFilterToken',\
NtFilterTokenEx,'NtFilterTokenEx',\
NtFindAtom,'NtFindAtom',\
NtFlushBuffersFile,'NtFlushBuffersFile',\
NtFlushBuffersFileEx,'NtFlushBuffersFileEx',\
NtFlushInstallUILanguage,'NtFlushInstallUILanguage',\
NtFlushInstructionCache,'NtFlushInstructionCache',\
NtFlushKey,'NtFlushKey',\
NtFlushProcessWriteBuffers,'NtFlushProcessWriteBuffers',\
NtFlushVirtualMemory,'NtFlushVirtualMemory',\
NtFlushWriteBuffer,'NtFlushWriteBuffer',\
NtFreeUserPhysicalPages,'NtFreeUserPhysicalPages',\
NtFreeVirtualMemory,'NtFreeVirtualMemory',\
NtFreezeRegistry,'NtFreezeRegistry',\
NtFreezeTransactions,'NtFreezeTransactions',\
NtFsControlFile,'NtFsControlFile',\
NtGetCachedSigningLevel,'NtGetCachedSigningLevel',\
NtGetCompleteWnfStateSubscription,'NtGetCompleteWnfStateSubscription',\
NtGetContextThread,'NtGetContextThread',\
NtGetCurrentProcessorNumber,'NtGetCurrentProcessorNumber',\
NtGetCurrentProcessorNumberEx,'NtGetCurrentProcessorNumberEx',\
NtGetDevicePowerState,'NtGetDevicePowerState',\
NtGetMUIRegistryInfo,'NtGetMUIRegistryInfo',\
NtGetNextProcess,'NtGetNextProcess',\
NtGetNextThread,'NtGetNextThread',\
NtGetNlsSectionPtr,'NtGetNlsSectionPtr',\
NtGetNotificationResourceManager,'NtGetNotificationResourceManager',\
NtGetTickCount,'NtGetTickCount',\
NtGetWriteWatch,'NtGetWriteWatch',\
NtImpersonateAnonymousToken,'NtImpersonateAnonymousToken',\
NtImpersonateClientOfPort,'NtImpersonateClientOfPort',\
NtImpersonateThread,'NtImpersonateThread',\
NtInitializeEnclave,'NtInitializeEnclave',\
NtInitializeNlsFiles,'NtInitializeNlsFiles',\
NtInitializeRegistry,'NtInitializeRegistry',\
NtInitiatePowerAction,'NtInitiatePowerAction',\
NtIsProcessInJob,'NtIsProcessInJob',\
NtIsSystemResumeAutomatic,'NtIsSystemResumeAutomatic',\
NtIsUILanguageComitted,'NtIsUILanguageComitted',\
NtListenPort,'NtListenPort',\
NtLoadDriver,'NtLoadDriver',\
NtLoadEnclaveData,'NtLoadEnclaveData',\
NtLoadKey,'NtLoadKey',\
NtLoadKey2,'NtLoadKey2',\
NtLoadKeyEx,'NtLoadKeyEx',\
NtLockFile,'NtLockFile',\
NtLockProductActivationKeys,'NtLockProductActivationKeys',\
NtLockRegistryKey,'NtLockRegistryKey',\
NtLockVirtualMemory,'NtLockVirtualMemory',\
NtMakePermanentObject,'NtMakePermanentObject',\
NtMakeTemporaryObject,'NtMakeTemporaryObject',\
NtManageHotPatch,'NtManageHotPatch',\
NtManagePartition,'NtManagePartition',\
NtMapCMFModule,'NtMapCMFModule',\
NtMapUserPhysicalPages,'NtMapUserPhysicalPages',\
NtMapUserPhysicalPagesScatter,'NtMapUserPhysicalPagesScatter',\
NtMapViewOfSection,'NtMapViewOfSection',\
NtMapViewOfSectionEx,'NtMapViewOfSectionEx',\
NtModifyBootEntry,'NtModifyBootEntry',\
NtModifyDriverEntry,'NtModifyDriverEntry',\
NtNotifyChangeDirectoryFile,'NtNotifyChangeDirectoryFile',\
NtNotifyChangeDirectoryFileEx,'NtNotifyChangeDirectoryFileEx',\
NtNotifyChangeKey,'NtNotifyChangeKey',\
NtNotifyChangeMultipleKeys,'NtNotifyChangeMultipleKeys',\
NtNotifyChangeSession,'NtNotifyChangeSession',\
NtOpenDirectoryObject,'NtOpenDirectoryObject',\
NtOpenEnlistment,'NtOpenEnlistment',\
NtOpenEvent,'NtOpenEvent',\
NtOpenEventPair,'NtOpenEventPair',\
NtOpenFile,'NtOpenFile',\
NtOpenIoCompletion,'NtOpenIoCompletion',\
NtOpenJobObject,'NtOpenJobObject',\
NtOpenKey,'NtOpenKey',\
NtOpenKeyedEvent,'NtOpenKeyedEvent',\
NtOpenKeyEx,'NtOpenKeyEx',\
NtOpenKeyTransacted,'NtOpenKeyTransacted',\
NtOpenKeyTransactedEx,'NtOpenKeyTransactedEx',\
NtOpenMutant,'NtOpenMutant',\
NtOpenObjectAuditAlarm,'NtOpenObjectAuditAlarm',\
NtOpenPartition,'NtOpenPartition',\
NtOpenPrivateNamespace,'NtOpenPrivateNamespace',\
NtOpenProcess,'NtOpenProcess',\
NtOpenProcessToken,'NtOpenProcessToken',\
NtOpenProcessTokenEx,'NtOpenProcessTokenEx',\
NtOpenRegistryTransaction,'NtOpenRegistryTransaction',\
NtOpenResourceManager,'NtOpenResourceManager',\
NtOpenSection,'NtOpenSection',\
NtOpenSemaphore,'NtOpenSemaphore',\
NtOpenSession,'NtOpenSession',\
NtOpenSymbolicLinkObject,'NtOpenSymbolicLinkObject',\
NtOpenThread,'NtOpenThread',\
NtOpenThreadToken,'NtOpenThreadToken',\
NtOpenThreadTokenEx,'NtOpenThreadTokenEx',\
NtOpenTimer,'NtOpenTimer',\
NtOpenTransaction,'NtOpenTransaction',\
NtOpenTransactionManager,'NtOpenTransactionManager',\
NtPlugPlayControl,'NtPlugPlayControl',\
NtPowerInformation,'NtPowerInformation',\
NtPrepareComplete,'NtPrepareComplete',\
NtPrepareEnlistment,'NtPrepareEnlistment',\
NtPrePrepareComplete,'NtPrePrepareComplete',\
NtPrePrepareEnlistment,'NtPrePrepareEnlistment',\
NtPrivilegeCheck,'NtPrivilegeCheck',\
NtPrivilegedServiceAuditAlarm,'NtPrivilegedServiceAuditAlarm',\
NtPrivilegeObjectAuditAlarm,'NtPrivilegeObjectAuditAlarm',\
NtPropagationComplete,'NtPropagationComplete',\
NtPropagationFailed,'NtPropagationFailed',\
NtProtectVirtualMemory,'NtProtectVirtualMemory',\
NtPulseEvent,'NtPulseEvent',\
NtQueryAttributesFile,'NtQueryAttributesFile',\
NtQueryAuxiliaryCounterFrequency,'NtQueryAuxiliaryCounterFrequency',\
NtQueryBootEntryOrder,'NtQueryBootEntryOrder',\
NtQueryBootOptions,'NtQueryBootOptions',\
NtQueryDebugFilterState,'NtQueryDebugFilterState',\
NtQueryDefaultLocale,'NtQueryDefaultLocale',\
NtQueryDefaultUILanguage,'NtQueryDefaultUILanguage',\
NtQueryDirectoryFile,'NtQueryDirectoryFile',\
NtQueryDirectoryFileEx,'NtQueryDirectoryFileEx',\
NtQueryDirectoryObject,'NtQueryDirectoryObject',\
NtQueryDriverEntryOrder,'NtQueryDriverEntryOrder',\
NtQueryEaFile,'NtQueryEaFile',\
NtQueryEvent,'NtQueryEvent',\
NtQueryFullAttributesFile,'NtQueryFullAttributesFile',\
NtQueryInformationAtom,'NtQueryInformationAtom',\
NtQueryInformationByName,'NtQueryInformationByName',\
NtQueryInformationEnlistment,'NtQueryInformationEnlistment',\
NtQueryInformationFile,'NtQueryInformationFile',\
NtQueryInformationJobObject,'NtQueryInformationJobObject',\
NtQueryInformationPort,'NtQueryInformationPort',\
NtQueryInformationProcess,'NtQueryInformationProcess',\
NtQueryInformationResourceManager,'NtQueryInformationResourceManager',\
NtQueryInformationThread,'NtQueryInformationThread',\
NtQueryInformationToken,'NtQueryInformationToken',\
NtQueryInformationTransaction,'NtQueryInformationTransaction',\
NtQueryInformationTransactionManager,'NtQueryInformationTransactionManager',\
NtQueryInformationWorkerFactory,'NtQueryInformationWorkerFactory',\
NtQueryInstallUILanguage,'NtQueryInstallUILanguage',\
NtQueryIntervalProfile,'NtQueryIntervalProfile',\
NtQueryIoCompletion,'NtQueryIoCompletion',\
NtQueryKey,'NtQueryKey',\
NtQueryLicenseValue,'NtQueryLicenseValue',\
NtQueryMultipleValueKey,'NtQueryMultipleValueKey',\
NtQueryMutant,'NtQueryMutant',\
NtQueryObject,'NtQueryObject',\
NtQueryOpenSubKeys,'NtQueryOpenSubKeys',\
NtQueryPerformanceCounter,'NtQueryPerformanceCounter',\
NtQueryPortInformationProcess,'NtQueryPortInformationProcess',\
NtQueryQuotaInformationFile,'NtQueryQuotaInformationFile',\
NtQuerySection,'NtQuerySection',\
NtQuerySecurityAttributesToken,'NtQuerySecurityAttributesToken',\
NtQuerySecurityObject,'NtQuerySecurityObject',\
NtQuerySecurityPolicy,'NtQuerySecurityPolicy',\
NtQuerySemaphore,'NtQuerySemaphore',\
NtQuerySymbolicLinkObject,'NtQuerySymbolicLinkObject',\
NtQuerySystemEnvironmentValue,'NtQuerySystemEnvironmentValue',\
NtQuerySystemEnvironmentValueEx,'NtQuerySystemEnvironmentValueEx',\
NtQuerySystemInformation,'NtQuerySystemInformation',\
NtQuerySystemInformationEx,'NtQuerySystemInformationEx',\
NtQuerySystemTime,'NtQuerySystemTime',\
NtQueryTimer,'NtQueryTimer',\
NtQueryTimerResolution,'NtQueryTimerResolution',\
NtQueryValueKey,'NtQueryValueKey',\
NtQueryVirtualMemory,'NtQueryVirtualMemory',\
NtQueryVolumeInformationFile,'NtQueryVolumeInformationFile',\
NtQueryWnfStateData,'NtQueryWnfStateData',\
NtQueryWnfStateNameInformation,'NtQueryWnfStateNameInformation',\
NtQueueApcThread,'NtQueueApcThread',\
NtQueueApcThreadEx,'NtQueueApcThreadEx',\
NtRaiseException,'NtRaiseException',\
NtRaiseHardError,'NtRaiseHardError',\
NtReadFile,'NtReadFile',\
NtReadFileScatter,'NtReadFileScatter',\
NtReadOnlyEnlistment,'NtReadOnlyEnlistment',\
NtReadRequestData,'NtReadRequestData',\
NtReadVirtualMemory,'NtReadVirtualMemory',\
NtRecoverEnlistment,'NtRecoverEnlistment',\
NtRecoverResourceManager,'NtRecoverResourceManager',\
NtRecoverTransactionManager,'NtRecoverTransactionManager',\
NtRegisterProtocolAddressInformation,'NtRegisterProtocolAddressInformation',\
NtRegisterThreadTerminatePort,'NtRegisterThreadTerminatePort',\
NtReleaseKeyedEvent,'NtReleaseKeyedEvent',\
NtReleaseMutant,'NtReleaseMutant',\
NtReleaseSemaphore,'NtReleaseSemaphore',\
NtReleaseWorkerFactoryWorker,'NtReleaseWorkerFactoryWorker',\
NtRemoveIoCompletion,'NtRemoveIoCompletion',\
NtRemoveIoCompletionEx,'NtRemoveIoCompletionEx',\
NtRemoveProcessDebug,'NtRemoveProcessDebug',\
NtRenameKey,'NtRenameKey',\
NtRenameTransactionManager,'NtRenameTransactionManager',\
NtReplaceKey,'NtReplaceKey',\
NtReplacePartitionUnit,'NtReplacePartitionUnit',\
NtReplyPort,'NtReplyPort',\
NtReplyWaitReceivePort,'NtReplyWaitReceivePort',\
NtReplyWaitReceivePortEx,'NtReplyWaitReceivePortEx',\
NtReplyWaitReplyPort,'NtReplyWaitReplyPort',\
NtRequestPort,'NtRequestPort',\
NtRequestWaitReplyPort,'NtRequestWaitReplyPort',\
NtResetEvent,'NtResetEvent',\
NtResetWriteWatch,'NtResetWriteWatch',\
NtRestoreKey,'NtRestoreKey',\
NtResumeProcess,'NtResumeProcess',\
NtResumeThread,'NtResumeThread',\
NtRevertContainerImpersonation,'NtRevertContainerImpersonation',\
NtRollbackComplete,'NtRollbackComplete',\
NtRollbackEnlistment,'NtRollbackEnlistment',\
NtRollbackRegistryTransaction,'NtRollbackRegistryTransaction',\
NtRollbackTransaction,'NtRollbackTransaction',\
NtRollforwardTransactionManager,'NtRollforwardTransactionManager',\
NtSaveKey,'NtSaveKey',\
NtSaveKeyEx,'NtSaveKeyEx',\
NtSaveMergedKeys,'NtSaveMergedKeys',\
NtSecureConnectPort,'NtSecureConnectPort',\
NtSerializeBoot,'NtSerializeBoot',\
NtSetBootEntryOrder,'NtSetBootEntryOrder',\
NtSetBootOptions,'NtSetBootOptions',\
NtSetCachedSigningLevel,'NtSetCachedSigningLevel',\
NtSetCachedSigningLevel2,'NtSetCachedSigningLevel2',\
NtSetContextThread,'NtSetContextThread',\
NtSetDebugFilterState,'NtSetDebugFilterState',\
NtSetDefaultHardErrorPort,'NtSetDefaultHardErrorPort',\
NtSetDefaultLocale,'NtSetDefaultLocale',\
NtSetDefaultUILanguage,'NtSetDefaultUILanguage',\
NtSetDriverEntryOrder,'NtSetDriverEntryOrder',\
NtSetEaFile,'NtSetEaFile',\
NtSetEvent,'NtSetEvent',\
NtSetEventBoostPriority,'NtSetEventBoostPriority',\
NtSetHighEventPair,'NtSetHighEventPair',\
NtSetHighWaitLowEventPair,'NtSetHighWaitLowEventPair',\
NtSetInformationDebugObject,'NtSetInformationDebugObject',\
NtSetInformationEnlistment,'NtSetInformationEnlistment',\
NtSetInformationFile,'NtSetInformationFile',\
NtSetInformationJobObject,'NtSetInformationJobObject',\
NtSetInformationKey,'NtSetInformationKey',\
NtSetInformationObject,'NtSetInformationObject',\
NtSetInformationProcess,'NtSetInformationProcess',\
NtSetInformationResourceManager,'NtSetInformationResourceManager',\
NtSetInformationSymbolicLink,'NtSetInformationSymbolicLink',\
NtSetInformationThread,'NtSetInformationThread',\
NtSetInformationToken,'NtSetInformationToken',\
NtSetInformationTransaction,'NtSetInformationTransaction',\
NtSetInformationTransactionManager,'NtSetInformationTransactionManager',\
NtSetInformationVirtualMemory,'NtSetInformationVirtualMemory',\
NtSetInformationWorkerFactory,'NtSetInformationWorkerFactory',\
NtSetIntervalProfile,'NtSetIntervalProfile',\
NtSetIoCompletion,'NtSetIoCompletion',\
NtSetIoCompletionEx,'NtSetIoCompletionEx',\
NtSetIRTimer,'NtSetIRTimer',\
NtSetLdtEntries,'NtSetLdtEntries',\
NtSetLowEventPair,'NtSetLowEventPair',\
NtSetLowWaitHighEventPair,'NtSetLowWaitHighEventPair',\
NtSetQuotaInformationFile,'NtSetQuotaInformationFile',\
NtSetSecurityObject,'NtSetSecurityObject',\
NtSetSystemEnvironmentValue,'NtSetSystemEnvironmentValue',\
NtSetSystemEnvironmentValueEx,'NtSetSystemEnvironmentValueEx',\
NtSetSystemInformation,'NtSetSystemInformation',\
NtSetSystemPowerState,'NtSetSystemPowerState',\
NtSetSystemTime,'NtSetSystemTime',\
NtSetThreadExecutionState,'NtSetThreadExecutionState',\
NtSetTimer,'NtSetTimer',\
NtSetTimer2,'NtSetTimer2',\
NtSetTimerEx,'NtSetTimerEx',\
NtSetTimerResolution,'NtSetTimerResolution',\
NtSetUuidSeed,'NtSetUuidSeed',\
NtSetValueKey,'NtSetValueKey',\
NtSetVolumeInformationFile,'NtSetVolumeInformationFile',\
NtSetWnfProcessNotificationEvent,'NtSetWnfProcessNotificationEvent',\
NtShutdownSystem,'NtShutdownSystem',\
NtShutdownWorkerFactory,'NtShutdownWorkerFactory',\
NtSignalAndWaitForSingleObject,'NtSignalAndWaitForSingleObject',\
NtSinglePhaseReject,'NtSinglePhaseReject',\
NtStartProfile,'NtStartProfile',\
NtStopProfile,'NtStopProfile',\
NtSubscribeWnfStateChange,'NtSubscribeWnfStateChange',\
NtSuspendProcess,'NtSuspendProcess',\
NtSuspendThread,'NtSuspendThread',\
NtSystemDebugControl,'NtSystemDebugControl',\
NtTerminateEnclave,'NtTerminateEnclave',\
NtTerminateJobObject,'NtTerminateJobObject',\
NtTerminateProcess,'NtTerminateProcess',\
NtTerminateThread,'NtTerminateThread',\
NtTestAlert,'NtTestAlert',\
NtThawRegistry,'NtThawRegistry',\
NtThawTransactions,'NtThawTransactions',\
NtTraceControl,'NtTraceControl',\
NtTraceEvent,'NtTraceEvent',\
NtTranslateFilePath,'NtTranslateFilePath',\
NtUmsThreadYield,'NtUmsThreadYield',\
NtUnloadDriver,'NtUnloadDriver',\
NtUnloadKey,'NtUnloadKey',\
NtUnloadKey2,'NtUnloadKey2',\
NtUnloadKeyEx,'NtUnloadKeyEx',\
NtUnlockFile,'NtUnlockFile',\
NtUnlockVirtualMemory,'NtUnlockVirtualMemory',\
NtUnmapViewOfSection,'NtUnmapViewOfSection',\
NtUnmapViewOfSectionEx,'NtUnmapViewOfSectionEx',\
NtUnsubscribeWnfStateChange,'NtUnsubscribeWnfStateChange',\
NtUpdateWnfStateData,'NtUpdateWnfStateData',\
NtVdmControl,'NtVdmControl',\
NtWaitForAlertByThreadId,'NtWaitForAlertByThreadId',\
NtWaitForDebugEvent,'NtWaitForDebugEvent',\
NtWaitForKeyedEvent,'NtWaitForKeyedEvent',\
NtWaitForMultipleObjects,'NtWaitForMultipleObjects',\
NtWaitForMultipleObjects32,'NtWaitForMultipleObjects32',\
NtWaitForSingleObject,'NtWaitForSingleObject',\
NtWaitForWorkViaWorkerFactory,'NtWaitForWorkViaWorkerFactory',\
NtWaitHighEventPair,'NtWaitHighEventPair',\
NtWaitLowEventPair,'NtWaitLowEventPair',\
NtWorkerFactoryWorkerReady,'NtWorkerFactoryWorkerReady',\
NtWriteFile,'NtWriteFile',\
NtWriteFileGather,'NtWriteFileGather',\
NtWriteRequestData,'NtWriteRequestData',\
NtWriteVirtualMemory,'NtWriteVirtualMemory',\
NtYieldExecution,'NtYieldExecution',\
PfxFindPrefix,'PfxFindPrefix',\
PfxInitialize,'PfxInitialize',\
PfxInsertPrefix,'PfxInsertPrefix',\
PfxRemovePrefix,'PfxRemovePrefix',\
pow,'pow',\
PssNtCaptureSnapshot,'PssNtCaptureSnapshot',\
PssNtDuplicateSnapshot,'PssNtDuplicateSnapshot',\
PssNtFreeRemoteSnapshot,'PssNtFreeRemoteSnapshot',\
PssNtFreeSnapshot,'PssNtFreeSnapshot',\
PssNtFreeWalkMarker,'PssNtFreeWalkMarker',\
PssNtQuerySnapshot,'PssNtQuerySnapshot',\
PssNtValidateDescriptor,'PssNtValidateDescriptor',\
PssNtWalkSnapshot,'PssNtWalkSnapshot',\
qsort,'qsort',\
qsort_s,'qsort_s',\
RtlAbortRXact,'RtlAbortRXact',\
RtlAbsoluteToSelfRelativeSD,'RtlAbsoluteToSelfRelativeSD',\
RtlAcquirePebLock,'RtlAcquirePebLock',\
RtlAcquirePrivilege,'RtlAcquirePrivilege',\
RtlAcquireReleaseSRWLockExclusive,'RtlAcquireReleaseSRWLockExclusive',\
RtlAcquireResourceExclusive,'RtlAcquireResourceExclusive',\
RtlAcquireResourceShared,'RtlAcquireResourceShared',\
RtlAcquireSRWLockExclusive,'RtlAcquireSRWLockExclusive',\
RtlAcquireSRWLockShared,'RtlAcquireSRWLockShared',\
RtlActivateActivationContext,'RtlActivateActivationContext',\
RtlActivateActivationContextEx,'RtlActivateActivationContextEx',\
RtlActivateActivationContextUnsafeFast,'RtlActivateActivationContextUnsafeFast',\
RtlAddAccessAllowedAce,'RtlAddAccessAllowedAce',\
RtlAddAccessAllowedAceEx,'RtlAddAccessAllowedAceEx',\
RtlAddAccessAllowedObjectAce,'RtlAddAccessAllowedObjectAce',\
RtlAddAccessDeniedAce,'RtlAddAccessDeniedAce',\
RtlAddAccessDeniedAceEx,'RtlAddAccessDeniedAceEx',\
RtlAddAccessDeniedObjectAce,'RtlAddAccessDeniedObjectAce',\
RtlAddAccessFilterAce,'RtlAddAccessFilterAce',\
RtlAddAce,'RtlAddAce',\
RtlAddActionToRXact,'RtlAddActionToRXact',\
RtlAddAtomToAtomTable,'RtlAddAtomToAtomTable',\
RtlAddAttributeActionToRXact,'RtlAddAttributeActionToRXact',\
RtlAddAuditAccessAce,'RtlAddAuditAccessAce',\
RtlAddAuditAccessAceEx,'RtlAddAuditAccessAceEx',\
RtlAddAuditAccessObjectAce,'RtlAddAuditAccessObjectAce',\
RtlAddCompoundAce,'RtlAddCompoundAce',\
RtlAddFunctionTable,'RtlAddFunctionTable',\
RtlAddGrowableFunctionTable,'RtlAddGrowableFunctionTable',\
RtlAddIntegrityLabelToBoundaryDescriptor,'RtlAddIntegrityLabelToBoundaryDescriptor',\
RtlAddMandatoryAce,'RtlAddMandatoryAce',\
RtlAddProcessTrustLabelAce,'RtlAddProcessTrustLabelAce',\
RtlAddRefActivationContext,'RtlAddRefActivationContext',\
RtlAddRefMemoryStream,'RtlAddRefMemoryStream',\
RtlAddResourceAttributeAce,'RtlAddResourceAttributeAce',\
RtlAddressInSectionTable,'RtlAddressInSectionTable',\
RtlAddScopedPolicyIDAce,'RtlAddScopedPolicyIDAce',\
RtlAddSIDToBoundaryDescriptor,'RtlAddSIDToBoundaryDescriptor',\
RtlAddVectoredContinueHandler,'RtlAddVectoredContinueHandler',\
RtlAddVectoredExceptionHandler,'RtlAddVectoredExceptionHandler',\
RtlAdjustPrivilege,'RtlAdjustPrivilege',\
RtlAllocateActivationContextStack,'RtlAllocateActivationContextStack',\
RtlAllocateAndInitializeSid,'RtlAllocateAndInitializeSid',\
RtlAllocateAndInitializeSidEx,'RtlAllocateAndInitializeSidEx',\
RtlAllocateHandle,'RtlAllocateHandle',\
RtlAllocateHeap,'RtlAllocateHeap',\
RtlAllocateMemoryBlockLookaside,'RtlAllocateMemoryBlockLookaside',\
RtlAllocateMemoryZone,'RtlAllocateMemoryZone',\
RtlAllocateWnfSerializationGroup,'RtlAllocateWnfSerializationGroup',\
RtlAnsiCharToUnicodeChar,'RtlAnsiCharToUnicodeChar',\
RtlAnsiStringToUnicodeSize,'RtlAnsiStringToUnicodeSize',\
RtlAnsiStringToUnicodeString,'RtlAnsiStringToUnicodeString',\
RtlAppendAsciizToString,'RtlAppendAsciizToString',\
RtlAppendPathElement,'RtlAppendPathElement',\
RtlAppendStringToString,'RtlAppendStringToString',\
RtlAppendUnicodeStringToString,'RtlAppendUnicodeStringToString',\
RtlAppendUnicodeToString,'RtlAppendUnicodeToString',\
RtlApplicationVerifierStop,'RtlApplicationVerifierStop',\
RtlApplyRXact,'RtlApplyRXact',\
RtlApplyRXactNoFlush,'RtlApplyRXactNoFlush',\
RtlAppxIsFileOwnedByTrustedInstaller,'RtlAppxIsFileOwnedByTrustedInstaller',\
RtlAreAllAccessesGranted,'RtlAreAllAccessesGranted',\
RtlAreAnyAccessesGranted,'RtlAreAnyAccessesGranted',\
RtlAreBitsClear,'RtlAreBitsClear',\
RtlAreBitsSet,'RtlAreBitsSet',\
RtlAreLongPathsEnabled,'RtlAreLongPathsEnabled',\
RtlAssert,'RtlAssert',\
RtlAvlInsertNodeEx,'RtlAvlInsertNodeEx',\
RtlAvlRemoveNode,'RtlAvlRemoveNode',\
RtlBarrier,'RtlBarrier',\
RtlBarrierForDelete,'RtlBarrierForDelete',\
RtlCancelTimer,'RtlCancelTimer',\
RtlCanonicalizeDomainName,'RtlCanonicalizeDomainName',\
RtlCapabilityCheck,'RtlCapabilityCheck',\
RtlCapabilityCheckForSingleSessionSku,'RtlCapabilityCheckForSingleSessionSku',\
RtlCaptureContext,'RtlCaptureContext',\
RtlCaptureStackBackTrace,'RtlCaptureStackBackTrace',\
RtlCharToInteger,'RtlCharToInteger',\
RtlCheckBootStatusIntegrity,'RtlCheckBootStatusIntegrity',\
RtlCheckForOrphanedCriticalSections,'RtlCheckForOrphanedCriticalSections',\
RtlCheckPortableOperatingSystem,'RtlCheckPortableOperatingSystem',\
RtlCheckRegistryKey,'RtlCheckRegistryKey',\
RtlCheckSandboxedToken,'RtlCheckSandboxedToken',\
RtlCheckSystemBootStatusIntegrity,'RtlCheckSystemBootStatusIntegrity',\
RtlCheckTokenCapability,'RtlCheckTokenCapability',\
RtlCheckTokenMembership,'RtlCheckTokenMembership',\
RtlCheckTokenMembershipEx,'RtlCheckTokenMembershipEx',\
RtlCleanUpTEBLangLists,'RtlCleanUpTEBLangLists',\
RtlClearAllBits,'RtlClearAllBits',\
RtlClearBit,'RtlClearBit',\
RtlClearBits,'RtlClearBits',\
RtlClearThreadWorkOnBehalfTicket,'RtlClearThreadWorkOnBehalfTicket',\
RtlCloneMemoryStream,'RtlCloneMemoryStream',\
RtlCloneUserProcess,'RtlCloneUserProcess',\
RtlCmDecodeMemIoResource,'RtlCmDecodeMemIoResource',\
RtlCmEncodeMemIoResource,'RtlCmEncodeMemIoResource',\
RtlCommitDebugInfo,'RtlCommitDebugInfo',\
RtlCommitMemoryStream,'RtlCommitMemoryStream',\
RtlCompactHeap,'RtlCompactHeap',\
RtlCompareAltitudes,'RtlCompareAltitudes',\
RtlCompareMemory,'RtlCompareMemory',\
RtlCompareMemoryUlong,'RtlCompareMemoryUlong',\
RtlCompareString,'RtlCompareString',\
RtlCompareUnicodeString,'RtlCompareUnicodeString',\
RtlCompareUnicodeStrings,'RtlCompareUnicodeStrings',\
RtlCompressBuffer,'RtlCompressBuffer',\
RtlComputeCrc32,'RtlComputeCrc32',\
RtlComputeImportTableHash,'RtlComputeImportTableHash',\
RtlComputePrivatizedDllName_U,'RtlComputePrivatizedDllName_U',\
RtlConnectToSm,'RtlConnectToSm',\
RtlConsoleMultiByteToUnicodeN,'RtlConsoleMultiByteToUnicodeN',\
RtlConstructCrossVmEventPath,'RtlConstructCrossVmEventPath',\
RtlContractHashTable,'RtlContractHashTable',\
RtlConvertDeviceFamilyInfoToString,'RtlConvertDeviceFamilyInfoToString',\
RtlConvertExclusiveToShared,'RtlConvertExclusiveToShared',\
RtlConvertLCIDToString,'RtlConvertLCIDToString',\
RtlConvertSharedToExclusive,'RtlConvertSharedToExclusive',\
RtlConvertSidToUnicodeString,'RtlConvertSidToUnicodeString',\
RtlConvertSRWLockExclusiveToShared,'RtlConvertSRWLockExclusiveToShared',\
RtlConvertToAutoInheritSecurityObject,'RtlConvertToAutoInheritSecurityObject',\
RtlCopyBitMap,'RtlCopyBitMap',\
RtlCopyContext,'RtlCopyContext',\
RtlCopyExtendedContext,'RtlCopyExtendedContext',\
RtlCopyLuid,'RtlCopyLuid',\
RtlCopyLuidAndAttributesArray,'RtlCopyLuidAndAttributesArray',\
RtlCopyMappedMemory,'RtlCopyMappedMemory',\
RtlCopyMemory,'RtlCopyMemory',\
RtlCopyMemoryNonTemporal,'RtlCopyMemoryNonTemporal',\
RtlCopyMemoryStreamTo,'RtlCopyMemoryStreamTo',\
RtlCopyOutOfProcessMemoryStreamTo,'RtlCopyOutOfProcessMemoryStreamTo',\
RtlCopySecurityDescriptor,'RtlCopySecurityDescriptor',\
RtlCopySid,'RtlCopySid',\
RtlCopySidAndAttributesArray,'RtlCopySidAndAttributesArray',\
RtlCopyString,'RtlCopyString',\
RtlCopyUnicodeString,'RtlCopyUnicodeString',\
RtlCrc32,'RtlCrc32',\
RtlCrc64,'RtlCrc64',\
RtlCreateAcl,'RtlCreateAcl',\
RtlCreateActivationContext,'RtlCreateActivationContext',\
RtlCreateAndSetSD,'RtlCreateAndSetSD',\
RtlCreateAtomTable,'RtlCreateAtomTable',\
RtlCreateBootStatusDataFile,'RtlCreateBootStatusDataFile',\
RtlCreateBoundaryDescriptor,'RtlCreateBoundaryDescriptor',\
RtlCreateEnvironment,'RtlCreateEnvironment',\
RtlCreateEnvironmentEx,'RtlCreateEnvironmentEx',\
RtlCreateHashTable,'RtlCreateHashTable',\
RtlCreateHashTableEx,'RtlCreateHashTableEx',\
RtlCreateHeap,'RtlCreateHeap',\
RtlCreateMemoryBlockLookaside,'RtlCreateMemoryBlockLookaside',\
RtlCreateMemoryZone,'RtlCreateMemoryZone',\
RtlCreateProcessParameters,'RtlCreateProcessParameters',\
RtlCreateProcessParametersEx,'RtlCreateProcessParametersEx',\
RtlCreateProcessParametersWithTemplate,'RtlCreateProcessParametersWithTemplate',\
RtlCreateProcessReflection,'RtlCreateProcessReflection',\
RtlCreatequeryDebugBuffer,'RtlCreatequeryDebugBuffer',\
RtlCreateRegistryKey,'RtlCreateRegistryKey',\
RtlCreateSecurityDescriptor,'RtlCreateSecurityDescriptor',\
RtlCreateServiceSid,'RtlCreateServiceSid',\
RtlCreateSystemVolumeInformationFolder,'RtlCreateSystemVolumeInformationFolder',\
RtlCreateTagHeap,'RtlCreateTagHeap',\
RtlCreateTimer,'RtlCreateTimer',\
RtlCreateTimerQueue,'RtlCreateTimerQueue',\
RtlCreateUnicodeString,'RtlCreateUnicodeString',\
RtlCreateUnicodeStringFromAsciiz,'RtlCreateUnicodeStringFromAsciiz',\
RtlCreateUserProcess,'RtlCreateUserProcess',\
RtlCreateUserProcessEx,'RtlCreateUserProcessEx',\
RtlCreateUserSecurityObject,'RtlCreateUserSecurityObject',\
RtlCreateUserStack,'RtlCreateUserStack',\
RtlCreateUserThread,'RtlCreateUserThread',\
RtlCreateVirtualAccountSid,'RtlCreateVirtualAccountSid',\
RtlCultureNameToLCID,'RtlCultureNameToLCID',\
RtlCustomCPToUnicodeN,'RtlCustomCPToUnicodeN',\
RtlCutoverTimeToSystemTime,'RtlCutoverTimeToSystemTime',\
RtlDeactivateActivationContext,'RtlDeactivateActivationContext',\
RtlDeactivateActivationContextUnsafeFast,'RtlDeactivateActivationContextUnsafeFast',\
RtlDebugPrintTimes,'RtlDebugPrintTimes',\
RtlDecodePointer,'RtlDecodePointer',\
RtlDecodeRemotePointer,'RtlDecodeRemotePointer',\
RtlDecodeSystemPointer,'RtlDecodeSystemPointer',\
RtlDeCommitDebugInfo,'RtlDeCommitDebugInfo',\
RtlDecompressBuffer,'RtlDecompressBuffer',\
RtlDecompressBufferEx,'RtlDecompressBufferEx',\
RtlDecompressFragment,'RtlDecompressFragment',\
RtlDefaultNpAcl,'RtlDefaultNpAcl',\
RtlDelete,'RtlDelete',\
RtlDeleteAce,'RtlDeleteAce',\
RtlDeleteAtomFromAtomTable,'RtlDeleteAtomFromAtomTable',\
RtlDeleteBarrier,'RtlDeleteBarrier',\
RtlDeleteBoundaryDescriptor,'RtlDeleteBoundaryDescriptor',\
RtlDeleteCriticalSection,'RtlDeleteCriticalSection',\
RtlDeleteElementGenericTable,'RtlDeleteElementGenericTable',\
RtlDeleteElementGenericTableAvl,'RtlDeleteElementGenericTableAvl',\
RtlDeleteElementGenericTableAvlEx,'RtlDeleteElementGenericTableAvlEx',\
RtlDeleteFunctionTable,'RtlDeleteFunctionTable',\
RtlDeleteGrowableFunctionTable,'RtlDeleteGrowableFunctionTable',\
RtlDeleteHashTable,'RtlDeleteHashTable',\
RtlDeleteNoSplay,'RtlDeleteNoSplay',\
RtlDeleteRegistryValue,'RtlDeleteRegistryValue',\
RtlDeleteResource,'RtlDeleteResource',\
RtlDeleteSecurityObject,'RtlDeleteSecurityObject',\
RtlDeleteTimer,'RtlDeleteTimer',\
RtlDeleteTimerQueue,'RtlDeleteTimerQueue',\
RtlDeleteTimerQueueEx,'RtlDeleteTimerQueueEx',\
RtlDeNormalizeProcessParams,'RtlDeNormalizeProcessParams',\
RtlDeregisterSecureMemoryCacheCallback,'RtlDeregisterSecureMemoryCacheCallback',\
RtlDeregisterWait,'RtlDeregisterWait',\
RtlDeregisterWaitEx,'RtlDeregisterWaitEx',\
RtlDeriveCapabilitySidsFromName,'RtlDeriveCapabilitySidsFromName',\
RtlDestroyAtomTable,'RtlDestroyAtomTable',\
RtlDestroyEnvironment,'RtlDestroyEnvironment',\
RtlDestroyHandleTable,'RtlDestroyHandleTable',\
RtlDestroyHeap,'RtlDestroyHeap',\
RtlDestroyMemoryBlockLookaside,'RtlDestroyMemoryBlockLookaside',\
RtlDestroyMemoryZone,'RtlDestroyMemoryZone',\
RtlDestroyProcessParameters,'RtlDestroyProcessParameters',\
RtlDestroyQueryDebugBuffer,'RtlDestroyQueryDebugBuffer',\
RtlDetectHeapLeaks,'RtlDetectHeapLeaks',\
RtlDetermineDosPathNameType_U,'RtlDetermineDosPathNameType_U',\
RtlDisableThreadProfiling,'RtlDisableThreadProfiling',\
RtlDllShutdownInProgress,'RtlDllShutdownInProgress',\
RtlDnsHostNameToComputerName,'RtlDnsHostNameToComputerName',\
RtlDoesFileExists_U,'RtlDoesFileExists_U',\
RtlDoesNameContainWildCards,'RtlDoesNameContainWildCards',\
RtlDosApplyFileIsolationRedirection_Ustr,'RtlDosApplyFileIsolationRedirection_Ustr',\
RtlDosLongPathNameToNtPathName_U_WithStatus,'RtlDosLongPathNameToNtPathName_U_WithStatus',\
RtlDosLongPathNameToRelativeNtPathName_U_WithStatus,'RtlDosLongPathNameToRelativeNtPathName_U_WithStatus',\
RtlDosPathNameToNtPathName_U,'RtlDosPathNameToNtPathName_U',\
RtlDosPathNameToNtPathName_U_WithStatus,'RtlDosPathNameToNtPathName_U_WithStatus',\
RtlDosPathNameToRelativeNtPathName_U,'RtlDosPathNameToRelativeNtPathName_U',\
RtlDosPathNameToRelativeNtPathName_U_WithStatus,'RtlDosPathNameToRelativeNtPathName_U_WithStatus',\
RtlDosSearchPath_U,'RtlDosSearchPath_U',\
RtlDosSearchPath_Ustr,'RtlDosSearchPath_Ustr',\
RtlDowncaseUnicodeChar,'RtlDowncaseUnicodeChar',\
RtlDowncaseUnicodeString,'RtlDowncaseUnicodeString',\
RtlDrainNonVolatileFlush,'RtlDrainNonVolatileFlush',\
RtlDumpResource,'RtlDumpResource',\
RtlDuplicateUnicodeString,'RtlDuplicateUnicodeString',\
RtlEmptyAtomTable,'RtlEmptyAtomTable',\
RtlEnableEarlyCriticalSectionEventCreation,'RtlEnableEarlyCriticalSectionEventCreation',\
RtlEnableThreadProfiling,'RtlEnableThreadProfiling',\
RtlEncodePointer,'RtlEncodePointer',\
RtlEncodeRemotePointer,'RtlEncodeRemotePointer',\
RtlEncodeSystemPointer,'RtlEncodeSystemPointer',\
RtlEndEnumerationHashTable,'RtlEndEnumerationHashTable',\
RtlEndStrongEnumerationHashTable,'RtlEndStrongEnumerationHashTable',\
RtlEndWeakEnumerationHashTable,'RtlEndWeakEnumerationHashTable',\
RtlEnterCriticalSection,'RtlEnterCriticalSection',\
RtlEnumerateEntryHashTable,'RtlEnumerateEntryHashTable',\
RtlEnumerateGenericTable,'RtlEnumerateGenericTable',\
RtlEnumerateGenericTableAvl,'RtlEnumerateGenericTableAvl',\
RtlEnumerateGenericTableLikeADirectory,'RtlEnumerateGenericTableLikeADirectory',\
RtlEnumerateGenericTableWithoutSplaying,'RtlEnumerateGenericTableWithoutSplaying',\
RtlEnumerateGenericTableWithoutSplayingAvl,'RtlEnumerateGenericTableWithoutSplayingAvl',\
RtlEnumProcessHeaps,'RtlEnumProcessHeaps',\
RtlequalComputerName,'RtlequalComputerName',\
RtlequalDomainName,'RtlequalDomainName',\
RtlequalLuid,'RtlequalLuid',\
RtlequalPrefixSid,'RtlequalPrefixSid',\
RtlequalSid,'RtlequalSid',\
RtlequalString,'RtlequalString',\
RtlequalUnicodeString,'RtlequalUnicodeString',\
RtlequalWnfChangeStamps,'RtlequalWnfChangeStamps',\
RtlEraseUnicodeString,'RtlEraseUnicodeString',\
RtlEthernetAddressToStringA,'RtlEthernetAddressToStringA',\
RtlEthernetAddressToStringW,'RtlEthernetAddressToStringW',\
RtlEthernetStringToAddressA,'RtlEthernetStringToAddressA',\
RtlEthernetStringToAddressW,'RtlEthernetStringToAddressW',\
RtlExitUserProcess,'RtlExitUserProcess',\
RtlExitUserThread,'RtlExitUserThread',\
RtlExpandEnvironmentStrings,'RtlExpandEnvironmentStrings',\
RtlExpandEnvironmentStrings_U,'RtlExpandEnvironmentStrings_U',\
RtlExpandHashTable,'RtlExpandHashTable',\
RtlExtendCorrelationVector,'RtlExtendCorrelationVector',\
RtlExtendMemoryBlockLookaside,'RtlExtendMemoryBlockLookaside',\
RtlExtendMemoryZone,'RtlExtendMemoryZone',\
RtlExtractBitMap,'RtlExtractBitMap',\
RtlFillMemory,'RtlFillMemory',\
RtlFillMemoryNonTemporal,'RtlFillMemoryNonTemporal',\
RtlFillNonVolatileMemory,'RtlFillNonVolatileMemory',\
RtlFinalReleaseOutOfProcessMemoryStream,'RtlFinalReleaseOutOfProcessMemoryStream',\
RtlFindAceByType,'RtlFindAceByType',\
RtlFindActivationContextSectionGuid,'RtlFindActivationContextSectionGuid',\
RtlFindActivationContextSectionString,'RtlFindActivationContextSectionString',\
RtlFindCharInUnicodeString,'RtlFindCharInUnicodeString',\
RtlFindClearBits,'RtlFindClearBits',\
RtlFindClearBitsAndSet,'RtlFindClearBitsAndSet',\
RtlFindClearRuns,'RtlFindClearRuns',\
RtlFindClosestEncodableLength,'RtlFindClosestEncodableLength',\
RtlFindExportedRoutineByName,'RtlFindExportedRoutineByName',\
RtlFindLastBackwardRunClear,'RtlFindLastBackwardRunClear',\
RtlFindLeastSignificantBit,'RtlFindLeastSignificantBit',\
RtlFindLongestRunClear,'RtlFindLongestRunClear',\
RtlFindMessage,'RtlFindMessage',\
RtlFindMostSignificantBit,'RtlFindMostSignificantBit',\
RtlFindNextForwardRunClear,'RtlFindNextForwardRunClear',\
RtlFindSetBits,'RtlFindSetBits',\
RtlFindSetBitsAndClear,'RtlFindSetBitsAndClear',\
RtlFindUnicodeSubstring,'RtlFindUnicodeSubstring',\
RtlFirstEntrySList,'RtlFirstEntrySList',\
RtlFirstFreeAce,'RtlFirstFreeAce',\
RtlFlsAlloc,'RtlFlsAlloc',\
RtlFlsFree,'RtlFlsFree',\
RtlFlsGetValue,'RtlFlsGetValue',\
RtlFlsSetValue,'RtlFlsSetValue',\
RtlFlushHeaps,'RtlFlushHeaps',\
RtlFlushNonVolatileMemory,'RtlFlushNonVolatileMemory',\
RtlFlushNonVolatileMemoryRanges,'RtlFlushNonVolatileMemoryRanges',\
RtlFlushSecureMemoryCache,'RtlFlushSecureMemoryCache',\
RtlFormatCurrentUserKeyPath,'RtlFormatCurrentUserKeyPath',\
RtlFormatMessage,'RtlFormatMessage',\
RtlFormatMessageEx,'RtlFormatMessageEx',\
RtlFreeActivationContextStack,'RtlFreeActivationContextStack',\
RtlFreeAnsiString,'RtlFreeAnsiString',\
RtlFreeHandle,'RtlFreeHandle',\
RtlFreeHeap,'RtlFreeHeap',\
RtlFreeMemoryBlockLookaside,'RtlFreeMemoryBlockLookaside',\
RtlFreeNonVolatileToken,'RtlFreeNonVolatileToken',\
RtlFreeOemString,'RtlFreeOemString',\
RtlFreeSid,'RtlFreeSid',\
RtlFreeThreadActivationContextStack,'RtlFreeThreadActivationContextStack',\
RtlFreeUnicodeString,'RtlFreeUnicodeString',\
RtlFreeUserStack,'RtlFreeUserStack',\
RtlGenerate8dot3Name,'RtlGenerate8dot3Name',\
RtlGetAce,'RtlGetAce',\
RtlGetActiveActivationContext,'RtlGetActiveActivationContext',\
RtlGetActiveConsoleId,'RtlGetActiveConsoleId',\
RtlGetAppContainerNamedObjectPath,'RtlGetAppContainerNamedObjectPath',\
RtlGetAppContainerParent,'RtlGetAppContainerParent',\
RtlGetAppContainerSidType,'RtlGetAppContainerSidType',\
RtlGetCallersAddress,'RtlGetCallersAddress',\
RtlGetCompressionWorkSpaceSize,'RtlGetCompressionWorkSpaceSize',\
RtlGetConsoleSessionForegroundProcessId,'RtlGetConsoleSessionForegroundProcessId',\
RtlGetControlSecurityDescriptor,'RtlGetControlSecurityDescriptor',\
RtlGetCriticalSectionRecursionCount,'RtlGetCriticalSectionRecursionCount',\
RtlGetCurrentDirectory_U,'RtlGetCurrentDirectory_U',\
RtlGetCurrentPeb,'RtlGetCurrentPeb',\
RtlGetCurrentProcessorNumber,'RtlGetCurrentProcessorNumber',\
RtlGetCurrentProcessorNumberEx,'RtlGetCurrentProcessorNumberEx',\
RtlGetCurrentServiceSessionId,'RtlGetCurrentServiceSessionId',\
RtlGetCurrentTransaction,'RtlGetCurrentTransaction',\
RtlGetDaclSecurityDescriptor,'RtlGetDaclSecurityDescriptor',\
RtlGetDeviceFamilyInfoEnum,'RtlGetDeviceFamilyInfoEnum',\
RtlGetElementGenericTable,'RtlGetElementGenericTable',\
RtlGetElementGenericTableAvl,'RtlGetElementGenericTableAvl',\
RtlGetEnabledExtendedFeatures,'RtlGetEnabledExtendedFeatures',\
RtlGetExePath,'RtlGetExePath',\
RtlGetExtendedContextLength,'RtlGetExtendedContextLength',\
RtlGetExtendedContextLength2,'RtlGetExtendedContextLength2',\
RtlGetExtendedFeaturesMask,'RtlGetExtendedFeaturesMask',\
RtlGetFileMUIPath,'RtlGetFileMUIPath',\
RtlGetFrame,'RtlGetFrame',\
RtlGetFullPathName_U,'RtlGetFullPathName_U',\
RtlGetFullPathName_UEx,'RtlGetFullPathName_UEx',\
RtlGetFullPathName_UstrEx,'RtlGetFullPathName_UstrEx',\
RtlGetFunctionTableListHead,'RtlGetFunctionTableListHead',\
RtlGetGroupSecurityDescriptor,'RtlGetGroupSecurityDescriptor',\
RtlGetIntegerAtom,'RtlGetIntegerAtom',\
RtlGetInterruptTimePrecise,'RtlGetInterruptTimePrecise',\
RtlGetLastNtStatus,'RtlGetLastNtStatus',\
RtlGetLastWin32Error,'RtlGetLastWin32Error',\
RtlGetLengthWithoutLastFullDosOrNtPathElement,'RtlGetLengthWithoutLastFullDosOrNtPathElement',\
RtlGetLengthWithoutTrailingPathSeperators,'RtlGetLengthWithoutTrailingPathSeperators',\
RtlGetLocaleFileMappingAddress,'RtlGetLocaleFileMappingAddress',\
RtlGetLongestNtPathLength,'RtlGetLongestNtPathLength',\
RtlGetMultiTimePrecise,'RtlGetMultiTimePrecise',\
RtlGetNativeSystemInformation,'RtlGetNativeSystemInformation',\
RtlGetNextEntryHashTable,'RtlGetNextEntryHashTable',\
RtlGetNonVolatileToken,'RtlGetNonVolatileToken',\
RtlGetNtGlobalFlags,'RtlGetNtGlobalFlags',\
RtlGetNtProductType,'RtlGetNtProductType',\
RtlGetNtSystemRoot,'RtlGetNtSystemRoot',\
RtlGetNtVersionNumbers,'RtlGetNtVersionNumbers',\
RtlGetOwnerSecurityDescriptor,'RtlGetOwnerSecurityDescriptor',\
RtlGetParentLocaleName,'RtlGetParentLocaleName',\
RtlGetPersistedStateLocation,'RtlGetPersistedStateLocation',\
RtlGetProcessHeaps,'RtlGetProcessHeaps',\
RtlGetProcessPreferredUILanguages,'RtlGetProcessPreferredUILanguages',\
RtlGetProductInfo,'RtlGetProductInfo',\
RtlGetSaclSecurityDescriptor,'RtlGetSaclSecurityDescriptor',\
RtlGetSearchPath,'RtlGetSearchPath',\
RtlGetSecurityDescriptorRMControl,'RtlGetSecurityDescriptorRMControl',\
RtlGetSessionProperties,'RtlGetSessionProperties',\
RtlGetSetBootStatusData,'RtlGetSetBootStatusData',\
RtlGetSuiteMask,'RtlGetSuiteMask',\
RtlGetSystemBootStatus,'RtlGetSystemBootStatus',\
RtlGetSystemBootStatusEx,'RtlGetSystemBootStatusEx',\
RtlGetSystemPreferredUILanguages,'RtlGetSystemPreferredUILanguages',\
RtlGetSystemTimePrecise,'RtlGetSystemTimePrecise',\
RtlGetThreadErrorMode,'RtlGetThreadErrorMode',\
RtlGetThreadLangIdByIndex,'RtlGetThreadLangIdByIndex',\
RtlGetThreadPreferredUILanguages,'RtlGetThreadPreferredUILanguages',\
RtlGetThreadWorkOnBehalfTicket,'RtlGetThreadWorkOnBehalfTicket',\
RtlGetTokenNamedObjectPath,'RtlGetTokenNamedObjectPath',\
RtlGetUILanguageInfo,'RtlGetUILanguageInfo',\
RtlGetUnloadEventTrace,'RtlGetUnloadEventTrace',\
RtlGetUnloadEventTraceEx,'RtlGetUnloadEventTraceEx',\
RtlGetUserPreferredUILanguages,'RtlGetUserPreferredUILanguages',\
RtlGetVersion,'RtlGetVersion',\
RtlGrowFunctionTable,'RtlGrowFunctionTable',\
RtlGuardCheckLongJumpTarget,'RtlGuardCheckLongJumpTarget',\
RtlGUIDFromString,'RtlGUIDFromString',\
RtlHashUnicodeString,'RtlHashUnicodeString',\
RtlHeapTrkInitialize,'RtlHeapTrkInitialize',\
RtlIdentifierAuthoritySid,'RtlIdentifierAuthoritySid',\
RtlIdnToAscii,'RtlIdnToAscii',\
RtlIdnToNameprepUnicode,'RtlIdnToNameprepUnicode',\
RtlIdnToUnicode,'RtlIdnToUnicode',\
RtlImageDirectoryEntryToData,'RtlImageDirectoryEntryToData',\
RtlImageNtHeader,'RtlImageNtHeader',\
RtlImageNtHeaderEx,'RtlImageNtHeaderEx',\
RtlImageRvaToSection,'RtlImageRvaToSection',\
RtlImageRvaToVa,'RtlImageRvaToVa',\
RtlImpersonateSelf,'RtlImpersonateSelf',\
RtlImpersonateSelfEx,'RtlImpersonateSelfEx',\
RtlIncrementCorrelationVector,'RtlIncrementCorrelationVector',\
RtlInitAnsiString,'RtlInitAnsiString',\
RtlInitAnsiStringEx,'RtlInitAnsiStringEx',\
RtlInitBarrier,'RtlInitBarrier',\
RtlInitCodePageTable,'RtlInitCodePageTable',\
RtlInitEnumerationHashTable,'RtlInitEnumerationHashTable',\
RtlInitializeAtomPackage,'RtlInitializeAtomPackage',\
RtlInitializeBitMap,'RtlInitializeBitMap',\
RtlInitializeConditionVariable,'RtlInitializeConditionVariable',\
RtlInitializeContext,'RtlInitializeContext',\
RtlInitializeCorrelationVector,'RtlInitializeCorrelationVector',\
RtlInitializeCriticalSection,'RtlInitializeCriticalSection',\
RtlInitializeCriticalSectionAndSpinCount,'RtlInitializeCriticalSectionAndSpinCount',\
RtlInitializeCriticalSectionEx,'RtlInitializeCriticalSectionEx',\
RtlInitializeExtendedContext,'RtlInitializeExtendedContext',\
RtlInitializeExtendedContext2,'RtlInitializeExtendedContext2',\
RtlInitializeGenericTable,'RtlInitializeGenericTable',\
RtlInitializeGenericTableAvl,'RtlInitializeGenericTableAvl',\
RtlInitializeHandleTable,'RtlInitializeHandleTable',\
RtlInitializeNtUserPfn,'RtlInitializeNtUserPfn',\
RtlInitializeResource,'RtlInitializeResource',\
RtlInitializeRXact,'RtlInitializeRXact',\
RtlInitializeSid,'RtlInitializeSid',\
RtlInitializeSidEx,'RtlInitializeSidEx',\
RtlInitializeSListHead,'RtlInitializeSListHead',\
RtlInitializeSRWLock,'RtlInitializeSRWLock',\
RtlInitMemoryStream,'RtlInitMemoryStream',\
RtlInitNlsTables,'RtlInitNlsTables',\
RtlInitOutOfProcessMemoryStream,'RtlInitOutOfProcessMemoryStream',\
RtlInitString,'RtlInitString',\
RtlInitStringEx,'RtlInitStringEx',\
RtlInitStrongEnumerationHashTable,'RtlInitStrongEnumerationHashTable',\
RtlInitUnicodeString,'RtlInitUnicodeString',\
RtlInitUnicodeStringEx,'RtlInitUnicodeStringEx',\
RtlInitWeakEnumerationHashTable,'RtlInitWeakEnumerationHashTable',\
RtlInsertElementGenericTable,'RtlInsertElementGenericTable',\
RtlInsertElementGenericTableAvl,'RtlInsertElementGenericTableAvl',\
RtlInsertElementGenericTableFull,'RtlInsertElementGenericTableFull',\
RtlInsertElementGenericTableFullAvl,'RtlInsertElementGenericTableFullAvl',\
RtlInsertEntryHashTable,'RtlInsertEntryHashTable',\
RtlInstallFunctionTableCallback,'RtlInstallFunctionTableCallback',\
RtlInt64ToUnicodeString,'RtlInt64ToUnicodeString',\
RtlIntegerToChar,'RtlIntegerToChar',\
RtlIntegerToUnicodeString,'RtlIntegerToUnicodeString',\
RtlInterlockedClearBitRun,'RtlInterlockedClearBitRun',\
RtlInterlockedFlushSList,'RtlInterlockedFlushSList',\
RtlInterlockedPopEntrySList,'RtlInterlockedPopEntrySList',\
RtlInterlockedPushEntrySList,'RtlInterlockedPushEntrySList',\
RtlInterlockedPushListSList,'RtlInterlockedPushListSList',\
RtlInterlockedPushListSListEx,'RtlInterlockedPushListSListEx',\
RtlInterlockedSetBitRun,'RtlInterlockedSetBitRun',\
RtlIoDecodeMemIoResource,'RtlIoDecodeMemIoResource',\
RtlIoEncodeMemIoResource,'RtlIoEncodeMemIoResource',\
RtlIpv4AddressToStringA,'RtlIpv4AddressToStringA',\
RtlIpv4AddressToStringExA,'RtlIpv4AddressToStringExA',\
RtlIpv4AddressToStringExW,'RtlIpv4AddressToStringExW',\
RtlIpv4AddressToStringW,'RtlIpv4AddressToStringW',\
RtlIpv4StringToAddressA,'RtlIpv4StringToAddressA',\
RtlIpv4StringToAddressExA,'RtlIpv4StringToAddressExA',\
RtlIpv4StringToAddressExW,'RtlIpv4StringToAddressExW',\
RtlIpv4StringToAddressW,'RtlIpv4StringToAddressW',\
RtlIpv6AddressToStringA,'RtlIpv6AddressToStringA',\
RtlIpv6AddressToStringExA,'RtlIpv6AddressToStringExA',\
RtlIpv6AddressToStringExW,'RtlIpv6AddressToStringExW',\
RtlIpv6AddressToStringW,'RtlIpv6AddressToStringW',\
RtlIpv6StringToAddressA,'RtlIpv6StringToAddressA',\
RtlIpv6StringToAddressExA,'RtlIpv6StringToAddressExA',\
RtlIpv6StringToAddressExW,'RtlIpv6StringToAddressExW',\
RtlIpv6StringToAddressW,'RtlIpv6StringToAddressW',\
RtlIsActivationContextActive,'RtlIsActivationContextActive',\
RtlIsCapabilitySid,'RtlIsCapabilitySid',\
RtlIsCloudFilesPlaceholder,'RtlIsCloudFilesPlaceholder',\
RtlIsCriticalSectionLocked,'RtlIsCriticalSectionLocked',\
RtlIsCriticalSectionLockedByThread,'RtlIsCriticalSectionLockedByThread',\
RtlIsCurrentProcess,'RtlIsCurrentProcess',\
RtlIsCurrentThread,'RtlIsCurrentThread',\
RtlIsCurrentThreadAttachExempt,'RtlIsCurrentThreadAttachExempt',\
RtlIsDosDeviceName_U,'RtlIsDosDeviceName_U',\
RtlIsElevatedRid,'RtlIsElevatedRid',\
RtlIsGenericTableEmpty,'RtlIsGenericTableEmpty',\
RtlIsGenericTableEmptyAvl,'RtlIsGenericTableEmptyAvl',\
RtlIsMultiSessionSku,'RtlIsMultiSessionSku',\
RtlIsMultiUsersInSessionSku,'RtlIsMultiUsersInSessionSku',\
RtlIsNameInExpression,'RtlIsNameInExpression',\
RtlIsNameInUnUpcasedExpression,'RtlIsNameInUnUpcasedExpression',\
RtlIsNameLegalDOS8Dot3,'RtlIsNameLegalDOS8Dot3',\
RtlIsNonEmptyDirectoryReparsePointAllowed,'RtlIsNonEmptyDirectoryReparsePointAllowed',\
RtlIsNormalizedString,'RtlIsNormalizedString',\
RtlIsPackageSid,'RtlIsPackageSid',\
RtlIsParentOfChildAppContainer,'RtlIsParentOfChildAppContainer',\
RtlIsPartialPlaceholder,'RtlIsPartialPlaceholder',\
RtlIsPartialPlaceholderFileHandle,'RtlIsPartialPlaceholderFileHandle',\
RtlIsPartialPlaceholderFileInfo,'RtlIsPartialPlaceholderFileInfo',\
RtlIsProcessorFeaturePresent,'RtlIsProcessorFeaturePresent',\
RtlIsStateSeparationEnabled,'RtlIsStateSeparationEnabled',\
RtlIsTextUnicode,'RtlIsTextUnicode',\
RtlIsThreadWithinLoaderCallout,'RtlIsThreadWithinLoaderCallout',\
RtlIsUntrustedObject,'RtlIsUntrustedObject',\
RtlIsValidHandle,'RtlIsValidHandle',\
RtlIsValidIndexHandle,'RtlIsValidIndexHandle',\
RtlIsValidLocaleName,'RtlIsValidLocaleName',\
RtlIsValidProcessTrustLabelSid,'RtlIsValidProcessTrustLabelSid',\
RtlKnownExceptionFilter,'RtlKnownExceptionFilter',\
RtlLargeIntegerToChar,'RtlLargeIntegerToChar',\
RtlLCIDToCultureName,'RtlLCIDToCultureName',\
RtlLcidToLocaleName,'RtlLcidToLocaleName',\
RtlLeaveCriticalSection,'RtlLeaveCriticalSection',\
RtlLengthRequiredSid,'RtlLengthRequiredSid',\
RtlLengthSecurityDescriptor,'RtlLengthSecurityDescriptor',\
RtlLengthSid,'RtlLengthSid',\
RtlLengthSidAsUnicodeString,'RtlLengthSidAsUnicodeString',\
RtlLoadStringA,'RtlLoadStringA',\
RtlLoadStringW,'RtlLoadStringW',\
RtlLocaleNameToLcid,'RtlLocaleNameToLcid',\
RtlLocalTimeToSystemTime,'RtlLocalTimeToSystemTime',\
RtlLocateExtendedFeature,'RtlLocateExtendedFeature',\
RtlLocateExtendedFeature2,'RtlLocateExtendedFeature2',\
RtlLocateLegacyContext,'RtlLocateLegacyContext',\
RtlLockBootStatusData,'RtlLockBootStatusData',\
RtlLockCurrentThread,'RtlLockCurrentThread',\
RtlLockHeap,'RtlLockHeap',\
RtlLockMemoryBlockLookaside,'RtlLockMemoryBlockLookaside',\
RtlLockMemoryStreamRegion,'RtlLockMemoryStreamRegion',\
RtlLockMemoryZone,'RtlLockMemoryZone',\
RtlLockModuleSection,'RtlLockModuleSection',\
RtlLogStackBackTrace,'RtlLogStackBackTrace',\
RtlLookupAtomInAtomTable,'RtlLookupAtomInAtomTable',\
RtlLookupElementGenericTable,'RtlLookupElementGenericTable',\
RtlLookupElementGenericTableAvl,'RtlLookupElementGenericTableAvl',\
RtlLookupElementGenericTableFull,'RtlLookupElementGenericTableFull',\
RtlLookupElementGenericTableFullAvl,'RtlLookupElementGenericTableFullAvl',\
RtlLookupEntryHashTable,'RtlLookupEntryHashTable',\
RtlLookupFirstMatchingElementGenericTableAvl,'RtlLookupFirstMatchingElementGenericTableAvl',\
RtlLookupFunctionEntry,'RtlLookupFunctionEntry',\
RtlLookupFunctionTable,'RtlLookupFunctionTable',\
RtlMakeSelfRelativeSD,'RtlMakeSelfRelativeSD',\
RtlMapGenericMask,'RtlMapGenericMask',\
RtlMapSecurityErrorToNtStatus,'RtlMapSecurityErrorToNtStatus',\
RtlMoveMemory,'RtlMoveMemory',\
RtlMultiAppendUnicodeStringBuffer,'RtlMultiAppendUnicodeStringBuffer',\
RtlMultiByteToUnicodeN,'RtlMultiByteToUnicodeN',\
RtlMultiByteToUnicodeSize,'RtlMultiByteToUnicodeSize',\
RtlMultipleAllocateHeap,'RtlMultipleAllocateHeap',\
RtlMultipleFreeHeap,'RtlMultipleFreeHeap',\
RtlNewInstanceSecurityObject,'RtlNewInstanceSecurityObject',\
RtlNewSecurityGrantedAccess,'RtlNewSecurityGrantedAccess',\
RtlNewSecurityObject,'RtlNewSecurityObject',\
RtlNewSecurityObjectEx,'RtlNewSecurityObjectEx',\
RtlNewSecurityObjectWithMultipleInheritance,'RtlNewSecurityObjectWithMultipleInheritance',\
RtlNormalizeProcessParams,'RtlNormalizeProcessParams',\
RtlNormalizeString,'RtlNormalizeString',\
RtlNtPathNameToDosPathName,'RtlNtPathNameToDosPathName',\
RtlNtStatusToDosError,'RtlNtStatusToDosError',\
RtlNtStatusToDosErrorNoTeb,'RtlNtStatusToDosErrorNoTeb',\
RtlNumberGenericTableElements,'RtlNumberGenericTableElements',\
RtlNumberGenericTableElementsAvl,'RtlNumberGenericTableElementsAvl',\
RtlNumberOfClearBits,'RtlNumberOfClearBits',\
RtlNumberOfClearBitsInRange,'RtlNumberOfClearBitsInRange',\
RtlNumberOfSetBits,'RtlNumberOfSetBits',\
RtlNumberOfSetBitsInRange,'RtlNumberOfSetBitsInRange',\
RtlNumberOfSetBitsUlongPtr,'RtlNumberOfSetBitsUlongPtr',\
RtlOemStringToUnicodeSize,'RtlOemStringToUnicodeSize',\
RtlOemStringToUnicodeString,'RtlOemStringToUnicodeString',\
RtlOemToUnicodeN,'RtlOemToUnicodeN',\
RtlOpenCurrentUser,'RtlOpenCurrentUser',\
RtlOsDeploymentState,'RtlOsDeploymentState',\
RtlOwnerAcesPresent,'RtlOwnerAcesPresent',\
RtlpApplyLengthFunction,'RtlpApplyLengthFunction',\
RtlpCheckDynamicTimeZoneInformation,'RtlpCheckDynamicTimeZoneInformation',\
RtlpCleanupRegistryKeys,'RtlpCleanupRegistryKeys',\
RtlpConvertAbsoluteToRelativeSecurityAttribute,'RtlpConvertAbsoluteToRelativeSecurityAttribute',\
RtlpConvertCultureNamesToLCIDs,'RtlpConvertCultureNamesToLCIDs',\
RtlpConvertLCIDsToCultureNames,'RtlpConvertLCIDsToCultureNames',\
RtlpConvertRelativeToAbsoluteSecurityAttribute,'RtlpConvertRelativeToAbsoluteSecurityAttribute',\
RtlpCreateProcessRegistryInfo,'RtlpCreateProcessRegistryInfo',\
RtlPcToFileHeader,'RtlPcToFileHeader',\
RtlpEnsureBufferSize,'RtlpEnsureBufferSize',\
RtlpFreezeTimeBias,'RtlpFreezeTimeBias',\
RtlpGetDeviceFamilyInfoEnum,'RtlpGetDeviceFamilyInfoEnum',\
RtlpGetLCIDFromLangInfoNode,'RtlpGetLCIDFromLangInfoNode',\
RtlpGetNameFromLangInfoNode,'RtlpGetNameFromLangInfoNode',\
RtlpGetSystemDefaultUILanguage,'RtlpGetSystemDefaultUILanguage',\
RtlpGetUserOrMachineUILanguage4NLS,'RtlpGetUserOrMachineUILanguage4NLS',\
RtlPinAtomInAtomTable,'RtlPinAtomInAtomTable',\
RtlpInitializeLangRegistryInfo,'RtlpInitializeLangRegistryInfo',\
RtlpIsQualifiedLanguage,'RtlpIsQualifiedLanguage',\
RtlpLoadMachineUIByPolicy,'RtlpLoadMachineUIByPolicy',\
RtlpLoadUserUIByPolicy,'RtlpLoadUserUIByPolicy',\
RtlpMergeSecurityAttributeInformation,'RtlpMergeSecurityAttributeInformation',\
RtlpMuiFreeLangRegistryInfo,'RtlpMuiFreeLangRegistryInfo',\
RtlpMuiRegCreateRegistryInfo,'RtlpMuiRegCreateRegistryInfo',\
RtlpMuiRegFreeRegistryInfo,'RtlpMuiRegFreeRegistryInfo',\
RtlpMuiRegLoadRegistryInfo,'RtlpMuiRegLoadRegistryInfo',\
RtlpNotOwnerCriticalSection,'RtlpNotOwnerCriticalSection',\
RtlpNtCreateKey,'RtlpNtCreateKey',\
RtlpNtEnumerateSubKey,'RtlpNtEnumerateSubKey',\
RtlpNtMakeTemporaryKey,'RtlpNtMakeTemporaryKey',\
RtlpNtOpenKey,'RtlpNtOpenKey',\
RtlpNtQueryValueKey,'RtlpNtQueryValueKey',\
RtlpNtSetValueKey,'RtlpNtSetValueKey',\
RtlPopFrame,'RtlPopFrame',\
RtlpQueryDefaultUILanguage,'RtlpQueryDefaultUILanguage',\
RtlPrefixString,'RtlPrefixString',\
RtlPrefixUnicodeString,'RtlPrefixUnicodeString',\
RtlpRefreshCachedUILanguage,'RtlpRefreshCachedUILanguage',\
RtlProcessFlsData,'RtlProcessFlsData',\
RtlProtectHeap,'RtlProtectHeap',\
RtlpSetInstallLanguage,'RtlpSetInstallLanguage',\
RtlpSetPreferredUILanguages,'RtlpSetPreferredUILanguages',\
RtlpSetUserPreferredUILanguages,'RtlpSetUserPreferredUILanguages',\
RtlpTimeFieldsToTime,'RtlpTimeFieldsToTime',\
RtlpTimeToTimeFields,'RtlpTimeToTimeFields',\
RtlPublishWnfStateData,'RtlPublishWnfStateData',\
RtlpUnWaitCriticalSection,'RtlpUnWaitCriticalSection',\
RtlPushFrame,'RtlPushFrame',\
RtlpVerifyAndCommitUILanguageSettings,'RtlpVerifyAndCommitUILanguageSettings',\
RtlpWaitForCriticalSection,'RtlpWaitForCriticalSection',\
RtlQueryActivationContextApplicationSettings,'RtlQueryActivationContextApplicationSettings',\
RtlQueryAtomInAtomTable,'RtlQueryAtomInAtomTable',\
RtlQueryCriticalSectionOwner,'RtlQueryCriticalSectionOwner',\
RtlQueryDepthSList,'RtlQueryDepthSList',\
RtlQueryDynamicTimeZoneInformation,'RtlQueryDynamicTimeZoneInformation',\
RtlQueryElevationFlags,'RtlQueryElevationFlags',\
RtlQueryEnvironmentVariable,'RtlQueryEnvironmentVariable',\
RtlQueryEnvironmentVariable_U,'RtlQueryEnvironmentVariable_U',\
RtlQueryHeapInformation,'RtlQueryHeapInformation',\
RtlQueryImageMitigationPolicy,'RtlQueryImageMitigationPolicy',\
RtlQueryInformationAcl,'RtlQueryInformationAcl',\
RtlQueryInformationActivationContext,'RtlQueryInformationActivationContext',\
RtlQueryInformationActiveActivationContext,'RtlQueryInformationActiveActivationContext',\
RtlQueryInterfaceMemoryStream,'RtlQueryInterfaceMemoryStream',\
RtlQueryModuleInformation,'RtlQueryModuleInformation',\
RtlQueryPackageClaims,'RtlQueryPackageClaims',\
RtlQueryPackageIdentity,'RtlQueryPackageIdentity',\
RtlQueryPackageIdentityEx,'RtlQueryPackageIdentityEx',\
RtlQueryPerformanceCounter,'RtlQueryPerformanceCounter',\
RtlQueryPerformanceFrequency,'RtlQueryPerformanceFrequency',\
RtlQueryProcessBackTraceInformation,'RtlQueryProcessBackTraceInformation',\
RtlQueryProcessDebugInformation,'RtlQueryProcessDebugInformation',\
RtlQueryProcessHeapInformation,'RtlQueryProcessHeapInformation',\
RtlQueryProcessLockInformation,'RtlQueryProcessLockInformation',\
RtlQueryProcessPlaceholderCompatibilityMode,'RtlQueryProcessPlaceholderCompatibilityMode',\
RtlQueryProtectedPolicy,'RtlQueryProtectedPolicy',\
RtlQueryRegistryValues,'RtlQueryRegistryValues',\
RtlQueryRegistryValuesEx,'RtlQueryRegistryValuesEx',\
RtlQueryRegistryValueWithFallback,'RtlQueryRegistryValueWithFallback',\
RtlQueryResourcePolicy,'RtlQueryResourcePolicy',\
RtlQuerySecurityObject,'RtlQuerySecurityObject',\
RtlQueryTagHeap,'RtlQueryTagHeap',\
RtlQueryThreadPlaceholderCompatibilityMode,'RtlQueryThreadPlaceholderCompatibilityMode',\
RtlQueryThreadProfiling,'RtlQueryThreadProfiling',\
RtlQueryTimeZoneInformation,'RtlQueryTimeZoneInformation',\
RtlQueryTokenHostIdAsUlong64,'RtlQueryTokenHostIdAsUlong64',\
RtlQueryUnbiasedInterruptTime,'RtlQueryUnbiasedInterruptTime',\
RtlQueryValidationRunlevel,'RtlQueryValidationRunlevel',\
RtlQueryWnfMetaNotification,'RtlQueryWnfMetaNotification',\
RtlQueryWnfStateData,'RtlQueryWnfStateData',\
RtlQueryWnfStateDataWithExplicitScope,'RtlQueryWnfStateDataWithExplicitScope',\
RtlQueueApcWow64Thread,'RtlQueueApcWow64Thread',\
RtlQueueWorkItem,'RtlQueueWorkItem',\
RtlRaiseCustomSystemEventTrigger,'RtlRaiseCustomSystemEventTrigger',\
RtlRaiseException,'RtlRaiseException',\
RtlRaiseStatus,'RtlRaiseStatus',\
RtlRandom,'RtlRandom',\
RtlRandomEx,'RtlRandomEx',\
RtlRbInsertNodeEx,'RtlRbInsertNodeEx',\
RtlRbRemoveNode,'RtlRbRemoveNode',\
RtlReadMemoryStream,'RtlReadMemoryStream',\
RtlReadOutOfProcessMemoryStream,'RtlReadOutOfProcessMemoryStream',\
RtlReadThreadProfilingData,'RtlReadThreadProfilingData',\
RtlReAllocateHeap,'RtlReAllocateHeap',\
RtlRealPredecessor,'RtlRealPredecessor',\
RtlRealSuccessor,'RtlRealSuccessor',\
RtlRegisterForWnfMetaNotification,'RtlRegisterForWnfMetaNotification',\
RtlRegisterSecureMemoryCacheCallback,'RtlRegisterSecureMemoryCacheCallback',\
RtlRegisterThreadWithCsrss,'RtlRegisterThreadWithCsrss',\
RtlRegisterWait,'RtlRegisterWait',\
RtlReleaseActivationContext,'RtlReleaseActivationContext',\
RtlReleaseMemoryStream,'RtlReleaseMemoryStream',\
RtlReleasePath,'RtlReleasePath',\
RtlReleasePebLock,'RtlReleasePebLock',\
RtlReleasePrivilege,'RtlReleasePrivilege',\
RtlReleaseRelativeName,'RtlReleaseRelativeName',\
RtlReleaseResource,'RtlReleaseResource',\
RtlReleaseSRWLockExclusive,'RtlReleaseSRWLockExclusive',\
RtlReleaseSRWLockShared,'RtlReleaseSRWLockShared',\
RtlRemoteCall,'RtlRemoteCall',\
RtlRemoveEntryHashTable,'RtlRemoveEntryHashTable',\
RtlRemovePrivileges,'RtlRemovePrivileges',\
RtlRemoveVectoredContinueHandler,'RtlRemoveVectoredContinueHandler',\
RtlRemoveVectoredExceptionHandler,'RtlRemoveVectoredExceptionHandler',\
RtlReplaceSidInSd,'RtlReplaceSidInSd',\
RtlReplaceSystemDirectoryInPath,'RtlReplaceSystemDirectoryInPath',\
RtlReportException,'RtlReportException',\
RtlReportExceptionEx,'RtlReportExceptionEx',\
RtlReportSilentProcessExit,'RtlReportSilentProcessExit',\
RtlReportSqmEscalation,'RtlReportSqmEscalation',\
RtlResetMemoryBlockLookaside,'RtlResetMemoryBlockLookaside',\
RtlResetMemoryZone,'RtlResetMemoryZone',\
RtlResetNtUserPfn,'RtlResetNtUserPfn',\
RtlResetRtlTranslations,'RtlResetRtlTranslations',\
RtlRestoreBootStatusDefaults,'RtlRestoreBootStatusDefaults',\
RtlRestoreContext,'RtlRestoreContext',\
RtlRestoreLastWin32Error,'RtlRestoreLastWin32Error',\
RtlRestoreSystemBootStatusDefaults,'RtlRestoreSystemBootStatusDefaults',\
RtlRetrieveNtUserPfn,'RtlRetrieveNtUserPfn',\
RtlRevertMemoryStream,'RtlRevertMemoryStream',\
RtlRunDecodeUnicodeString,'RtlRunDecodeUnicodeString',\
RtlRunEncodeUnicodeString,'RtlRunEncodeUnicodeString',\
RtlRunOnceBeginInitialize,'RtlRunOnceBeginInitialize',\
RtlRunOnceComplete,'RtlRunOnceComplete',\
RtlRunOnceExecuteOnce,'RtlRunOnceExecuteOnce',\
RtlRunOnceInitialize,'RtlRunOnceInitialize',\
RtlSecondsSince1970ToTime,'RtlSecondsSince1970ToTime',\
RtlSecondsSince1980ToTime,'RtlSecondsSince1980ToTime',\
RtlSeekMemoryStream,'RtlSeekMemoryStream',\
RtlSelfRelativeToAbsoluteSD,'RtlSelfRelativeToAbsoluteSD',\
RtlSelfRelativeToAbsoluteSD2,'RtlSelfRelativeToAbsoluteSD2',\
RtlSendMsgToSm,'RtlSendMsgToSm',\
RtlSetAllBits,'RtlSetAllBits',\
RtlSetAttributesSecurityDescriptor,'RtlSetAttributesSecurityDescriptor',\
RtlSetBit,'RtlSetBit',\
RtlSetBits,'RtlSetBits',\
RtlSetControlSecurityDescriptor,'RtlSetControlSecurityDescriptor',\
RtlSetCriticalSectionSpinCount,'RtlSetCriticalSectionSpinCount',\
RtlSetCurrentDirectory_U,'RtlSetCurrentDirectory_U',\
RtlSetCurrentEnvironment,'RtlSetCurrentEnvironment',\
RtlSetCurrentTransaction,'RtlSetCurrentTransaction',\
RtlSetDaclSecurityDescriptor,'RtlSetDaclSecurityDescriptor',\
RtlSetDynamicTimeZoneInformation,'RtlSetDynamicTimeZoneInformation',\
RtlSetEnvironmentStrings,'RtlSetEnvironmentStrings',\
RtlSetEnvironmentVar,'RtlSetEnvironmentVar',\
RtlSetEnvironmentVariable,'RtlSetEnvironmentVariable',\
RtlSetExtendedFeaturesMask,'RtlSetExtendedFeaturesMask',\
RtlSetGroupSecurityDescriptor,'RtlSetGroupSecurityDescriptor',\
RtlSetHeapInformation,'RtlSetHeapInformation',\
RtlSetImageMitigationPolicy,'RtlSetImageMitigationPolicy',\
RtlSetInformationAcl,'RtlSetInformationAcl',\
RtlSetIoCompletionCallback,'RtlSetIoCompletionCallback',\
RtlSetLastWin32Error,'RtlSetLastWin32Error',\
RtlSetLastWin32ErrorAndNtStatusFromNtStatus,'RtlSetLastWin32ErrorAndNtStatusFromNtStatus',\
RtlSetMemoryStreamSize,'RtlSetMemoryStreamSize',\
RtlSetOwnerSecurityDescriptor,'RtlSetOwnerSecurityDescriptor',\
RtlSetPortableOperatingSystem,'RtlSetPortableOperatingSystem',\
RtlSetProcessDebugInformation,'RtlSetProcessDebugInformation',\
RtlSetProcessIsCritical,'RtlSetProcessIsCritical',\
RtlSetProcessPlaceholderCompatibilityMode,'RtlSetProcessPlaceholderCompatibilityMode',\
RtlSetProcessPreferredUILanguages,'RtlSetProcessPreferredUILanguages',\
RtlSetProtectedPolicy,'RtlSetProtectedPolicy',\
RtlSetProxiedProcessId,'RtlSetProxiedProcessId',\
RtlSetSaclSecurityDescriptor,'RtlSetSaclSecurityDescriptor',\
RtlSetSearchPathMode,'RtlSetSearchPathMode',\
RtlSetSecurityDescriptorRMControl,'RtlSetSecurityDescriptorRMControl',\
RtlSetSecurityObject,'RtlSetSecurityObject',\
RtlSetSecurityObjectEx,'RtlSetSecurityObjectEx',\
RtlSetSystemBootStatus,'RtlSetSystemBootStatus',\
RtlSetSystemBootStatusEx,'RtlSetSystemBootStatusEx',\
RtlSetThreadErrorMode,'RtlSetThreadErrorMode',\
RtlSetThreadIsCritical,'RtlSetThreadIsCritical',\
RtlSetThreadPlaceholderCompatibilityMode,'RtlSetThreadPlaceholderCompatibilityMode',\
RtlSetThreadPoolStartFunc,'RtlSetThreadPoolStartFunc',\
RtlSetThreadPreferredUILanguages,'RtlSetThreadPreferredUILanguages',\
RtlSetThreadSubProcessTag,'RtlSetThreadSubProcessTag',\
RtlSetThreadWorkOnBehalfTicket,'RtlSetThreadWorkOnBehalfTicket',\
RtlSetTimer,'RtlSetTimer',\
RtlSetTimeZoneInformation,'RtlSetTimeZoneInformation',\
RtlSetUnhandledExceptionFilter,'RtlSetUnhandledExceptionFilter',\
RtlSetUserFlagsHeap,'RtlSetUserFlagsHeap',\
RtlSetUserValueHeap,'RtlSetUserValueHeap',\
RtlSidDominates,'RtlSidDominates',\
RtlSidDominatesForTrust,'RtlSidDominatesForTrust',\
RtlSidequalLevel,'RtlSidequalLevel',\
RtlSidHashInitialize,'RtlSidHashInitialize',\
RtlSidHashLookup,'RtlSidHashLookup',\
RtlSidIsHigherLevel,'RtlSidIsHigherLevel',\
RtlSizeHeap,'RtlSizeHeap',\
RtlSleepConditionVariableCS,'RtlSleepConditionVariableCS',\
RtlSleepConditionVariableSRW,'RtlSleepConditionVariableSRW',\
RtlSplay,'RtlSplay',\
RtlStartRXact,'RtlStartRXact',\
RtlStatMemoryStream,'RtlStatMemoryStream',\
RtlStringFromGUID,'RtlStringFromGUID',\
RtlStringFromGUIDEx,'RtlStringFromGUIDEx',\
RtlStronglyEnumerateEntryHashTable,'RtlStronglyEnumerateEntryHashTable',\
RtlSubAuthorityCountSid,'RtlSubAuthorityCountSid',\
RtlSubAuthoritySid,'RtlSubAuthoritySid',\
RtlSubscribeWnfStateChangeNotification,'RtlSubscribeWnfStateChangeNotification',\
RtlSubtreePredecessor,'RtlSubtreePredecessor',\
RtlSubtreeSuccessor,'RtlSubtreeSuccessor',\
RtlSwitchedVVI,'RtlSwitchedVVI',\
RtlSystemTimeToLocalTime,'RtlSystemTimeToLocalTime',\
RtlTestAndPublishWnfStateData,'RtlTestAndPublishWnfStateData',\
RtlTestBit,'RtlTestBit',\
RtlTestProtectedAccess,'RtlTestProtectedAccess',\
RtlTimeFieldsToTime,'RtlTimeFieldsToTime',\
RtlTimeToElapsedTimeFields,'RtlTimeToElapsedTimeFields',\
RtlTimeToSecondsSince1970,'RtlTimeToSecondsSince1970',\
RtlTimeToSecondsSince1980,'RtlTimeToSecondsSince1980',\
RtlTimeToTimeFields,'RtlTimeToTimeFields',\
RtlTraceDatabaseAdd,'RtlTraceDatabaseAdd',\
RtlTraceDatabaseCreate,'RtlTraceDatabaseCreate',\
RtlTraceDatabaseDestroy,'RtlTraceDatabaseDestroy',\
RtlTraceDatabaseEnumerate,'RtlTraceDatabaseEnumerate',\
RtlTraceDatabaseFind,'RtlTraceDatabaseFind',\
RtlTraceDatabaseLock,'RtlTraceDatabaseLock',\
RtlTraceDatabaseUnlock,'RtlTraceDatabaseUnlock',\
RtlTraceDatabaseValidate,'RtlTraceDatabaseValidate',\
RtlTryAcquirePebLock,'RtlTryAcquirePebLock',\
RtlTryAcquireSRWLockExclusive,'RtlTryAcquireSRWLockExclusive',\
RtlTryAcquireSRWLockShared,'RtlTryAcquireSRWLockShared',\
RtlTryConvertSRWLockSharedToExclusiveOrRelease,'RtlTryConvertSRWLockSharedToExclusiveOrRelease',\
RtlTryEnterCriticalSection,'RtlTryEnterCriticalSection',\
RtlUdiv128,'RtlUdiv128',\
RtlUnhandledExceptionFilter,'RtlUnhandledExceptionFilter',\
RtlUnhandledExceptionFilter2,'RtlUnhandledExceptionFilter2',\
RtlUnicodeStringToAnsiSize,'RtlUnicodeStringToAnsiSize',\
RtlUnicodeStringToAnsiString,'RtlUnicodeStringToAnsiString',\
RtlUnicodeStringToCountedOemString,'RtlUnicodeStringToCountedOemString',\
RtlUnicodeStringToInteger,'RtlUnicodeStringToInteger',\
RtlUnicodeStringToOemSize,'RtlUnicodeStringToOemSize',\
RtlUnicodeStringToOemString,'RtlUnicodeStringToOemString',\
RtlUnicodeToCustomCPN,'RtlUnicodeToCustomCPN',\
RtlUnicodeToMultiByteN,'RtlUnicodeToMultiByteN',\
RtlUnicodeToMultiByteSize,'RtlUnicodeToMultiByteSize',\
RtlUnicodeToOemN,'RtlUnicodeToOemN',\
RtlUnicodeToUTF8N,'RtlUnicodeToUTF8N',\
RtlUniform,'RtlUniform',\
RtlUnlockBootStatusData,'RtlUnlockBootStatusData',\
RtlUnlockCurrentThread,'RtlUnlockCurrentThread',\
RtlUnlockHeap,'RtlUnlockHeap',\
RtlUnlockMemoryBlockLookaside,'RtlUnlockMemoryBlockLookaside',\
RtlUnlockMemoryStreamRegion,'RtlUnlockMemoryStreamRegion',\
RtlUnlockMemoryZone,'RtlUnlockMemoryZone',\
RtlUnlockModuleSection,'RtlUnlockModuleSection',\
RtlUnsubscribeWnfNotificationWaitForCompletion,'RtlUnsubscribeWnfNotificationWaitForCompletion',\
RtlUnsubscribeWnfNotificationWithCompletionCallback,'RtlUnsubscribeWnfNotificationWithCompletionCallback',\
RtlUnsubscribeWnfStateChangeNotification,'RtlUnsubscribeWnfStateChangeNotification',\
RtlUnwind,'RtlUnwind',\
RtlUnwindEx,'RtlUnwindEx',\
RtlUpcaseUnicodeChar,'RtlUpcaseUnicodeChar',\
RtlUpcaseUnicodeString,'RtlUpcaseUnicodeString',\
RtlUpcaseUnicodeStringToAnsiString,'RtlUpcaseUnicodeStringToAnsiString',\
RtlUpcaseUnicodeStringToCountedOemString,'RtlUpcaseUnicodeStringToCountedOemString',\
RtlUpcaseUnicodeStringToOemString,'RtlUpcaseUnicodeStringToOemString',\
RtlUpcaseUnicodeToCustomCPN,'RtlUpcaseUnicodeToCustomCPN',\
RtlUpcaseUnicodeToMultiByteN,'RtlUpcaseUnicodeToMultiByteN',\
RtlUpcaseUnicodeToOemN,'RtlUpcaseUnicodeToOemN',\
RtlUpdateClonedCriticalSection,'RtlUpdateClonedCriticalSection',\
RtlUpdateClonedSRWLock,'RtlUpdateClonedSRWLock',\
RtlUpdateTimer,'RtlUpdateTimer',\
RtlUpperChar,'RtlUpperChar',\
RtlUpperString,'RtlUpperString',\
RtlUserThreadStart,'RtlUserThreadStart',\
RtlUTF8ToUnicodeN,'RtlUTF8ToUnicodeN',\
RtlValidAcl,'RtlValidAcl',\
RtlValidateCorrelationVector,'RtlValidateCorrelationVector',\
RtlValidateHeap,'RtlValidateHeap',\
RtlValidateProcessHeaps,'RtlValidateProcessHeaps',\
RtlValidateUnicodeString,'RtlValidateUnicodeString',\
RtlValidProcessProtection,'RtlValidProcessProtection',\
RtlValidRelativeSecurityDescriptor,'RtlValidRelativeSecurityDescriptor',\
RtlValidSecurityDescriptor,'RtlValidSecurityDescriptor',\
RtlValidSid,'RtlValidSid',\
RtlVerifyVersionInfo,'RtlVerifyVersionInfo',\
RtlVirtualUnwind,'RtlVirtualUnwind',\
RtlWaitForWnfMetaNotification,'RtlWaitForWnfMetaNotification',\
RtlWaitOnAddress,'RtlWaitOnAddress',\
RtlWakeAddressAll,'RtlWakeAddressAll',\
RtlWakeAddressAllNoFence,'RtlWakeAddressAllNoFence',\
RtlWakeAddressSingle,'RtlWakeAddressSingle',\
RtlWakeAddressSingleNoFence,'RtlWakeAddressSingleNoFence',\
RtlWakeAllConditionVariable,'RtlWakeAllConditionVariable',\
RtlWakeConditionVariable,'RtlWakeConditionVariable',\
RtlWalkFrameChain,'RtlWalkFrameChain',\
RtlWalkHeap,'RtlWalkHeap',\
RtlWeaklyEnumerateEntryHashTable,'RtlWeaklyEnumerateEntryHashTable',\
RtlWerpReportException,'RtlWerpReportException',\
RtlWnfCompareChangeStamp,'RtlWnfCompareChangeStamp',\
RtlWnfDllUnloadCallback,'RtlWnfDllUnloadCallback',\
RtlWow64CallFunction64,'RtlWow64CallFunction64',\
RtlWow64EnableFsRedirection,'RtlWow64EnableFsRedirection',\
RtlWow64EnableFsRedirectionEx,'RtlWow64EnableFsRedirectionEx',\
RtlWow64GetCpuAreaInfo,'RtlWow64GetCpuAreaInfo',\
RtlWow64GetCurrentMachine,'RtlWow64GetCurrentMachine',\
RtlWow64GetequivalentMachineCHPE,'RtlWow64GetequivalentMachineCHPE',\
RtlWow64GetProcessMachines,'RtlWow64GetProcessMachines',\
RtlWow64GetSharedInfoProcess,'RtlWow64GetSharedInfoProcess',\
RtlWow64GetThreadContext,'RtlWow64GetThreadContext',\
RtlWow64IsWowGuestMachineSupported,'RtlWow64IsWowGuestMachineSupported',\
RtlWow64LogMessageInEventLogger,'RtlWow64LogMessageInEventLogger',\
RtlWow64SetThreadContext,'RtlWow64SetThreadContext',\
RtlWriteMemoryStream,'RtlWriteMemoryStream',\
RtlWriteNonVolatileMemory,'RtlWriteNonVolatileMemory',\
RtlWriteRegistryValue,'RtlWriteRegistryValue',\
RtlxAnsiStringToUnicodeSize,'RtlxAnsiStringToUnicodeSize',\
RtlxOemStringToUnicodeSize,'RtlxOemStringToUnicodeSize',\
RtlxUnicodeStringToAnsiSize,'RtlxUnicodeStringToAnsiSize',\
RtlxUnicodeStringToOemSize,'RtlxUnicodeStringToOemSize',\
RtlZeroHeap,'RtlZeroHeap',\
RtlZeroMemory,'RtlZeroMemory',\
RtlZombifyActivationContext,'RtlZombifyActivationContext',\
SbExecuteProcedure,'SbExecuteProcedure',\
SbSelectProcedure,'SbSelectProcedure',\
ShipAssert,'ShipAssert',\
ShipAssertGetBufferInfo,'ShipAssertGetBufferInfo',\
ShipAssertMsgA,'ShipAssertMsgA',\
ShipAssertMsgW,'ShipAssertMsgW',\
sin,'sin',\
sprintf,'sprintf',\
sprintf_s,'sprintf_s',\
sqrt,'sqrt',\
sscanf,'sscanf',\
sscanf_s,'sscanf_s',\
strcat,'strcat',\
strcat_s,'strcat_s',\
strchr,'strchr',\
strcmp,'strcmp',\
strcpy,'strcpy',\
strcpy_s,'strcpy_s',\
strcspn,'strcspn',\
strlen,'strlen',\
strncat,'strncat',\
strncat_s,'strncat_s',\
strncmp,'strncmp',\
strncpy,'strncpy',\
strncpy_s,'strncpy_s',\
strnlen,'strnlen',\
strpbrk,'strpbrk',\
strrchr,'strrchr',\
strspn,'strspn',\
strstr,'strstr',\
strtok_s,'strtok_s',\
strtol,'strtol',\
strtoul,'strtoul',\
swprintf,'swprintf',\
swprintf_s,'swprintf_s',\
swscanf_s,'swscanf_s',\
tan,'tan',\
tolower,'tolower',\
toupper,'toupper',\
towlower,'towlower',\
towupper,'towupper',\
TpAllocAlpcCompletion,'TpAllocAlpcCompletion',\
TpAllocAlpcCompletionEx,'TpAllocAlpcCompletionEx',\
TpAllocCleanupGroup,'TpAllocCleanupGroup',\
TpAllocIoCompletion,'TpAllocIoCompletion',\
TpAllocJobNotification,'TpAllocJobNotification',\
TpAllocPool,'TpAllocPool',\
TpAllocTimer,'TpAllocTimer',\
TpAllocWait,'TpAllocWait',\
TpAllocWork,'TpAllocWork',\
TpAlpcRegisterCompletionList,'TpAlpcRegisterCompletionList',\
TpAlpcUnregisterCompletionList,'TpAlpcUnregisterCompletionList',\
TpCallbackDetectedUnrecoverableError,'TpCallbackDetectedUnrecoverableError',\
TpCallbackIndependent,'TpCallbackIndependent',\
TpCallbackLeaveCriticalSectionOnCompletion,'TpCallbackLeaveCriticalSectionOnCompletion',\
TpCallbackMayRunLong,'TpCallbackMayRunLong',\
TpCallbackReleaseMutexOnCompletion,'TpCallbackReleaseMutexOnCompletion',\
TpCallbackReleaseSemaphoreOnCompletion,'TpCallbackReleaseSemaphoreOnCompletion',\
TpCallbackSendAlpcMessageOnCompletion,'TpCallbackSendAlpcMessageOnCompletion',\
TpCallbackSendPendingAlpcMessage,'TpCallbackSendPendingAlpcMessage',\
TpCallbackSetEventOnCompletion,'TpCallbackSetEventOnCompletion',\
TpCallbackUnloadDllOnCompletion,'TpCallbackUnloadDllOnCompletion',\
TpCancelAsyncIoOperation,'TpCancelAsyncIoOperation',\
TpCaptureCaller,'TpCaptureCaller',\
TpCheckTerminateWorker,'TpCheckTerminateWorker',\
TpDbgDumpHeapUsage,'TpDbgDumpHeapUsage',\
TpDbgSetLogRoutine,'TpDbgSetLogRoutine',\
TpDisablePoolCallbackChecks,'TpDisablePoolCallbackChecks',\
TpDisassociateCallback,'TpDisassociateCallback',\
TpIsTimerSet,'TpIsTimerSet',\
TpPostWork,'TpPostWork',\
TpQueryPoolStackInformation,'TpQueryPoolStackInformation',\
TpReleaseAlpcCompletion,'TpReleaseAlpcCompletion',\
TpReleaseCleanupGroup,'TpReleaseCleanupGroup',\
TpReleaseCleanupGroupMembers,'TpReleaseCleanupGroupMembers',\
TpReleaseIoCompletion,'TpReleaseIoCompletion',\
TpReleaseJobNotification,'TpReleaseJobNotification',\
TpReleasePool,'TpReleasePool',\
TpReleaseTimer,'TpReleaseTimer',\
TpReleaseWait,'TpReleaseWait',\
TpReleaseWork,'TpReleaseWork',\
TpSetDefaultPoolMaxThreads,'TpSetDefaultPoolMaxThreads',\
TpSetDefaultPoolStackInformation,'TpSetDefaultPoolStackInformation',\
TpSetPoolMaxThreads,'TpSetPoolMaxThreads',\
TpSetPoolMaxThreadsSoftLimit,'TpSetPoolMaxThreadsSoftLimit',\
TpSetPoolMinThreads,'TpSetPoolMinThreads',\
TpSetPoolStackInformation,'TpSetPoolStackInformation',\
TpSetPoolThreadBasePriority,'TpSetPoolThreadBasePriority',\
TpSetPoolThreadCpuSets,'TpSetPoolThreadCpuSets',\
TpSetPoolWorkerThreadIdleTimeout,'TpSetPoolWorkerThreadIdleTimeout',\
TpSetTimer,'TpSetTimer',\
TpSetTimerEx,'TpSetTimerEx',\
TpSetWait,'TpSetWait',\
TpSetWaitEx,'TpSetWaitEx',\
TpSimpleTryPost,'TpSimpleTryPost',\
TpStartAsyncIoOperation,'TpStartAsyncIoOperation',\
TpTimerOutstandingCallbackCount,'TpTimerOutstandingCallbackCount',\
TpTrimPools,'TpTrimPools',\
TpWaitForAlpcCompletion,'TpWaitForAlpcCompletion',\
TpWaitForIoCompletion,'TpWaitForIoCompletion',\
TpWaitForJobNotification,'TpWaitForJobNotification',\
TpWaitForTimer,'TpWaitForTimer',\
TpWaitForWait,'TpWaitForWait',\
TpWaitForWork,'TpWaitForWork',\
vDbgPrintEx,'vDbgPrintEx',\
vDbgPrintExWithPrefix,'vDbgPrintExWithPrefix',\
VerSetConditionMask,'VerSetConditionMask',\
vsprintf,'vsprintf',\
vsprintf_s,'vsprintf_s',\
vswprintf_s,'vswprintf_s',\
wcscat,'wcscat',\
wcscat_s,'wcscat_s',\
wcschr,'wcschr',\
wcscmp,'wcscmp',\
wcscpy,'wcscpy',\
wcscpy_s,'wcscpy_s',\
wcscspn,'wcscspn',\
wcslen,'wcslen',\
wcsncat,'wcsncat',\
wcsncat_s,'wcsncat_s',\
wcsncmp,'wcsncmp',\
wcsncpy,'wcsncpy',\
wcsncpy_s,'wcsncpy_s',\
wcsnlen,'wcsnlen',\
wcspbrk,'wcspbrk',\
wcsrchr,'wcsrchr',\
wcsspn,'wcsspn',\
wcsstr,'wcsstr',\
wcstok_s,'wcstok_s',\
wcstol,'wcstol',\
wcstombs,'wcstombs',\
wcstoul,'wcstoul',\
WerReportExceptionWorker,'WerReportExceptionWorker',\
WerReportSQMEvent,'WerReportSQMEvent',\
WinSqmAddToAverageDWORD,'WinSqmAddToAverageDWORD',\
WinSqmAddToStream,'WinSqmAddToStream',\
WinSqmAddToStreamEx,'WinSqmAddToStreamEx',\
WinSqmCheckEscalationAddToStreamEx,'WinSqmCheckEscalationAddToStreamEx',\
WinSqmCheckEscalationSetDWORD,'WinSqmCheckEscalationSetDWORD',\
WinSqmCheckEscalationSetDWORD64,'WinSqmCheckEscalationSetDWORD64',\
WinSqmCheckEscalationSetString,'WinSqmCheckEscalationSetString',\
WinSqmCommonDatapointDelete,'WinSqmCommonDatapointDelete',\
WinSqmCommonDatapointSetDWORD,'WinSqmCommonDatapointSetDWORD',\
WinSqmCommonDatapointSetDWORD64,'WinSqmCommonDatapointSetDWORD64',\
WinSqmCommonDatapointSetStreamEx,'WinSqmCommonDatapointSetStreamEx',\
WinSqmCommonDatapointSetString,'WinSqmCommonDatapointSetString',\
WinSqmEndSession,'WinSqmEndSession',\
WinSqmEventEnabled,'WinSqmEventEnabled',\
WinSqmEventWrite,'WinSqmEventWrite',\
WinSqmGetEscalationRuleStatus,'WinSqmGetEscalationRuleStatus',\
WinSqmGetInstrumentationProperty,'WinSqmGetInstrumentationProperty',\
WinSqmIncrementDWORD,'WinSqmIncrementDWORD',\
WinSqmIsOptedIn,'WinSqmIsOptedIn',\
WinSqmIsOptedInEx,'WinSqmIsOptedInEx',\
WinSqmIsSessionDisabled,'WinSqmIsSessionDisabled',\
WinSqmSetDWORD,'WinSqmSetDWORD',\
WinSqmSetDWORD64,'WinSqmSetDWORD64',\
WinSqmSetEscalationInfo,'WinSqmSetEscalationInfo',\
WinSqmSetIfMaxDWORD,'WinSqmSetIfMaxDWORD',\
WinSqmSetIfMinDWORD,'WinSqmSetIfMinDWORD',\
WinSqmSetString,'WinSqmSetString',\
WinSqmStartSession,'WinSqmStartSession',\
WinSqmStartSessionForPartner,'WinSqmStartSessionForPartner',\
WinSqmStartSqmOptinListener,'WinSqmStartSqmOptinListener',\
ZwAcceptConnectPort,'ZwAcceptConnectPort',\
ZwAccessCheck,'ZwAccessCheck',\
ZwAccessCheckAndAuditAlarm,'ZwAccessCheckAndAuditAlarm',\
ZwAccessCheckByType,'ZwAccessCheckByType',\
ZwAccessCheckByTypeAndAuditAlarm,'ZwAccessCheckByTypeAndAuditAlarm',\
ZwAccessCheckByTypeResultList,'ZwAccessCheckByTypeResultList',\
ZwAccessCheckByTypeResultListAndAuditAlarm,'ZwAccessCheckByTypeResultListAndAuditAlarm',\
ZwAccessCheckByTypeResultListAndAuditAlarmByHandle,'ZwAccessCheckByTypeResultListAndAuditAlarmByHandle',\
ZwAcquireProcessActivityReference,'ZwAcquireProcessActivityReference',\
ZwAddAtom,'ZwAddAtom',\
ZwAddAtomEx,'ZwAddAtomEx',\
ZwAddBootEntry,'ZwAddBootEntry',\
ZwAddDriverEntry,'ZwAddDriverEntry',\
ZwAdjustGroupsToken,'ZwAdjustGroupsToken',\
ZwAdjustPrivilegesToken,'ZwAdjustPrivilegesToken',\
ZwAdjustTokenClaimsAndDeviceGroups,'ZwAdjustTokenClaimsAndDeviceGroups',\
ZwAlertResumeThread,'ZwAlertResumeThread',\
ZwAlertThread,'ZwAlertThread',\
ZwAlertThreadByThreadId,'ZwAlertThreadByThreadId',\
ZwAllocateLocallyUniqueId,'ZwAllocateLocallyUniqueId',\
ZwAllocateReserveObject,'ZwAllocateReserveObject',\
ZwAllocateUserPhysicalPages,'ZwAllocateUserPhysicalPages',\
ZwAllocateUuids,'ZwAllocateUuids',\
ZwAllocateVirtualMemory,'ZwAllocateVirtualMemory',\
ZwAllocateVirtualMemoryEx,'ZwAllocateVirtualMemoryEx',\
ZwAlpcAcceptConnectPort,'ZwAlpcAcceptConnectPort',\
ZwAlpcCancelMessage,'ZwAlpcCancelMessage',\
ZwAlpcConnectPort,'ZwAlpcConnectPort',\
ZwAlpcConnectPortEx,'ZwAlpcConnectPortEx',\
ZwAlpcCreatePort,'ZwAlpcCreatePort',\
ZwAlpcCreatePortSection,'ZwAlpcCreatePortSection',\
ZwAlpcCreateResourceReserve,'ZwAlpcCreateResourceReserve',\
ZwAlpcCreateSectionView,'ZwAlpcCreateSectionView',\
ZwAlpcCreateSecurityContext,'ZwAlpcCreateSecurityContext',\
ZwAlpcDeletePortSection,'ZwAlpcDeletePortSection',\
ZwAlpcDeleteResourceReserve,'ZwAlpcDeleteResourceReserve',\
ZwAlpcDeleteSectionView,'ZwAlpcDeleteSectionView',\
ZwAlpcDeleteSecurityContext,'ZwAlpcDeleteSecurityContext',\
ZwAlpcDisconnectPort,'ZwAlpcDisconnectPort',\
ZwAlpcImpersonateClientContainerOfPort,'ZwAlpcImpersonateClientContainerOfPort',\
ZwAlpcImpersonateClientOfPort,'ZwAlpcImpersonateClientOfPort',\
ZwAlpcOpenSenderProcess,'ZwAlpcOpenSenderProcess',\
ZwAlpcOpenSenderThread,'ZwAlpcOpenSenderThread',\
ZwAlpcQueryInformation,'ZwAlpcQueryInformation',\
ZwAlpcQueryInformationMessage,'ZwAlpcQueryInformationMessage',\
ZwAlpcRevokeSecurityContext,'ZwAlpcRevokeSecurityContext',\
ZwAlpcSendWaitReceivePort,'ZwAlpcSendWaitReceivePort',\
ZwAlpcSetInformation,'ZwAlpcSetInformation',\
ZwAreMappedFilesTheSame,'ZwAreMappedFilesTheSame',\
ZwAssignProcessToJobObject,'ZwAssignProcessToJobObject',\
ZwAssociateWaitCompletionPacket,'ZwAssociateWaitCompletionPacket',\
ZwCallbackReturn,'ZwCallbackReturn',\
ZwCallEnclave,'ZwCallEnclave',\
ZwCancelIoFile,'ZwCancelIoFile',\
ZwCancelIoFileEx,'ZwCancelIoFileEx',\
ZwCancelSynchronousIoFile,'ZwCancelSynchronousIoFile',\
ZwCancelTimer,'ZwCancelTimer',\
ZwCancelTimer2,'ZwCancelTimer2',\
ZwCancelWaitCompletionPacket,'ZwCancelWaitCompletionPacket',\
ZwClearEvent,'ZwClearEvent',\
ZwClose,'ZwClose',\
ZwCloseObjectAuditAlarm,'ZwCloseObjectAuditAlarm',\
ZwCommitComplete,'ZwCommitComplete',\
ZwCommitEnlistment,'ZwCommitEnlistment',\
ZwCommitRegistryTransaction,'ZwCommitRegistryTransaction',\
ZwCommitTransaction,'ZwCommitTransaction',\
ZwCompactKeys,'ZwCompactKeys',\
ZwCompareObjects,'ZwCompareObjects',\
ZwCompareSigningLevels,'ZwCompareSigningLevels',\
ZwCompareTokens,'ZwCompareTokens',\
ZwCompleteConnectPort,'ZwCompleteConnectPort',\
ZwCompressKey,'ZwCompressKey',\
ZwConnectPort,'ZwConnectPort',\
ZwContinue,'ZwContinue',\
ZwConvertBetweenAuxiliaryCounterAndPerformanceCounter,'ZwConvertBetweenAuxiliaryCounterAndPerformanceCounter',\
ZwCreateCrossVmEvent,'ZwCreateCrossVmEvent',\
ZwCreateDebugObject,'ZwCreateDebugObject',\
ZwCreateDirectoryObject,'ZwCreateDirectoryObject',\
ZwCreateDirectoryObjectEx,'ZwCreateDirectoryObjectEx',\
ZwCreateEnclave,'ZwCreateEnclave',\
ZwCreateEnlistment,'ZwCreateEnlistment',\
ZwCreateEvent,'ZwCreateEvent',\
ZwCreateEventPair,'ZwCreateEventPair',\
ZwCreateFile,'ZwCreateFile',\
ZwCreateIoCompletion,'ZwCreateIoCompletion',\
ZwCreateIRTimer,'ZwCreateIRTimer',\
ZwCreateJobObject,'ZwCreateJobObject',\
ZwCreateJobSet,'ZwCreateJobSet',\
ZwCreateKey,'ZwCreateKey',\
ZwCreateKeyedEvent,'ZwCreateKeyedEvent',\
ZwCreateKeyTransacted,'ZwCreateKeyTransacted',\
ZwCreateLowBoxToken,'ZwCreateLowBoxToken',\
ZwCreateMailslotFile,'ZwCreateMailslotFile',\
ZwCreateMutant,'ZwCreateMutant',\
ZwCreateNamedPipeFile,'ZwCreateNamedPipeFile',\
ZwCreatePagingFile,'ZwCreatePagingFile',\
ZwCreatePartition,'ZwCreatePartition',\
ZwCreatePort,'ZwCreatePort',\
ZwCreatePrivateNamespace,'ZwCreatePrivateNamespace',\
ZwCreateProcess,'ZwCreateProcess',\
ZwCreateProcessEx,'ZwCreateProcessEx',\
ZwCreateProfile,'ZwCreateProfile',\
ZwCreateProfileEx,'ZwCreateProfileEx',\
ZwCreateRegistryTransaction,'ZwCreateRegistryTransaction',\
ZwCreateResourceManager,'ZwCreateResourceManager',\
ZwCreateSection,'ZwCreateSection',\
ZwCreateSectionEx,'ZwCreateSectionEx',\
ZwCreateSemaphore,'ZwCreateSemaphore',\
ZwCreateSymbolicLinkObject,'ZwCreateSymbolicLinkObject',\
ZwCreateThread,'ZwCreateThread',\
ZwCreateThreadEx,'ZwCreateThreadEx',\
ZwCreateTimer,'ZwCreateTimer',\
ZwCreateTimer2,'ZwCreateTimer2',\
ZwCreateToken,'ZwCreateToken',\
ZwCreateTokenEx,'ZwCreateTokenEx',\
ZwCreateTransaction,'ZwCreateTransaction',\
ZwCreateTransactionManager,'ZwCreateTransactionManager',\
ZwCreateUserProcess,'ZwCreateUserProcess',\
ZwCreateWaitablePort,'ZwCreateWaitablePort',\
ZwCreateWaitCompletionPacket,'ZwCreateWaitCompletionPacket',\
ZwCreateWnfStateName,'ZwCreateWnfStateName',\
ZwCreateWorkerFactory,'ZwCreateWorkerFactory',\
ZwDebugActiveProcess,'ZwDebugActiveProcess',\
ZwDebugContinue,'ZwDebugContinue',\
ZwDelayExecution,'ZwDelayExecution',\
ZwDeleteAtom,'ZwDeleteAtom',\
ZwDeleteBootEntry,'ZwDeleteBootEntry',\
ZwDeleteDriverEntry,'ZwDeleteDriverEntry',\
ZwDeleteFile,'ZwDeleteFile',\
ZwDeleteKey,'ZwDeleteKey',\
ZwDeleteObjectAuditAlarm,'ZwDeleteObjectAuditAlarm',\
ZwDeletePrivateNamespace,'ZwDeletePrivateNamespace',\
ZwDeleteValueKey,'ZwDeleteValueKey',\
ZwDeleteWnfStateData,'ZwDeleteWnfStateData',\
ZwDeleteWnfStateName,'ZwDeleteWnfStateName',\
ZwDeviceIoControlFile,'ZwDeviceIoControlFile',\
ZwDisableLastKnownGood,'ZwDisableLastKnownGood',\
ZwDisplayString,'ZwDisplayString',\
ZwDrawText,'ZwDrawText',\
ZwDuplicateObject,'ZwDuplicateObject',\
ZwDuplicateToken,'ZwDuplicateToken',\
ZwEnableLastKnownGood,'ZwEnableLastKnownGood',\
ZwEnumerateBootEntries,'ZwEnumerateBootEntries',\
ZwEnumerateDriverEntries,'ZwEnumerateDriverEntries',\
ZwEnumerateKey,'ZwEnumerateKey',\
ZwEnumerateSystemEnvironmentValuesEx,'ZwEnumerateSystemEnvironmentValuesEx',\
ZwEnumerateTransactionObject,'ZwEnumerateTransactionObject',\
ZwEnumerateValueKey,'ZwEnumerateValueKey',\
ZwExtendSection,'ZwExtendSection',\
ZwFilterBootOption,'ZwFilterBootOption',\
ZwFilterToken,'ZwFilterToken',\
ZwFilterTokenEx,'ZwFilterTokenEx',\
ZwFindAtom,'ZwFindAtom',\
ZwFlushBuffersFile,'ZwFlushBuffersFile',\
ZwFlushBuffersFileEx,'ZwFlushBuffersFileEx',\
ZwFlushInstallUILanguage,'ZwFlushInstallUILanguage',\
ZwFlushInstructionCache,'ZwFlushInstructionCache',\
ZwFlushKey,'ZwFlushKey',\
ZwFlushProcessWriteBuffers,'ZwFlushProcessWriteBuffers',\
ZwFlushVirtualMemory,'ZwFlushVirtualMemory',\
ZwFlushWriteBuffer,'ZwFlushWriteBuffer',\
ZwFreeUserPhysicalPages,'ZwFreeUserPhysicalPages',\
ZwFreeVirtualMemory,'ZwFreeVirtualMemory',\
ZwFreezeRegistry,'ZwFreezeRegistry',\
ZwFreezeTransactions,'ZwFreezeTransactions',\
ZwFsControlFile,'ZwFsControlFile',\
ZwGetCachedSigningLevel,'ZwGetCachedSigningLevel',\
ZwGetCompleteWnfStateSubscription,'ZwGetCompleteWnfStateSubscription',\
ZwGetContextThread,'ZwGetContextThread',\
ZwGetCurrentProcessorNumber,'ZwGetCurrentProcessorNumber',\
ZwGetCurrentProcessorNumberEx,'ZwGetCurrentProcessorNumberEx',\
ZwGetDevicePowerState,'ZwGetDevicePowerState',\
ZwGetMUIRegistryInfo,'ZwGetMUIRegistryInfo',\
ZwGetNextProcess,'ZwGetNextProcess',\
ZwGetNextThread,'ZwGetNextThread',\
ZwGetNlsSectionPtr,'ZwGetNlsSectionPtr',\
ZwGetNotificationResourceManager,'ZwGetNotificationResourceManager',\
ZwGetWriteWatch,'ZwGetWriteWatch',\
ZwImpersonateAnonymousToken,'ZwImpersonateAnonymousToken',\
ZwImpersonateClientOfPort,'ZwImpersonateClientOfPort',\
ZwImpersonateThread,'ZwImpersonateThread',\
ZwInitializeEnclave,'ZwInitializeEnclave',\
ZwInitializeNlsFiles,'ZwInitializeNlsFiles',\
ZwInitializeRegistry,'ZwInitializeRegistry',\
ZwInitiatePowerAction,'ZwInitiatePowerAction',\
ZwIsProcessInJob,'ZwIsProcessInJob',\
ZwIsSystemResumeAutomatic,'ZwIsSystemResumeAutomatic',\
ZwIsUILanguageComitted,'ZwIsUILanguageComitted',\
ZwListenPort,'ZwListenPort',\
ZwLoadDriver,'ZwLoadDriver',\
ZwLoadEnclaveData,'ZwLoadEnclaveData',\
ZwLoadKey,'ZwLoadKey',\
ZwLoadKey2,'ZwLoadKey2',\
ZwLoadKeyEx,'ZwLoadKeyEx',\
ZwLockFile,'ZwLockFile',\
ZwLockProductActivationKeys,'ZwLockProductActivationKeys',\
ZwLockRegistryKey,'ZwLockRegistryKey',\
ZwLockVirtualMemory,'ZwLockVirtualMemory',\
ZwMakePermanentObject,'ZwMakePermanentObject',\
ZwMakeTemporaryObject,'ZwMakeTemporaryObject',\
ZwManageHotPatch,'ZwManageHotPatch',\
ZwManagePartition,'ZwManagePartition',\
ZwMapCMFModule,'ZwMapCMFModule',\
ZwMapUserPhysicalPages,'ZwMapUserPhysicalPages',\
ZwMapUserPhysicalPagesScatter,'ZwMapUserPhysicalPagesScatter',\
ZwMapViewOfSection,'ZwMapViewOfSection',\
ZwMapViewOfSectionEx,'ZwMapViewOfSectionEx',\
ZwModifyBootEntry,'ZwModifyBootEntry',\
ZwModifyDriverEntry,'ZwModifyDriverEntry',\
ZwNotifyChangeDirectoryFile,'ZwNotifyChangeDirectoryFile',\
ZwNotifyChangeDirectoryFileEx,'ZwNotifyChangeDirectoryFileEx',\
ZwNotifyChangeKey,'ZwNotifyChangeKey',\
ZwNotifyChangeMultipleKeys,'ZwNotifyChangeMultipleKeys',\
ZwNotifyChangeSession,'ZwNotifyChangeSession',\
ZwOpenDirectoryObject,'ZwOpenDirectoryObject',\
ZwOpenEnlistment,'ZwOpenEnlistment',\
ZwOpenEvent,'ZwOpenEvent',\
ZwOpenEventPair,'ZwOpenEventPair',\
ZwOpenFile,'ZwOpenFile',\
ZwOpenIoCompletion,'ZwOpenIoCompletion',\
ZwOpenJobObject,'ZwOpenJobObject',\
ZwOpenKey,'ZwOpenKey',\
ZwOpenKeyedEvent,'ZwOpenKeyedEvent',\
ZwOpenKeyEx,'ZwOpenKeyEx',\
ZwOpenKeyTransacted,'ZwOpenKeyTransacted',\
ZwOpenKeyTransactedEx,'ZwOpenKeyTransactedEx',\
ZwOpenMutant,'ZwOpenMutant',\
ZwOpenObjectAuditAlarm,'ZwOpenObjectAuditAlarm',\
ZwOpenPartition,'ZwOpenPartition',\
ZwOpenPrivateNamespace,'ZwOpenPrivateNamespace',\
ZwOpenProcess,'ZwOpenProcess',\
ZwOpenProcessToken,'ZwOpenProcessToken',\
ZwOpenProcessTokenEx,'ZwOpenProcessTokenEx',\
ZwOpenRegistryTransaction,'ZwOpenRegistryTransaction',\
ZwOpenResourceManager,'ZwOpenResourceManager',\
ZwOpenSection,'ZwOpenSection',\
ZwOpenSemaphore,'ZwOpenSemaphore',\
ZwOpenSession,'ZwOpenSession',\
ZwOpenSymbolicLinkObject,'ZwOpenSymbolicLinkObject',\
ZwOpenThread,'ZwOpenThread',\
ZwOpenThreadToken,'ZwOpenThreadToken',\
ZwOpenThreadTokenEx,'ZwOpenThreadTokenEx',\
ZwOpenTimer,'ZwOpenTimer',\
ZwOpenTransaction,'ZwOpenTransaction',\
ZwOpenTransactionManager,'ZwOpenTransactionManager',\
ZwPlugPlayControl,'ZwPlugPlayControl',\
ZwPowerInformation,'ZwPowerInformation',\
ZwPrepareComplete,'ZwPrepareComplete',\
ZwPrepareEnlistment,'ZwPrepareEnlistment',\
ZwPrePrepareComplete,'ZwPrePrepareComplete',\
ZwPrePrepareEnlistment,'ZwPrePrepareEnlistment',\
ZwPrivilegeCheck,'ZwPrivilegeCheck',\
ZwPrivilegedServiceAuditAlarm,'ZwPrivilegedServiceAuditAlarm',\
ZwPrivilegeObjectAuditAlarm,'ZwPrivilegeObjectAuditAlarm',\
ZwPropagationComplete,'ZwPropagationComplete',\
ZwPropagationFailed,'ZwPropagationFailed',\
ZwProtectVirtualMemory,'ZwProtectVirtualMemory',\
ZwPulseEvent,'ZwPulseEvent',\
ZwQueryAttributesFile,'ZwQueryAttributesFile',\
ZwQueryAuxiliaryCounterFrequency,'ZwQueryAuxiliaryCounterFrequency',\
ZwQueryBootEntryOrder,'ZwQueryBootEntryOrder',\
ZwQueryBootOptions,'ZwQueryBootOptions',\
ZwQueryDebugFilterState,'ZwQueryDebugFilterState',\
ZwQueryDefaultLocale,'ZwQueryDefaultLocale',\
ZwQueryDefaultUILanguage,'ZwQueryDefaultUILanguage',\
ZwQueryDirectoryFile,'ZwQueryDirectoryFile',\
ZwQueryDirectoryObject,'ZwQueryDirectoryObject',\
ZwQueryDriverEntryOrder,'ZwQueryDriverEntryOrder',\
ZwQueryEaFile,'ZwQueryEaFile',\
ZwQueryEvent,'ZwQueryEvent',\
ZwQueryFullAttributesFile,'ZwQueryFullAttributesFile',\
ZwQueryInformationAtom,'ZwQueryInformationAtom',\
ZwQueryInformationByName,'ZwQueryInformationByName',\
ZwQueryInformationEnlistment,'ZwQueryInformationEnlistment',\
ZwQueryInformationFile,'ZwQueryInformationFile',\
ZwQueryInformationJobObject,'ZwQueryInformationJobObject',\
ZwQueryInformationPort,'ZwQueryInformationPort',\
ZwQueryInformationProcess,'ZwQueryInformationProcess',\
ZwQueryInformationResourceManager,'ZwQueryInformationResourceManager',\
ZwQueryInformationThread,'ZwQueryInformationThread',\
ZwQueryInformationToken,'ZwQueryInformationToken',\
ZwQueryInformationTransaction,'ZwQueryInformationTransaction',\
ZwQueryInformationTransactionManager,'ZwQueryInformationTransactionManager',\
ZwQueryInformationWorkerFactory,'ZwQueryInformationWorkerFactory',\
ZwQueryInstallUILanguage,'ZwQueryInstallUILanguage',\
ZwQueryIntervalProfile,'ZwQueryIntervalProfile',\
ZwQueryIoCompletion,'ZwQueryIoCompletion',\
ZwQueryKey,'ZwQueryKey',\
ZwQueryLicenseValue,'ZwQueryLicenseValue',\
ZwQueryMultipleValueKey,'ZwQueryMultipleValueKey',\
ZwQueryMutant,'ZwQueryMutant',\
ZwQueryObject,'ZwQueryObject',\
ZwQueryOpenSubKeys,'ZwQueryOpenSubKeys',\
ZwQueryOpenSubKeysEx,'ZwQueryOpenSubKeysEx',\
ZwQueryPerformanceCounter,'ZwQueryPerformanceCounter',\
ZwQueryPortInformationProcess,'ZwQueryPortInformationProcess',\
ZwQueryQuotaInformationFile,'ZwQueryQuotaInformationFile',\
ZwQuerySection,'ZwQuerySection',\
ZwQuerySecurityAttributesToken,'ZwQuerySecurityAttributesToken',\
ZwQuerySecurityObject,'ZwQuerySecurityObject',\
ZwQuerySecurityPolicy,'ZwQuerySecurityPolicy',\
ZwQuerySemaphore,'ZwQuerySemaphore',\
ZwQuerySymbolicLinkObject,'ZwQuerySymbolicLinkObject',\
ZwQuerySystemEnvironmentValue,'ZwQuerySystemEnvironmentValue',\
ZwQuerySystemEnvironmentValueEx,'ZwQuerySystemEnvironmentValueEx',\
ZwQuerySystemInformation,'ZwQuerySystemInformation',\
ZwQuerySystemInformationEx,'ZwQuerySystemInformationEx',\
ZwQuerySystemTime,'ZwQuerySystemTime',\
ZwQueryTimer,'ZwQueryTimer',\
ZwQueryTimerResolution,'ZwQueryTimerResolution',\
ZwQueryValueKey,'ZwQueryValueKey',\
ZwQueryVirtualMemory,'ZwQueryVirtualMemory',\
ZwQueryVolumeInformationFile,'ZwQueryVolumeInformationFile',\
ZwQueryWnfStateData,'ZwQueryWnfStateData',\
ZwQueryWnfStateNameInformation,'ZwQueryWnfStateNameInformation',\
ZwQueueApcThread,'ZwQueueApcThread',\
ZwQueueApcThreadEx,'ZwQueueApcThreadEx',\
ZwRaiseException,'ZwRaiseException',\
ZwRaiseHardError,'ZwRaiseHardError',\
ZwReadFile,'ZwReadFile',\
ZwReadFileScatter,'ZwReadFileScatter',\
ZwReadOnlyEnlistment,'ZwReadOnlyEnlistment',\
ZwReadRequestData,'ZwReadRequestData',\
ZwReadVirtualMemory,'ZwReadVirtualMemory',\
ZwRecoverEnlistment,'ZwRecoverEnlistment',\
ZwRecoverResourceManager,'ZwRecoverResourceManager',\
ZwRecoverTransactionManager,'ZwRecoverTransactionManager',\
ZwRegisterProtocolAddressInformation,'ZwRegisterProtocolAddressInformation',\
ZwRegisterThreadTerminatePort,'ZwRegisterThreadTerminatePort',\
ZwReleaseKeyedEvent,'ZwReleaseKeyedEvent',\
ZwReleaseMutant,'ZwReleaseMutant',\
ZwReleaseSemaphore,'ZwReleaseSemaphore',\
ZwReleaseWorkerFactoryWorker,'ZwReleaseWorkerFactoryWorker',\
ZwRemoveIoCompletion,'ZwRemoveIoCompletion',\
ZwRemoveIoCompletionEx,'ZwRemoveIoCompletionEx',\
ZwRemoveProcessDebug,'ZwRemoveProcessDebug',\
ZwRenameKey,'ZwRenameKey',\
ZwRenameTransactionManager,'ZwRenameTransactionManager',\
ZwReplaceKey,'ZwReplaceKey',\
ZwReplacePartitionUnit,'ZwReplacePartitionUnit',\
ZwReplyPort,'ZwReplyPort',\
ZwReplyWaitReceivePort,'ZwReplyWaitReceivePort',\
ZwReplyWaitReceivePortEx,'ZwReplyWaitReceivePortEx',\
ZwReplyWaitReplyPort,'ZwReplyWaitReplyPort',\
ZwRequestPort,'ZwRequestPort',\
ZwRequestWaitReplyPort,'ZwRequestWaitReplyPort',\
ZwResetEvent,'ZwResetEvent',\
ZwResetWriteWatch,'ZwResetWriteWatch',\
ZwRestoreKey,'ZwRestoreKey',\
ZwResumeProcess,'ZwResumeProcess',\
ZwResumeThread,'ZwResumeThread',\
ZwRevertContainerImpersonation,'ZwRevertContainerImpersonation',\
ZwRollbackComplete,'ZwRollbackComplete',\
ZwRollbackEnlistment,'ZwRollbackEnlistment',\
ZwRollbackRegistryTransaction,'ZwRollbackRegistryTransaction',\
ZwRollbackTransaction,'ZwRollbackTransaction',\
ZwRollforwardTransactionManager,'ZwRollforwardTransactionManager',\
ZwSaveKey,'ZwSaveKey',\
ZwSaveKeyEx,'ZwSaveKeyEx',\
ZwSaveMergedKeys,'ZwSaveMergedKeys',\
ZwSecureConnectPort,'ZwSecureConnectPort',\
ZwSerializeBoot,'ZwSerializeBoot',\
ZwSetBootEntryOrder,'ZwSetBootEntryOrder',\
ZwSetBootOptions,'ZwSetBootOptions',\
ZwSetCachedSigningLevel,'ZwSetCachedSigningLevel',\
ZwSetCachedSigningLevel2,'ZwSetCachedSigningLevel2',\
ZwSetContextThread,'ZwSetContextThread',\
ZwSetDebugFilterState,'ZwSetDebugFilterState',\
ZwSetDefaultHardErrorPort,'ZwSetDefaultHardErrorPort',\
ZwSetDefaultLocale,'ZwSetDefaultLocale',\
ZwSetDefaultUILanguage,'ZwSetDefaultUILanguage',\
ZwSetDriverEntryOrder,'ZwSetDriverEntryOrder',\
ZwSetEaFile,'ZwSetEaFile',\
ZwSetEvent,'ZwSetEvent',\
ZwSetEventBoostPriority,'ZwSetEventBoostPriority',\
ZwSetHighEventPair,'ZwSetHighEventPair',\
ZwSetHighWaitLowEventPair,'ZwSetHighWaitLowEventPair',\
ZwSetInformationDebugObject,'ZwSetInformationDebugObject',\
ZwSetInformationEnlistment,'ZwSetInformationEnlistment',\
ZwSetInformationFile,'ZwSetInformationFile',\
ZwSetInformationJobObject,'ZwSetInformationJobObject',\
ZwSetInformationKey,'ZwSetInformationKey',\
ZwSetInformationObject,'ZwSetInformationObject',\
ZwSetInformationProcess,'ZwSetInformationProcess',\
ZwSetInformationResourceManager,'ZwSetInformationResourceManager',\
ZwSetInformationSymbolicLink,'ZwSetInformationSymbolicLink',\
ZwSetInformationThread,'ZwSetInformationThread',\
ZwSetInformationToken,'ZwSetInformationToken',\
ZwSetInformationTransaction,'ZwSetInformationTransaction',\
ZwSetInformationTransactionManager,'ZwSetInformationTransactionManager',\
ZwSetInformationVirtualMemory,'ZwSetInformationVirtualMemory',\
ZwSetInformationWorkerFactory,'ZwSetInformationWorkerFactory',\
ZwSetIntervalProfile,'ZwSetIntervalProfile',\
ZwSetIoCompletion,'ZwSetIoCompletion',\
ZwSetIoCompletionEx,'ZwSetIoCompletionEx',\
ZwSetIRTimer,'ZwSetIRTimer',\
ZwSetLdtEntries,'ZwSetLdtEntries',\
ZwSetLowEventPair,'ZwSetLowEventPair',\
ZwSetLowWaitHighEventPair,'ZwSetLowWaitHighEventPair',\
ZwSetQuotaInformationFile,'ZwSetQuotaInformationFile',\
ZwSetSecurityObject,'ZwSetSecurityObject',\
ZwSetSystemEnvironmentValue,'ZwSetSystemEnvironmentValue',\
ZwSetSystemEnvironmentValueEx,'ZwSetSystemEnvironmentValueEx',\
ZwSetSystemInformation,'ZwSetSystemInformation',\
ZwSetSystemPowerState,'ZwSetSystemPowerState',\
ZwSetSystemTime,'ZwSetSystemTime',\
ZwSetThreadExecutionState,'ZwSetThreadExecutionState',\
ZwSetTimer,'ZwSetTimer',\
ZwSetTimer2,'ZwSetTimer2',\
ZwSetTimerEx,'ZwSetTimerEx',\
ZwSetTimerResolution,'ZwSetTimerResolution',\
ZwSetUuidSeed,'ZwSetUuidSeed',\
ZwSetValueKey,'ZwSetValueKey',\
ZwSetVolumeInformationFile,'ZwSetVolumeInformationFile',\
ZwSetWnfProcessNotificationEvent,'ZwSetWnfProcessNotificationEvent',\
ZwShutdownSystem,'ZwShutdownSystem',\
ZwShutdownWorkerFactory,'ZwShutdownWorkerFactory',\
ZwSignalAndWaitForSingleObject,'ZwSignalAndWaitForSingleObject',\
ZwSinglePhaseReject,'ZwSinglePhaseReject',\
ZwStartProfile,'ZwStartProfile',\
ZwStopProfile,'ZwStopProfile',\
ZwSubscribeWnfStateChange,'ZwSubscribeWnfStateChange',\
ZwSuspendProcess,'ZwSuspendProcess',\
ZwSuspendThread,'ZwSuspendThread',\
ZwSystemDebugControl,'ZwSystemDebugControl',\
ZwTerminateEnclave,'ZwTerminateEnclave',\
ZwTerminateJobObject,'ZwTerminateJobObject',\
ZwTerminateProcess,'ZwTerminateProcess',\
ZwTerminateThread,'ZwTerminateThread',\
ZwTestAlert,'ZwTestAlert',\
ZwThawRegistry,'ZwThawRegistry',\
ZwThawTransactions,'ZwThawTransactions',\
ZwTraceControl,'ZwTraceControl',\
ZwTraceEvent,'ZwTraceEvent',\
ZwTranslateFilePath,'ZwTranslateFilePath',\
ZwUmsThreadYield,'ZwUmsThreadYield',\
ZwUnloadDriver,'ZwUnloadDriver',\
ZwUnloadKey,'ZwUnloadKey',\
ZwUnloadKey2,'ZwUnloadKey2',\
ZwUnloadKeyEx,'ZwUnloadKeyEx',\
ZwUnlockFile,'ZwUnlockFile',\
ZwUnlockVirtualMemory,'ZwUnlockVirtualMemory',\
ZwUnmapViewOfSection,'ZwUnmapViewOfSection',\
ZwUnmapViewOfSectionEx,'ZwUnmapViewOfSectionEx',\
ZwUnsubscribeWnfStateChange,'ZwUnsubscribeWnfStateChange',\
ZwUpdateWnfStateData,'ZwUpdateWnfStateData',\
ZwVdmControl,'ZwVdmControl',\
ZwWaitForAlertByThreadId,'ZwWaitForAlertByThreadId',\
ZwWaitForDebugEvent,'ZwWaitForDebugEvent',\
ZwWaitForKeyedEvent,'ZwWaitForKeyedEvent',\
ZwWaitForMultipleObjects,'ZwWaitForMultipleObjects',\
ZwWaitForMultipleObjects32,'ZwWaitForMultipleObjects32',\
ZwWaitForSingleObject,'ZwWaitForSingleObject',\
ZwWaitForWorkViaWorkerFactory,'ZwWaitForWorkViaWorkerFactory',\
ZwWaitHighEventPair,'ZwWaitHighEventPair',\
ZwWaitLowEventPair,'ZwWaitLowEventPair',\
ZwWorkerFactoryWorkerReady,'ZwWorkerFactoryWorkerReady',\
ZwWriteFile,'ZwWriteFile',\
ZwWriteFileGather,'ZwWriteFileGather',\
ZwWriteRequestData,'ZwWriteRequestData',\
ZwWriteVirtualMemory,'ZwWriteVirtualMemory',\
ZwYieldExecution,'ZwYieldExecution'

end if ;NTDLL_INC
